<?php

require_once (dirname(__FILE__).'/B.php');
require_once (dirname(__FILE__).'/../classes/DB.php');
require_once (dirname(__FILE__).'/../classes/Ini.php');
require_once (dirname(__FILE__).'/../classes/Record.php');

$armid=REQUEST('arm');
$mhrfrom=REQUEST('mhrfrom');
$mhrto=REQUEST('mhrto');
$shg=REQUEST('shg');


$b=new B($armid);

$dbbook = new DB($b->CurDb);
$ini = new Ini($b->Ini);
$dbntagekz = $ini->GetValue('MAIN', 'DBNTAGEKZ', '910');
$dbndelimbar = $ini->GetValue('MAIN', 'DBNDELIMBAR', 'H');
$dbndelimstore = $ini->GetValue('MAIN', 'DBNDELIMSTORE', 'D');

$msg='';
$suc=true;
$sha=explode("\n",$shg);
if (is_array($sha)) foreach($sha as $sh2)
{
 if (trim($sh2)!='')
 {
  $csuc=true;
  $sh1=trim($sh2);
  $res = $dbbook->FindRecords('("IN=' . $sh1. '")','', 2, 1);
  $er = $b->ParseError($res);
  if ($er != '')
  {
   $msg.=($sh1.': '.ER_ERROR.' '.$er.'<br>');
   $suc=false;
   $csuc=false;
  }
  if (($csuc)&&($res[0] < 1))
  {
   $msg.= (ER_ERROR . ': ' . ER_BOOKNOTFOUND . ' ' . $sh1 . '<br>');
   $suc=false;
   $csuc=false;
  }
  if (($csuc)&&($res[0] > 1))
  {
   $msg.=(ER_ERROR.': '. ER_BOOKSHKDUBLET . ' ' . $sh1 . '<br>');
   $suc=false;
   $csuc=false;
  }

  $brec = new Record(0);

  if ($csuc)
  {
   $brec->SetFromRecord($res[1]);

   $rc = $brec->GetContent();
   $rocc = 0;
   if (is_array($rc[$dbntagekz])) foreach ($rc[$dbntagekz] as $occ => $fld)
   {
    if ($brec->GetSubField($dbntagekz, $occ + 1, $dbndelimbar) == $sh1)
    {
     $rocc = $occ + 1;
    }
   }
   else
   {
    $msg.=(ER_ERROR . ': Internal Error B0002<br>');
    $suc=false;
    $csuc=false;
   }
  }
  if ($csuc)
  {
   if ($brec->GetSubField($b->dbntagekz, $rocc, $b->dbndelimstore)!=$mhrfrom)
   {
    $msg.=(ER_ERROR . ': '.sprintf(ARMB_ERCHANGEMHR,$brec->GetSubField($b->dbntagekz, $rocc, $b->dbndelimstore)).'<br>');
    $suc=false;
    $csuc=false;
   }
  }
  if ($csuc)
  {
   $brec->SetSubField($b->dbntagekz, $rocc, $b->dbndelimstore, $mhrto);
   $r1 = $dbbook->SaveAndUpdateRecord($brec);
   if ($r1 < 0)
   $msg.=(ER_ERROR . ': ' . $b->ParseError($r1) . '<br>');
   else
   $msg.=($sh1.': '.ARMB_DONE.'<br>');
  }
  $brec->Dispose($brec->GetId());
  $b->df($msg);
 }
}
echo "{success:true,Action:function(params){Ext.Msg.alert('','" . $msg . "');}}";

?>