<?php 
require_once (dirname(__FILE__)."/../classes/OM.php");
require_once (dirname(__FILE__)."/../cfg.php");
require_once (dirname(__FILE__)."/../classes/DP.php");
require_once (dirname(__FILE__)."/../classes/DB.php");
require_once (dirname(__FILE__)."/../classes/ARM.php");
require_once (dirname(__FILE__).'/../classes/Record.php');

class c extends ARM
{
    /* vars
    IsLogged
    DbList[]
    DP[]
    CurIni
    CurDb
    CurWs
    Ini
    CurPft
    CurRec
    */

    var $db;

    function c($id = 0)
    {
        parent::ARM($id, 'c');
    }

    function Show()
    {
        global $OPTIONS;
        $db=new DB($this->CurDb);
        $ini=new Ini($this->Ini);
?>
<html>
<head>
 <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
 <title>АРМ Каталогизатор</title>
 <link rel="shortcut icon" type="image/x-icon" href="../img/favicon.gif">
 <?php  $this->ShowIScripts(); ?>
 <link rel="stylesheet" type="text/css" href="../resources/css/ux-all.css" /> 
 <?php if ($this->debugmode) { ?>
  <script type="text/javascript" src="../JS/c.js"></script>
 <?php } else { ?>
  <script type="text/javascript" src="../JS/irbis-c-<?php echo $OPTIONS['ver'];?>.js"></script>
 <?php } ?>
 <script>
Ext.onReady(function()
{
//    Ext.state.Manager.setProvider(new Ext.state.CookieProvider());
 Ext.QuickTips.init();
 Ext.BLANK_IMAGE_URL = '../resources/images/default/s.gif';

 var viewport = new Irbis.C.ARM
 ({
   arm:<?php  echo $this->GetId(); ?>,
   irbDb:<?php  echo $this->CurDb; ?>,
   currecid:<?php  echo $this->CurRecId; ?>,
   colcfg:<?php  echo $db->GetIniValue('MAIN','COLCFG',"[{fmt:'brief',dataIndex:'brief',header:'Описание'}]"); ?>,
   orgsigla: "<?php echo $db->GetIniValue('MAIN','ORGSIGLA','');?>",
   ini:<?php echo $ini->GetAsJson();?>
 });

});
  </script>
 </head>
 <body>
  <iframe id="irbisWorkIFrame" name="irbisWorkIFrame" style="display: none"></iframe>
  <script type="text/javascript" src="../_old/examples.js"></script><!-- EXAMPLES -->
 </body>
</html>

 <?php 
    }

    function Login($ARM, $host, $port, $login, $pw)
    {
        $r=ARM::Login($ARM, $host, $port, $login, $pw);
        if ($r!=0) return $r;
        require_once (dirname(__FILE__).'/../classes/Ini.php');

        $ini = new Ini($this->Ini);
        $dbid = $this->GetDbIdByName($ini->GetValue('MAIN', 'DEFAULTDB','IBIS'));
        $db = new DB($this->CurDb);
        $db->Open($this->Ini);
        $this->CurDb=$db->GetId();
        $CurRec=new Record(0);
        $this->CurRecId=$CurRec->GetId();
    }
        function ManageAnswer($ar,$issilence)
        {
                $res='function(RdrPft,BookTable,bIn){';
                $res.=$ar['ACTIONSBEFORE'];
                if ($ar['REFRESHRDR']) 
                        $res.="RdrPft.load('../classes/json.php?action=FormatRec&arm=" .$this->GetId() . "&rec=" . $this->CurRdrRec . "&db=" . $this->DbRdr ."&pft=@RDR0W_HTML');";
                if ($ar['REFRESHBOOKLIST'])
                        $res.="BookTable.getStore().load();BookTable.doLayout();";
                if ($ar['ERRMSG']!="")
                {
                        if ((!$issilence)||(($issilence)&&(!$ar['ISOK'])))
                        {
                                $res.='Ext.Msg.show({';
                                if ($ar['TITLE']=='')
                                {
                                        if (!$ar['ISOK']) $res.='title:"' . ER_ERROR . '",';
                                        else $res.='title:"Информация",';
                                }
                                else $res.='title:"'.addslashes($ar['TITLE']).'",';
                                $res.='msg: "'.$ar['ERRMSG'].'",';
                                if ($ar['BTN']=='') $ar['BTN']='OK';
                                $res.='buttons: Ext.Msg.'.$ar['BTN'].',';
                                if ($ar['FN']!='') $res.='fn:'.$ar['FN'].',';
                                if ($ar['ICO']=='') {if ($ar['ISOK']) $ar['ICO']='INFO'; else $ar['ICO']='ERROR';}
                                $res.='icon: Ext.MessageBox.'.$ar['ICO'].',';
                                $res.='modal:true,minWidth:700});';
                        }       
                }
                elseif ($ar['ISWINDOW'])
                {
                        // show window, using TITLE, WINDOWITEMS
                        $res.="w=new Ext.Window({modal:true,layout:'fit',viewConfig:{forceFit:true},title: \"{$ar['TITLE']}\",width:700,height:510,items:[{$ar['WINDOWITEMS']}],maximizable:true});w.show();w.center();";
                }
                $res.=$ar['ACTIONSAFTER'];
                $res.='}';
                echo "{success: true, Action:" . $res . "}";
        }
}
;

switch (REQUEST('action')) {
    case 'Close':
        $c = new c(REQUEST('s'));
        $c->Close();
        break;
    case 'Debug':
        $c = new c(REQUEST('s'));
        $c->Debug();
        break;
    case 'Noop':
        $c = new c(REQUEST('arm'));
        $c->Noop();
        break;
}

?>
