Irbis.InType1=function(cfg)
{
 this.store = new Ext.data.JsonStore
 ({
   url: '../vidget/InType-1.php',
   remoteSort:true,
   root: 'RecList',
   baseParams: {limit:200,irbDb:cfg.irbDb,mnu:cfg.dopinf,sort:cfg['sort'],action:'GetMnu'},
   totalProperty:'totalCount',
   fields:['key','val']
 });

 if (cfg['sort']==1) this.store.setDefaultSort('key', 'asc');
 if (cfg['sort']==2) this.store.setDefaultSort('val', 'asc');

 this.fnDblClick=function(grid,rowIndex,e)
 {
 	sm=grid.getSelectionModel();
 	if (sm.getCount()==1)
  {
  		this.fireEvent('doSelect',
  		{
    		rec:sm.getSelected(),
			cfg:grid.initialcfg,
			newValue: sm.getSelected().get("key")
  		});
	}
 };
 
 this.btnOk=new Ext.Button
 ({
 	text:"Ок",
	minWidth:70,
	handler:function()
	{
		sm=this.grid.getSelectionModel();
		if (sm.getCount()==1)
		{
			this.fireEvent('doSelect',
  			{
    			rec:sm.getSelected(),
				cfg:this.grid.initialcfg,
				newValue: sm.getSelected().get("key")
  			});
		}
	},
	scope:this
 });
 
 this.btnCancel=new Ext.Button
 ({
 	text:"Отмена",
	minWidth:70,
	handler:function()
	{
		this.fireEvent('doCancel',{cfg:this.grid.initialcfg});
	},
	scope:this
 });
 
 this.keyField=new Ext.form.TextField({enableKeyEvents:true});
 this.keyField.on('keyup',function(fld,e){this.FlyToTerm(fld.getValue());},this,{buffer:250});

 this.FlyToTerm=function(term)
 {
  this.store.load({params:{val:term}});
 }

 this.grid = new Ext.grid.GridPanel
 ({
   store:this.store,
   height:500,
        // inline buttons
   buttons: [this.btnOk,this.keyField,this.btnCancel],
   buttonAlign:'center',

   viewConfig: 
   {
     forceFit: true, autoFill:true
   },
   sm: new Ext.grid.CheckboxSelectionModel({singleSelect:true,width:20}),
   columns:
   [
    {header: 'Ключ',width:20,dataIndex:'key',sortable: true},
    {header: 'Значение',dataIndex:'val',sortable: true}
   ],
   autoWidth:true,
   autoExpandColumn: 'key',
   listeners:
   {
    rowdblclick:this.fnDblClick,
    scope:this
   }
 });

 this.grid.initialcfg=cfg;
 
 tcfg=cfg;
 tcfg.items=[this.grid];
 tcfg.layout='fit';
 tcfg.bbar=new Ext.PagingToolbar
   ({
     store: this.store,
     pageSize: 200,
     displayInfo: true,
     autoWidth:true,
     emptyMsg: "Нет результатов поиска"
   });

 Irbis.InType1.superclass.constructor.call(this,tcfg);
 
 this.store.load();

};

Ext.extend(Irbis.InType1,Ext.Panel);