Irbis.RecPreselector=function(cfg)
{
 if ((cfg.allowEmptySearch!=true) && (typeof(cfg.params["mfn[]"])=="undefined") && (typeof(cfg.params.src)=="undefined") && (typeof(cfg.params.sequence)=="undefined"))
 {
  Ext.Msg.alert('Ошибка','Нет ни одной записи');
  return;
 }

 this.irbArm=cfg.irbArm;
 this.irbDb=cfg.irbDb;
 this.title=cfg.title;
 this.oscope=cfg.oscope;
 this.basket=cfg.basket;
 cfg.modal=true;
 cfg.width=500;
 cfg.layout='form';
 cfg.maximizable=false;


 this.bCancel=
 {
  text:'Отмена',
  handler:function()
  {
   this.close();
  },
  scope:this
 };
 
 this.formitems=[];

 var tf=typeof(cfg.params["mfn[]"]);
 this.noselected=(tf=="undefined");

 if (cfg.showSrcDocSelector) this.formitems.push(
 {
  xtype:'fieldset',
  columnWidth: 1,
  title: 'Исходные документы',
  collapsible: false,
  defaultType: 'textfield',
  defaults: {anchor: '90%'},
  layout: 'anchor',
  noselected:this.noselected,
  items:
  [
   new Ext.form.RadioGroup
   ({
     id: 'operator',
     xtype: 'radiogroup',
     fieldLabel: '',
     columns: 1,
     vertical: true,
     items: 
     [
      {boxLabel: 'Все', name: 'oper', inputValue: 'all',checked:this.noselected},
      {boxLabel: 'Отмеченные', name: 'oper', inputValue: 'selected', checked: (!this.noselected),disabled:this.noselected},
      {boxLabel: 'Кроме отмеченных', name: 'oper', inputValue: 'unselected',disabled:this.noselected}
     ]
   })
  ]
 });

 if (cfg.showTVP) this.formitems.push(new Irbis.MnuComboSelector
    ({
      arm:this.irbArm,
      irbDb:this.irbDb,
      irbMnuNameByIniSection:cfg.irbMnuNameByIniSection,//'MAIN',
      irbMnuNameByIniParam:cfg.irbMnuNameByIniParam,//'COPYMNU',
      name:'fstname',
      fieldLabel: 'ТВП',
      allowBlank: true,
      editable: false,
      anchor: '100%'
    })
 );
 if (cfg.showExpDbSelector) this.formitems.push(new Irbis.DbSelector
    ({
      arm:this.irbArm,
      xtype:'combo',
      name:'dbtoname',
      allowBlank: false,
      editable: false,
      fieldLabel: 'Выходная БД',
      anchor: '100%',
      listeners:
      { 
       select:function(combo,record,index)
       {
        //this.changeDb(record.get('irbDb'),record.get('options'));
       },
       scope:this
      }
    })
 );

 if (cfg.showContainerSelector) this.formitems.push(
 {
  xtype:'fieldset',
  columnWidth: 1,
  title: 'Формат записей',
  collapsible: false,
  defaultType: 'textfield',
  defaults: {anchor: '90%'},
  layout: 'anchor',
  items:
  [
   new Ext.form.RadioGroup
   ({
     id: 'reccontainer',
     xtype: 'radiogroup',
     fieldLabel: '',
     columns: 4,
     vertical: false,
     items: 
     [
      {boxLabel: 'Текстовый', name: 'container', inputValue: 'text', checked: true,listeners: {scope:this,check:function(cb,c){if (c) this.fs_codepage.enable();}}},
      {boxLabel: 'ISO 2709', name: 'container', inputValue: 'iso',listeners: {scope:this,check:function(cb,c){if (c) this.fs_codepage.enable();}}},
      {boxLabel: 'XML', name: 'container', inputValue: 'xml',listeners: {scope:this,check:function(cb,c){if (c) this.fs_codepage.disable();}}},
      {boxLabel: 'JSON', name: 'container', inputValue: 'json',listeners: {scope:this,check:function(cb,c){if (c) this.fs_codepage.disable();}}}
     ]
   })
  ]
 });

 if (cfg.showCodepageSelector)
 {
  this.bl_utf=new Ext.form.Radio({boxLabel: 'UTF-8', name: 'codepage', inputValue: 'utf-8', checked: true});
  this.bl_win=new Ext.form.Radio({boxLabel: 'Windows-1251', name: 'codepage', inputValue: 'windows-1251'});
  this.bl_dos=new Ext.form.Radio({boxLabel: 'CP 866 (DOS)', name: 'codepage', inputValue: 'cp866'});
  this.fs_codepage=new Ext.form.FieldSet
  ({
    xtype:'fieldset',
    columnWidth: 1,
    title: 'Кодировка',
    collapsible: false,
    defaultType: 'textfield',
    defaults: {anchor: '90%'},
    layout: 'anchor',
    items:
    [
     new Ext.form.RadioGroup
     ({
       id: 'reccodepage',
       xtype: 'radiogroup',
       fieldLabel: '',
       columns: 3,
       vertical: false,
       items: 
       [
        this.bl_utf,
        this.bl_win,
        this.bl_dos
       ]
     })
    ]
  });
  this.formitems.push(this.fs_codepage);
 }

 if (cfg.showFileUpload)
 {
  this.formitems.push
  (
   {
     xtype: 'fileuploadfield',
     anchor: '100%',
     id: 'form-file',
     emptyText: 'Выберите файл для загрузки',
     fieldLabel: 'Файл',
     name: 'filpath',
     buttonText: '',
     buttonCfg: {iconCls: 'irb-import'}
   }
  );
 }

 if (cfg.showGlobalCorrect)
 {
  this.formitems.push(new Irbis.MnuComboSelector
  ({
    arm:this.irbArm,
    irbDb:this.irbDb,
    irbMnuName:'glob.mnu',
    name:'globname',
    fieldLabel: 'Корректировка',
    allowBlank: false,
    editable: false,
    anchor: '100%',
    listeners:
    {
     'select':function(combo,rec,idx)
           {
            Ext.Ajax.request
            ({
              url: '../vidget/ButtonManagers_Config.php',
              params: 
              {
               arm:this.irbArm,
               irbDb:this.irbDb,
               type:'gbl',
               cls:rec.get('key')
              },
              success:function(response)
              {
               resp=Ext.decode(response.responseText); 
               resp.Action(this);
              },
              scope: this
            });
           },
     scope:this
    }
  })
 );
 }

 if (cfg.showSerialSearch)
 {
  this.formitems.push(new Irbis.MnuComboSelector
  ({
    arm:this.irbArm,
    irbDb:this.irbDb,
    irbMnuName:'serialsearch.mnu',
    name:'globname',
    fieldLabel: 'Вид поиска',
    allowBlank: false,
    editable: false,
    anchor: '100%',
    listeners:
    {
     'select':function(combo,rec,idx)
           {
            Ext.Ajax.request
            ({
              url: '../vidget/ButtonManagers_Config.php',
              params: 
              {
               arm:this.irbArm,
               irbDb:this.irbDb,
               type:'serialsearch',
               cls:rec.get('key')
              },
              success:function(response)
              {
               resp=Ext.decode(response.responseText); 
               resp.Action(this);
              },
              scope: this
            });
           },
     scope:this
    }
  })
 );
 }


 if (cfg.showStatForms)
 {
  this.stats={};


  this.formitems.push(new Irbis.MnuComboSelector
  ({
    arm:this.irbArm,
    irbDb:this.irbDb,
    irbMnuName:'stt128.mnu',
    name:'rowtype',
    fieldLabel: 'Тип строк',
    allowBlank: false,
    editable: false,
    anchor: '100%',
    listeners:
    {
     'select':function(combo,rec,idx)
     {
      this.statcolstore.load({params:{rowtype:rec.get('key')}});
      Ext.Ajax.request
      ({
        url: '../vidget/ButtonManagers_Config.php',
        params: 
        {
         arm:this.irbArm,
         irbDb:this.irbDb,
         type:'stt',
         cls:rec.get('key')
        },
        success:function(response)
        {
         resp=Ext.decode(response.responseText); 
         resp.Action(this);
        },
        scope: this
      });
     },
     scope:this
    }
  }));


  this.statcolstore=new Ext.data.JsonStore
  ({
     url: '../vidget/rlbStatFormsConfig.php',
     root: 'cols',
     fields: ['Name','Title','IsUse','agregate']
  });

  this.statcoltable=new Ext.grid.EditorGridPanel
  ({
    enableHdMenu:false,
    layout:'fit',
    clicksToEdit: 1,
    height:150,
    store:this.statcolstore,
    fieldLabel: 'Конфигурация столбцов',
    name:'colConfig',
    sm:new Ext.grid.RowSelectionModel({singleSelect:false}),
    viewConfig: { forceFit: true },
    colModel: new Ext.grid.ColumnModel
    ({
      defaults: {width: 120, sortable: false },
      columns:
      [
       {header: 'Использовать',width:30,dataIndex:'IsUse',xtype: 'checkcolumn'},
       {header: 'Столбцы',dataIndex:'Title',editor:new Ext.form.TextField({allowBlank: false})}
       /*{
        header: 'Функция',
        dataIndex:'agregate',
        editor:new Ext.form.ComboBox
        ({
          typeAhead: true, 
          triggerAction: 'all', 
          lazyRender:true, 
          mode: 'local', 
          store: new Ext.data.ArrayStore
          ({
            id: 0, 
            fields: ['myId', 'displayText'], 
            data: [['sum', 'Сумма'], ['count', 'Количество'], ['avg', 'Среднее'], ['min', 'Минимум'], ['max', 'Максимум'], ['concatenate', 'Конкатенация строк']] 
          }), 
          valueField: 'myId', 
          displayField: 'displayText'
        })
       }*/
      ]
    })
  });



  this.statcoltable.recWork=function(r) 
  {
   if (r.get('IsUse'))
   {
    this.statcolsvalue["colConfigName[]"].push(r.get('Name'));
    this.statcolsvalue["colConfigTitle[]"].push(r.get('Title'));
    this.statcolsvalue["colConfigAgregate[]"].push(r.get('agregate'));
   }
  }
  this.statcoltable.getValue=function() 
  {
   this.statcolsvalue={"colConfigName[]":[],"colConfigTitle[]":[],"colConfigAgregate[]":[]};
   var s=this.getStore(); 
   s.each(this.recWork,this);
   return this.statcolsvalue;
  };
  this.statcoltable.getName=function() {return this.name;};
  this.statcoltable.isValid=function(mark){return true;};
  this.statcoltable.validate=function() {return true;};

  this.formitems.push(this.statcoltable);
 }

 if (cfg.showGlobalCorrect || cfg.showStatForms || cfg.showSerialSearch)
 {
  this.addconfigitem=new Ext.form.FieldSet
  ({
    title: 'Параметры',
    collapsible: false,
    autoHeight:true,
    hidden:true,
    defaults: 
    {
     anchor: '-20' // leave room for error icon
    },
    items :[]
  });

  this.formitems.push(this.addconfigitem);
 }

 this.bCancel.scope=this;

 document.irbisuploadform=new Ext.FormPanel
 ({
   minButtonWidth:75,
   fileUpload:true,
   frame:true,
   defaults: 
   {
    anchor: '95%',
    allowBlank: true,
    msgTarget: 'side'
   },
   buttons:
   [
    {
     text:'Ok',
     hidden:(!cfg.showFileUpload),
     handler:function()
     {
      if(document.irbisuploadform.getForm().isValid())
      {
       document.irbisuploadform.getForm().submit
       ({
         url: document.irbisuploadform.url,
         waitMsg: 'Загрузка файла...',
         success: function(fp, o)
         {
          if (o.result.file=='')
          {
           Ext.Msg.alert('Ошибка', 'Ошибка загрузки файла на сервер');
           return;
          }
          else
          {
           var rs=document.irbisrecselector;
           rs.params.irbDb=rs.irbDb;
           rs.params.irbArm=rs.irbArm;
           Ext.apply(rs.params,document.irbisuploadform.getForm().getValues());
           rs.params.fpath=o.result.file;
           rs.oscope.LongRequest(rs.params,rs.url);
          }
          document.irbisrecselector.close();
         }
       });
      }
     }
    },
    {
     text:'Ok',
     hidden:cfg.showFileUpload,
     handler:function()
     {
      var rs=this;
      rs.params.irbDb=rs.irbDb;
      rs.params.irbArm=rs.irbArm;
      Ext.apply(rs.params,document.irbisuploadform.getForm().getValues());
      if (rs.showStatForms) Ext.apply(rs.params,rs.statcoltable.getValue());
      rs.oscope.LongRequest(rs.params,rs.url);
      rs.close();
     },
     scope:this
    },
    this.bCancel
   ],
   items:this.formitems
 });

 document.irbisrecselector=this;
 document.irbisuploadform.url=cfg.url;
 document.irbisuploadform.showFileUpload=cfg.showFileUpload;
 cfg.items=
 [
  document.irbisuploadform
 ];
 cfg.width=750;
 Irbis.RecPreselector.superclass.constructor.call(this,cfg);
}

Ext.extend(Irbis.RecPreselector,Ext.Window);