/*
params:
irbDb
irbTreName
*/

Irbis.TreComboSelector = Ext.extend(Ext.form.ComboBox, 
{
 editable:false,
 triggerClass : 'irb-trigger-f2',
 initList: function() 
 {
  this.list = new Ext.tree.TreePanel
  ({
    useArrows: true,
    autoScroll: true,
    animate: true,
    enableDD: false,
    containerScroll: true,
    border: false,
    rootVisible: false,
    root: 
    {
     nodeType: 'async',
     text: 'Ext JS',
     draggable: false,
     id: 'source'
    },
    loader:new Ext.tree.TreeLoader
    ({
      url: '../vidget/InType-6.php',
      baseParams: {irbDb:this.irbDb,tre:this.irbTreName,action:'GetTreeItems'}
    }),
    floating: true,
    autoHeight: true,
    listeners: 
    {
     click: this.onNodeClick,
     scope: this
    },
    setZIndex:function(){},
    alignTo: function(el, pos) { this.setPagePosition(this.el.getAlignToXY(el, pos)); }
  });
 },

 expand: function() 
 {
  if (!this.list.rendered) 
  {
   this.list.render(document.body);
   this.list.setWidth(this.el.getWidth());
   this.innerList = this.list.body;
   this.list.hide();
  }
//  this.el.focus();
  Irbis.TreComboSelector.superclass.expand.apply(this, arguments);
 },

 doQuery: function(q, forceAll) 
 {
  this.expand();
 },

 collapseIf : function(e)
 {
  if(!e.within(this.wrap) && !e.within(this.list.el))
  {
   this.collapse();
  }
 },

 onNodeClick: function(node, e) 
 {
  this.setRawValue(node.attributes.text);
  if (this.hiddenField) 
  {
   this.hiddenField.value = node.id;
  }
  this.collapse();
 }
});
Ext.reg('trecomboselector', Irbis.TreComboSelector);