Irbis.R={version:Irbis.version};

Irbis.R.ARM=function(cfg)
{
 //this is for debug only
 this.irbIsUserLogged=true;
 this.irbAllowBasket=true;
 this.irbIsAllowExport=true;
 //end debug block
 cfg=cfg||{};
 this.bArm=cfg.irbArm;

 this.bExportRecs=new Irbis.RecListPanel.RecExportButton({iconCls:'irb-export'});
 this.SearchPanel=new Irbis.SearchPanelMulty
 ({
   irbArm:cfg.irbArm,
   region:'north',
   title:'Поиск',
   split:true,
   collapsible:true,
   titleCollapse:true,
   height:400
 });
 this.RecList=new Irbis.RecListPanel
 ({
   title: 'Результаты поиска',
   iconCls:'irb-search',
   showTotalCount:true,
   //irbShowDbInfoOnFull:true,
   tbar:[this.bExportRecs,{iconCls:'irb-basket',text:'Добавить в корзину',handler:function(){this.Basket.addRecs(this.RecList.grid.getSelectionModel().getSelections())},scope:this},{iconCls:'irb-rqst',text:'Заказать'}]
 });
 this.bExportRecs.RecListPanel=this.RecList;
 this.bExportRecs.on('click',function(btn,e)
 {
   grid=btn.RecListPanel.grid;
   s=grid.getSelectionModel().getSelections();
   //Ext.Msg.alert('s.length',grid);
   /*shl='';
   for(var i = 0, len = s.length; i < len; i++)
   {
    var r = s[i];
    if (i>0) shl+='<br>';
    shl+=r.get('dbid')+'/'+r.get('mfn');
   }*/
   w=new Irbis.ExportWindow({irbSelections:s,width:400});
   w.show();
 }
);
 this.tabs=new Array();
 this.tabs[0]=this.RecList;
 
 if (this.irbAllowBasket)
 {
  this.Basket=new Irbis.RecBasket
  ({
    title: 'Корзина',
    iconCls:'irb-basket',
    showTotalCount:true,
    irbShowDbInfoOnFull:true,
    irbArm:this.bArm,
    tbar:[new Irbis.RecListPanel.RecExportButton({iconCls:'irb-export'})]
  });
  this.tabs[this.tabs.length]=this.Basket;
 };
 
 if (this.irbIsUserLogged)
 {
  this.BooksOnHands=new Irbis.RecListPanel
  ({
    title: 'Книги на руках',
    iconCls:'irb-booklist',
    showTotalCount:true,
    irbShowDbInfoOnFull:true
    //tbar:[this.bExportRecs]
  });
  this.tabs[this.tabs.length]=this.BooksOnHands;
 };
 this.tab=new Ext.TabPanel
 ({
   activeTab:0,
   region:'center',
   split:true,
  items:this.tabs
 });
 this.bLogout=new Ext.Button
 ({
   iconCls:'irb-logout',
   text:'<b>Выход</b>',
   tooltip:'Выход',
   arm:this.bArm,
   handler: function()
   {
    Ext.Ajax.request
    ({
      url: '../R2/Logout.php',
      failure: function(){Ext.Msg.alert("Ошибка","Ошибка связи!");},
      success: function(response)
      {
       resp=Ext.decode(response.responseText); 
       resp.Action();
      },
      params: { action: 'Logout',arm:this.bArm}
    });
   },
   scope:this
 });
 this.Pan=new Ext.Panel
 ({
   layout:'border',
   tbar:[{iconCls:'irb-key',text:'Вход'},{iconCls:'irb-chainik',text:'Поиск для чайников'},'->',this.bLogout],
   items:[this.SearchPanel,this.tab]
 });
 this.SearchPanel.on('onSearchSelected',function(opt)
 {
  this.RecList.ChangeDb(opt.irbDb);
  this.RecList.MakeSearch
  (
   opt.irbSearch,'',
   [{fmt:"&uf(\'6brief\')",dataIndex:'brief',header:'Описание'}]
  );
 },this);
 cfg.layout='fit';
 cfg.items=
 [
  this.Pan
 ];
 Irbis.R.ARM.superclass.constructor.call(this,cfg);
 var task = 
 {
  run: function()
  {
   Ext.Ajax.request
   ({
     url: '../r/r.php',
     params: { arm: cfg.irbArm, action:'Noop' }
   });
  },
  interval: 60000 //1 min
 };
 runner = new Ext.util.TaskRunner();
 runner.start(task);
}

Ext.extend(Irbis.R.ARM,Ext.Viewport);