<?php 

require_once(dirname(__FILE__).'/K.php');
require_once(dirname(__FILE__).'/../classes/ARM.php');
require_once(dirname(__FILE__).'/../classes/DB.php');
require_once(dirname(__FILE__).'/../classes/Record.php');
require_once(dirname(__FILE__).'/../classes/LongTask.php');

function ProcessRecListRequest($c)
{
 if (REQUEST('action')=='destroy')
 {
  $guid=REQUEST('guid');
  $task=new LongTask($guid);
  //$res=$task->GetData('result');
  $task->Destroy();
  return;
 }

 $cfg=GetRecListRequestCfg();
 $guid=REQUEST('guid');
 $res='';
 $totcount=count($cfg['mfns']);
 $cnt=0;
 set_time_limit(36000);
 $task=new LongTask($guid);
 $task->Start();
 $task->Update(0,$cnt.' записей из '.$totcount.' обработано');
 foreach($cfg['mfns'] as $m) 
 {
  $cnt++;
  $res=$c->Process($cfg,$m,$res);
  $task->Update($cnt/$totcount,$cnt.' записей из '.$totcount.' обработано');
 }

 $task->SetData('result',$res);
 $action=$c->GetAction($res);
 $task->Done($action);

}

function GetRecListRequestCfg()
{
 $res=array();
 $res['irbArm']=REQUEST('irbArm');
 $res['irbDb']=REQUEST('irbDb');
 $res['irbDbVuz']=REQUEST('irbDbVuz');
 $res['irbDbRdr']=REQUEST('irbDbRdr');
 $res['mfns']=REQUEST('mfns');
 $res['db']=new DB($res['irbDb']);
 $res['dbrdr']=new DB($res['irbDbRdr']);
 $res['dbvuz']=new DB($res['irbDbVuz']);
 $res['arm']=new K($res['irbArm']);
 return $res;
}

?>