<?php 
require_once(dirname(__FILE__) . "/OM.php");
require_once(dirname(__FILE__) . "/Record.php");

define('DPC_RECREAD',1);

class DP extends OM
{
// ProviderType
// Provider
// LastError
// IsConnected;

 var $dprv;

 function DP($id,$ProviderType='',$OwnerProvider=0)
 {
  $this->OM($id,'DP');
  if ($id<=0)
  { // create new
   $this->ProviderType=$ProviderType;
   $this->Provider=0;
   $this->OwnerProvider=$OwnerProvider;
  }
  if ($this->ProviderType=='') $this->ProviderType='DP_Irbis64';
  require_once(dirname(__FILE__) .'/'.$this->ProviderType.'.php');
  eval('require_once("'.addslashes(dirname(__FILE__)) . "/".$this->ProviderType.'.php");$this->dprv=new '.$this->ProviderType.'('.$this->Provider.');');
  $this->Provider=$this->dprv->GetId();
  if ($id<=0)
  {
   $this->dprv->SetOwnerProvider($this->OwnerProvider);
  }
 }

 function IsCapable($Origin,$Capables)
 {
  return ((((int)$Origin)&((int)$Capables))==((int)$Capables));
 }

 function Connect($params)
 {
  if ((isset($params['dbid']))&&($params['dbid']>0))
   $this->SetOwnerDb($params['dbid']);
  $res=$this->dprv->Connect($params);
  $this->IsConnected=$this->dprv->IsConnected;
  $this->Ini=$this->dprv->Ini;
  return $res;
 }

 function Disconnect()
 {
  return $this->dprv->Disconnect();
 }

 function GetFile($nApath,$sAdbn,$FileName)
 {
  return $this->dprv->GetFile($nApath,$sAdbn,$FileName);
 }

 function GetFormattedRecordsAfterSearch($DbName, $Expression, $Format, $NumRecords=0, $FirstRecord=0,$Min=0, $Max=0, $Sequence='')
 {
  return $this->dprv->GetFormattedRecordsAfterSearch($DbName, $Expression, $Format, $NumRecords=0, $FirstRecord=0,$Min=0, $Max=0, $Sequence='');
 }

 function GetMaxMfn($DbName)
 {
  return $this->dprv->GetMaxMfn($DbName);
 }

 function NoOperation()
 {
  return $this->dprv->NoOperation();
 }

 function RecIfUpdate($DbName, $mfn)
 {
  return $this->dprv->RecIfUpdate($DbName, $mfn);
 }

 function RecRead($DbName, $mfn, $bLock,Record $rec)
 {
  return $this->dprv->RecRead($DbName, $mfn, $bLock,$rec);
 }

 function RecReadAndFormat($DbName, $mfn, $bLock, $Format)
 {
  return $this->dprv->RecReadAndFormat($DbName, $mfn, $bLock, $Format);
 }

 function RecVirtualFormat($DbName, $Format, Record $VirtualRecord)
 {
  return $this->dprv->RecVirtualFormat($DbName, $Format, $VirtualRecord);
 }

 function RecWrite($DbName, $bLock, $bIfUpdate, Record $VirtualRecord)
 {
  return $this->dprv->RecWrite($DbName, $bLock, $bIfUpdate, $VirtualRecord);
 }

 function Search($DbName, $Expression, $Sequence, $Format, $NumMfn=0, $FirstMfn=0, $Min=0, $Max=0)
 {
  return $this->dprv->Search($DbName, $Expression, $Sequence, $Format, $NumMfn, $FirstMfn, $Min, $Max);
 }

 function RecSearch($DbName, $Expression, $Sequence, $NumMfn=0, $FirstMfn=0)
 {
  return $this->dprv->RecSearch($DbName, $Expression, $Sequence, $NumMfn, $FirstMfn);
 }


 function WriteToIni($IniText)
 {
  return $this->dprv->WriteToIni($IniText);
 }

 function GetTermList($DbName,$Pref,$StartTerm,$NumTerms,$isback=0,$format='')
 {
  return $this->dprv->GetTermList($DbName,$Pref,$StartTerm,$NumTerms,$isback,$format);
 }

 function Noop()
 {
  return $this->dprv->Noop();
 }
 
 function SetOwnerDb($id)
 {
  $this->odbi=$id;
 }

 function DeleteRec($DbName,$mfn)
 {
  return $this->dprv->DeleteRec($DbName,$mfn);
 }
}

?>