<?php 
require_once (dirname(__FILE__) . "/OM.php");
require_once (dirname(__FILE__) . "/Ini.php");
require_once (dirname(__FILE__) . '/DummyDP.php');

define('i64DBG', false);
//define ('i64DBG',true);

class DP_Irbis64 extends DummyDP
{
	// var opid; // Owner provider id
	// var $cmdno;
	// var $m_cARM;
	// var $sId;
	// var $address;
	// var $port;
	// var $login;
	// var $pw;
	// var IsConnected;

	function DP_Irbis64($id, $address = '127.0.0.1', $port = '6666', $login = '1', $pw =
		'1')
	{       
	        global $OPTIONS;
	        if ($address=='127.0.0.1') $address=$OPTIONS['i64MasterHost'];
                if ($port=='6666') $address=$OPTIONS['i64MasterPort'];
		$this->OM($id, 'DP_Irbis64');
		if ($id <= 0)
		{
			$this->address = $address;
			$this->port = $port;
			$this->login = $login;
			$this->pw = $pw;
			$this->cmdno = 0;
			$this->sId = 0;
			$this->IsConnected = false;
			$this->m_cARM = 'R';
			//$this->CrDbg=debug_backtrace();
		}
	}

	function SetOwnerProvider($id)
	{
		$this->opid = $id;
	}

	private function SendPacket($cmd, $packet,$dontSend=false)
	{
	  list($usec, $sec) = explode(" ",microtime()); $tb=((float)$usec + (float)$sec); 
		$socket = socket_create(AF_INET, SOCK_STREAM, 0);
		$addr=$this->address;
		$prt=$this->port;
		if ($socket < 0)
		{
			trigger_error("socket_create() failed: reason: ".socket_strerror($socket)."\n",E_USER_NOTICE);
			return;
		}
		$result = @socket_connect($socket, $addr, $prt);
		if ($result < 0)
		{
			trigger_error("socket_connect() failed.\nReason: ($result) ".socket_strerror($result)."\n",E_USER_NOTICE);
			return;
		}
		$out = '';
		$pp = sprintf("%d\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n\n\n\n", strlen($packet) + 14 +
			/*strlen($this->sId) + strlen($this->cmdno) +*/ strlen($this->login) + strlen($this->pw), $cmd,
			$this->m_cARM, $cmd, $this->sId, $this->cmdno, $this->pw, $this->login);
		$this->cmdno = $this->cmdno + 1;
		//session_write_close();
		$pp .= $packet;
//		trigger_error(var_export("\n=============SEND=============\n".$pp,true),E_USER_NOTICE);
		//  echo "<pre>===\n".$pp."\n===</pre>";
		if ($dontSend)
		{
		 $f=fopen('c:\p.txt','w');
		 fwrite($f,'='.$pp.'=');
		 fclose($f);
		 return -9999;
		}
		if (@socket_write($socket, $pp, strlen($pp))===FALSE)
		{
		 $sle=socket_last_error();
		 trigger_error('DP_Irbis64['.$this->GetId().']: socket_write() failed '.$sle.': '.socket_strerror($sle)."\nObject details:\n".$this->rDump(),E_USER_NOTICE);
		 //$f=fopen('c:\i64l','w');
		 //$dd='DP_Irbis64['.$this->GetId().']: backtrace: '.var_export(debug_backtrace(),true);
		 //fwrite($f,$dd,strlen($dd));
		 //fclose($f);
		 $ecnt=0;
		 $maxtry=5;
		 $sleeptime=2;
		 socket_close($socket);
		 $socket = socket_create(AF_INET, SOCK_STREAM, 0);
		 socket_connect($socket, $this->address, $this->port);
		 while (($ecnt<$maxtry)&&(@socket_write($socket, $pp, strlen($pp))===FALSE))
		 {
		  trigger_error('DP_Irbis64['.$this->GetId().']: socket_write() failed [TRY #'.$ecnt.']',E_USER_NOTICE);
		  $ecnt++;
		  sleep($sleeptime);
		  socket_close($socket);
 		  $socket = socket_create(AF_INET, SOCK_STREAM, 0);
		  socket_connect($socket, $this->address, $this->port);
		 }
		 if ($ecnt==$maxtry) return;
		}
		$res = '';
		while ($out = socket_read($socket, 2048))
		{
			$res .= $out;
		}
//		echo'<pre>';print_r($res);echo'</pre>';
//		trigger_error(var_export("\n=============RCV=============\n".$res,true),E_USER_NOTICE);
		$res = str_replace("\r", "", $res);
		if (i64DBG)
		{
			trigger_error('<table border=1><tr><td valign="top"><pre>'."1\n2\n3\n4\n5\n6\n7\n8\n9\n10".
				'</pre></td><td valign="top"><pre>'.$pp.'</pre></td><td valign="top"><pre>'.$res.
				'</pre></td></tr></table>',E_USER_NOTICE);
			$dbg[$this->cmdno]['rqst'] = $pp;
			$dbg[$this->cmdno]['answ'] = $res;
			//   $dbg[$this->cmdno]['trace']=debug_backtrace();
			$_SESSION['dpi64dbg'][] = $dbg;
		}
		$m = explode("\n", $res);
		socket_close($socket);
                list($usec, $sec) = explode(" ",microtime()); $te=((float)$usec + (float)$sec); 
                global $i64cmdcount;
                global $i64cmdtime;
                global $i64rqsts;
                $i64cmdcount++;
                $i64cmdtime+=($te-$tb);
                $i64rqsts[]=array('packet'=>$packet,'time'=>($te-$tb));
                if (is_array($m) && ($m[10]==-3335))
		{
		 if ($this->address!='' && $this->login!='' && $this->pw!='' && $this->sId!='')
		 {
  		  $this->cmdno = 1;
                  $r = $this->SendPacket('A', $this->login."\n".$this->pw);
                  trigger_error('DP_Irbis64: Restart session '.$this->sId,E_USER_NOTICE);
                  $res = array_slice($r, 10);
                  $Ini = new Ini($this->Ini);
                  $this->Ini = $Ini->GetId();
                  $Ini->Parse(array_slice($res, 2));
                  $er = $r[10];
                  if ($er != ER_OK) return $m;
                  return $this->SendPacket($cmd, $packet,$dontSend=false);
                 }
                }
		//session_start();
		return $m;
	}

	function Connect($params)
	{
	        global $OPTIONS;
		if ($this->IsConnected) $this->Disconnect();
		if ($params['dbid']>0) $this->SetOwnerDb($params['dbid']);
		if ($params['address']=='')
		 $this->address=$OPTIONS['i64MasterHost'];
		else
 		 $this->address=$params['address'];
		$this->port = $params['port'];
		$this->login = $params['login'];
		$this->pw = $params['pw'];
		$this->cmdno = 1;
		$sId = rand(1, 500000);
		$this->sId = $sId;
		$this->m_cARM = $params['ARM'];
		$r = $this->SendPacket('A', $this->login."\n".$this->pw);
		$res = array_slice($r, 10);
		//$res=$r;
		$er = $r[10];
		if ($er == ER_OK) $this->IsConnected = true;
		else  $this->IsConnected = $res;
		$Ini = new Ini(0);
		$Ini->InitSharedVar('Content','UI/'.$this->login.'/ARM_'.$this->m_cARM.'.ini');
		$Ini->Parse(array_slice($res, 2));
		$this->Ini = $Ini->GetId();
		return $er;
	}

	function Disconnect()
	{
		$r = $this->SendPacket('B', $this->login);
		if ($r[10] != 0) return $r[10];
		$this->IsConnected = false;
	}

	function GetFile($nApath, $sAdbn, $FileName)
	{
		$r = array();
		switch ($nApath)
		{
			case APATH_SYS:
			case APATH_DATAI:
				$r = $this->SendPacket('L', $nApath."..".$FileName);
				break;
			case APATH_MST:
			case APATH_IF:
			case APATH_DB:
				$r = $this->SendPacket('L', $nApath.'.'.$sAdbn.'.'.$FileName);
				/*$er=$this->Er;
				$er[]=$nApath.'.'.$sAdbn.'.'.$FileName;
				$this->Er=$er;*/
				break;
			default:
				return - 2222;
		}
		if ($r[10] < 0) return $r[10];
		$Result = $r[10];
		$Result = str_replace("\x1E", "\x0A", $Result);
		$Result = str_replace("\x1F", "\x0D", $Result);
		return $Result;
	}
	function GetFormattedRecordsAfterSearch($DbName, $Expression, $Format, $NumRecords =
		0, $FirstRecord = 0, $Min = 0, $Max = 0, $Sequence = '')
	{
		$e = $Expression;
		if ($e)
		{
			$e = str_replace("\x0A", "\x1E", $e);
			$e = str_replace("\x0D", "\x1F", $e);
		}
		$PacketData = '';
		if (!$Sequence) $PacketData = sprintf("%s\n%s\n%d\n%d\n%s", $DbName, $e, $NumMfn,
				$FirstMfn, $Format);
		else  $PacketData = sprintf("%s\n%s\n%d\n%d\n%s\n%d\n%d\n%s", $DbName, $e, $NumMfn,
				$FirstMfn, $Format, $Min, $Max, $Sequence);
		$r = $this->SendPacket('K', $PacketData);
		if ($r[10] < 0) return $r[10];
		return $r[11];
	}

	function GetMaxMfn($DbName)
	{
		$r = $this->SendPacket('O', $DbName);
		return $r[10] - 1;
	}

	function NoOperation()
	{
		$r = $this->SendPacket('N', $this->login);
		return $r[10];
	}

	function RecIfUpdate($DbName, $mfn)
	{
		// mfn==0,        
		$PacketData = sprintf("%s\n%d", $DbName, $mfn);
		//trigger_error('ifupdate: '.$PacketData,E_USER_NOTICE);
		$r = $this->SendPacket('F', $PacketData);
		return $r[10];
	}

	function RecRead($DbName, $mfn, $bLock,Record $rec)
	{
		$recs = array();
		$s = sprintf("%s\n%d\n%d", $DbName, $mfn, $bLock ? 1 : 0);
		$r = $this->SendPacket('C', $s);
		if ($r[10] != 0) return $r[10];
		$recs[] = $r[10];
		for ($i = 11; $i < count($r); $i++)
		{
			if (($r[$i]{0}== '0') && ($r[$i]{1}== '#'))
			 $r[$i] = substr($r[$i], 2);
			$recs[] = $r[$i];
			//trigger_error('DP_irbis64: '.$r[$i], E_USER_NOTICE);
		}
		$rec->ParseIrbisRec($recs);
		//trigger_error('DP_Irbis64 RecRead: '.var_export($rec->rDump(),true),E_USER_NOTICE);
		return 0;
	}

	function RecReadAndFormat($DbName, $mfn, $bLock, $Format)
	{
		$s = sprintf("%s\n%d\n%d\n%s", $DbName, $mfn, $bLock ? 1 : 0, $Format);
		$r = $this->SendPacket('C', $s);
		if ($r[10] != 0) return $r[10];
		$i = 0;
		for ($i = 11; (($r[$i] <> '#') && ($i < count($r))); $i++) ;
		$i += 2;
		//trigger_error('DP_Irbis64 RecReadAndFormat: '.($r[$i].$r[$i + 1]),E_USER_NOTICE);
		return $r[$i].$r[$i + 1];
	}

	function RecVirtualFormat($DbName, $Format, Record $VirtualRecord)
	{
		$v = $VirtualRecord->GetAsIrbRec();
//		$VirtualRecord->Dump();
//		echo'<pre>';print_r($v);echo'</pre>';
		$v = str_replace("\x0A", "\x1E", $v);
		$v = str_replace("\x0D", "\x1F", $v);
		$f = $Format;
		$f = str_replace("\x0A", "\x1E", $f);
		$f = str_replace("\x0D", "\x1F", $f);
		//echo '~'.$f.'~';
		$PacketData = sprintf("%s\n%s\n%d\n%s", $DbName, $f, -2, $v);
		$r = $this->SendPacket('G', $PacketData);
//		echo'<pre>';print_r($PacketData);echo'</pre>';
		//trigger_error('RVF: '.var_export($r,true),E_USER_NOTICE);
		if ($r[10] != 0) return $r[10];
		$res=$r[11];
		for ($i=12;$i<count($r);$i++)
 		 $res = $res."\n".$r[$i];
		$res = str_replace("\x1E", "\x0A", $res);
		$res = str_replace("\x1F", "\x0D", $res);
		
		//  print_r($r);
		return $res;
	}

	function RecWrite($DbName, $bLock, $bIfUpdate, Record $VirtualRecord)
	{ // return error (<0) or mfn
		$v = $VirtualRecord->GetAsIrbRec();
		$v = str_replace("\x0A", "\x1E", $v);
		$v = str_replace("\x0D", "\x1F", $v);
		$PacketData = sprintf("%s\n%d\n%d\n%s", $DbName, $bLock ? 1 : 0, $bIfUpdate ? 1 :
			0, $v);
		
		$r = $this->SendPacket('D', $PacketData);
		if (!is_array($r)) return $r;
		if ($r[10]<0) return $r[10];
		//print_r($r);
		//trigger_error('Write: "'.$PacketData.'"',E_USER_NOTICE);
		//trigger_error('Write RESULT: "'.var_export($r,true).'"',E_USER_NOTICE);
		$res = explode('#', $r[11]); //r[11]=mfn or errcode#...		
		//trigger_error('Write RESULT: "'.var_export($res,true).'"',E_USER_NOTICE);
		if ($res[0]>0)
		{
		 $VirtualRecord->SetVersion($VirtualRecord->GetVersion()+1);
		 $VirtualRecord->SetMfn($res[0]);
		}
		return $res[0];
	}

	/**
	 *   <0   
	 *  ,    -  ,
	 *  0 - -  
	 */
	function Search($DbName, $Expression, $Sequence, $Format, $NumMfn = 0, $FirstMfn =
		0, $Min = 0, $Max = 0)
	{
		$e = $Expression;
		if ($e)
		{
			$e = str_replace("\x0A", "\x1E", $e);
			$e = str_replace("\x0D", "\x1F", $e);
		}
		$f = str_replace("\x0A", "\x1E", $Format);
		$f = str_replace("\x0D", "\x1F", $f);
		$PacketData = '';
		if ($Sequence == '')
		{
			$PacketData = sprintf("%s\n%s\n%d\n%d\n%s", $DbName, $e, $NumMfn, $FirstMfn, $f);
		}
		else
		{
			$PacketData = sprintf("%s\n%s\n%d\n%d\n%s\n%d\n%d\n%s", $DbName, $e, $NumMfn, $FirstMfn,
				$Format, $Min, $Max, $Sequence);
		}
		$r = $this->SendPacket('K', $PacketData);
		if ($r[10] < 0) return $r[10];
		$res = array();
		for ($i = 11; $i < count($r); $i++)
		{
			$ss = $r[$i];
			if ($i != 11)
			{
				for ($j = 0; (($j < strlen($ss)) && ($ss[$j] != "#")); $j++) ;
				$ss = substr($ss, $j + 1);
			}
			$ss = str_replace("\x1E", "\x0A", $ss);
			$ss = str_replace("\x1F", "\x0D", $ss);
			if ($ss != '') $res[] = $ss;
		}
		return $res;
	}

       function RecSearch($DbName, $Expression, $Sequence, $NumMfn = 0, $FirstMfn = 0)
       {
    	$r = $this->Search($DbName,$Expression, $Sequence, "&uf('+0')", $NumMfn, $FirstMfn);
	if (!is_array($r)) return array(0=>$r);
	if ($r[0] < 1) return array(0=>$r[0]);
	$res = array(0=>0);
	foreach ($r as $key => $m)
	{
	 if ($key == 0) $res[0] = $m;
	 else
	 {
	  if ($m != '')
	  {
	   $rr = new Record(0);
	   $rr->ParseIrbisRec($m);
	   $res[] = $rr;
	  }
	 }
	}
	return $res;
       }

       function FullTextSearch($DbName,$FTExpression,$Expression,$Sequence,$FTSPrefix,$MaxWordDistance=-1,$Morphology=FALSE,$NumMfn=0,$FirstMfn=0,$Min=0,$Max=0)
       {
        $FTSRqst=$FTExpression."\x1F".$Expression."\x1F".($Morphology?"1":"")."\x1F".$FTSPrefix."\x1F".$MaxWordDistance."\x1F"."\x1F"."100";
        $PacketData=sprintf("%s\n\n%s\n%s\n%s\n%s\n%s\n%s\n%s",$DbName,$NumMfn,$FirstMfn,$Format,$Min,$Max,$Sequence,$FTSRqst);
        $r=$this->SendPacket('R',$PacketData);
        if ($r[10] < 0) return $r[10];
        $res=array();
        for ($i=11; $i<count($r); $i++)
        {
         $ss=$r[$i];
         if ($i!=11)
         {
          // razbor zapisey
         }
         if ($ss != '') $res[] = $ss;
        }
        return $res;
       }


	function WriteToIni($IniText)
	{
		$r = $this->SendPacket('8', $IniText);
		return $r[10];
	}

	function GetTermList($DbName, $Pref, $StartTerm, $NumTerms, $isback = 0, $format =
		'')
	{
		//echo('~~~~~'.$format);
		$PacketData = '';
		if ($format == '') $PacketData = sprintf("%s\n%s\n%d", $DbName, ($Pref.$StartTerm), $NumTerms);
		else  $PacketData = sprintf("%s\n%s\n%d\n%s\n", $DbName, ($Pref.$StartTerm), $NumTerms,	$format);

		$r = array();
		//trigger_error('DP_i64: TermList PacketData: '.var_export($PacketData,true), E_USER_NOTICE);
		if ($isback != 0) $r = $this->SendPacket('P', $PacketData);
		else  $r = $this->SendPacket('H', $PacketData);
		//trigger_error('DP_i64: TermList: '.var_export($r,true), E_USER_NOTICE);
		if ($r<0)
		{
		 trigger_error('DP_i64: Connect error: '.$r, E_USER_NOTICE);
		 return array('errorcode'=>$r);
		}
		//print_r($r);
		$res = array();
		$nb = 10;
		$ne = count($r) - 1;
		$nz = 1;
		if ($isback != 0)
		{
			$nb = count($r) - 1;
			$ne = 10;
			$nz = -1;
		}
		if (count($r)<10)
		{
		 $ne=$nb;
		 trigger_error('DP_i64: Connect error: '.var_export($r,true), E_USER_NOTICE);
		}

		for ($i = $nb; $i != $ne; $i += $nz)
		{
			$ss = $r[$i];
			$ss = str_replace("\x1E", "\x0A", $ss);
			$ss = str_replace("\x1F", "\x0D", $ss);
			$sr = array();
			if ($i != 10)
			{
				if ($format == '')
				{
					for ($j = 0; (($j < strlen($ss)) && ($ss[$j] != "#")); $j++) ;
					$sr['key'] = substr($ss, $j + 1);
					$sr['refs'] = substr($ss, 0, $j);
				}
				else
				{
					// parse extended answer
					//echo $ss.'---';
					for ($j = 0; (($j < strlen($ss)) && ($ss[$j] != "\x0A")); $j++) ;
					$n=substr($ss, $j + 1);
					$refinf=substr($ss, 0, $j);
					for ($j = 0; (($j < strlen($n)) && ($n[$j] != "\x0A")); $j++) ;
					$sr['format'] = substr($n, $j + 1);
					$sr['key']=substr($n, 0, $j);
					$ri=explode('#',$refinf);
					$sr['refs']=$ri[0];
					$sr['mfn']=$ri[1];
					$sr['tag']=$ri[2];
					$sr['occ']=$ri[3];
					$sr['cnt']=$ri[4];
				}
			}
			else
			{
				$res['errorcode'] = $ss;
			}
			if (($sr['key'] != '') && ($sr['refs'] > 0) && (@strpos($sr['key'], $Pref) !== false))
			{
				$sr['key'] = substr($sr['key'], strlen($Pref));
				$res[] = $sr;
			}
		}
		return $res;
	}

	function Noop()
	{
		$this->NoOperation();
	}
    function SetOwnerDb($id)
    {
     $this->odbi=$id;
    }

    function DeleteRec($DbName,$mfn)
    {
     $r=new Record(0);
     $res=$this->RecRead($DbName, $mfn, false,$r); if ($res!=0) {$r->Dispose($r->GetId()); return $res;}
     $r->SetStatus(1);
     $this->RecWrite($DbName, false, true, $r); if ($res!=0) {$r->Dispose($r->GetId()); return $res;}
     $r->Dispose($r->GetId());
     return $res;
    }

}
;

?>
