<?php 

require_once(dirname(__FILE__) . '/OM.php');
require_once(dirname(__FILE__) . '/Record.php');
require_once(dirname(__FILE__) . '/Ini.php');
require_once(dirname(__FILE__) . '/DummyDP.php');

define ('DPicorpDBG',0);



class DP_icorp extends DummyDP
{
//    var $host=http://librarynew.gpntb.ru/icorp/index.php;
//    var $port=80;
//    var $login=;
//    var $pw=;
//    var $proxy;
//    var $IsConnected;
//    var $cfg;
//    var $db;
//    var $odb; //owner db config
//    var $timeout;
//    var $dbcfg;
//    var $remotecp;
//    var $mode;
//    var $z21id;
//    var $termpreg;
//    var $termpregcolrefs;
//    var $termpregcolterms;
    
    function DP_icorp($id)
    {
     $this->OM($id,'DP_icorp');
     //       ( )
     if ($id<=0)
     {
      $this->host = 'http://librarynew.gpntb.ru/icorp/index.php';
      $this->port = 80;
      $this->login = '';
      $this->pw = '';
      $this->db='IBIS';
      $this->timeout=120;
      $this->IsConnected = false;
      $this->mode=1;
      $this->proxy='';
      $this->proxyUser='';
      $this->proxyPassword;
     }
    }
  
    function SetOwnerProvider($id)
    {
     $this->odpi=$id;
    }

    private function exception($errcode)
    {
      return $errcode;
    }

    function ExecRqst($params)
    {
     $ch = curl_init();

     $pf=http_build_query($params);

     if ($this->mode==1)
      curl_setopt($ch,CURLOPT_URL,$this->host); 
     else
      curl_setopt($ch,CURLOPT_URL,$this->host.'?'.$pf); 
     curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $this->timeout);
     if (($this->port!='')&&($this->port!=80))
      curl_setopt($ch,CURLOPT_PORT,$this->port);
     if ($this->mode==1)
      curl_setopt($ch, CURLOPT_POST, 1);
     curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
     curl_setopt($ch, CURLOPT_FAILONERROR, 1);
     curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
     //curl_setopt($ch, CURLOPT_HEADER, 0);
     if ($this->mode==1)
      curl_setopt($ch,CURLOPT_POSTFIELDS,$pf);
     if ($this->proxy!='')
     {
        curl_setopt($ch, CURLOPT_HTTPPROXYTUNNEL, TRUE);
        curl_setopt($ch, CURLOPT_PROXY, $this->proxy);
        if(($this->proxyUser!='')&&($this->proxyPassword!=''))
        {
            curl_setopt($ch,CURLOPT_PROXYAUTH,CURLAUTH_BASIC);
            curl_setopt($ch, CURLOPT_USERPWD, "{$this->proxyUser}:{$this->proxyPassword}");
         }
     }
     //trigger_error('Corp Url: '.var_export($params,true),E_USER_NOTICE);
     $res=curl_exec($ch);
     $er=curl_errno($ch);
     if ($er != 0)
     {
      trigger_error('DP_icorp: ('.$this->host.'): '.curl_error($ch)."\n".$pf, E_USER_NOTICE);
      trigger_error('DP_icorp: '.var_export($res,true), E_USER_NOTICE);
      curl_close($ch);
      return $er;
     }
     curl_close($ch);
//     trigger_error('Corp res: '.var_export($res,true),E_USER_NOTICE);
     return $res;
    }

 
    function Connect($params)
    {
     if ($this->IsConnected) return 0;
     $this->SetOwnerDb($params['dbid']);
     $odp=new DP($this->odpi);
      // read parameters
     $ini=$params['Ini'];
     $this->host = $ini->GetValue('PROVIDER','HOST','http://librarynew.gpntb.ru/icorp/index.php');
     $this->port = $ini->GetValue('PROVIDER','PORT',80);
     $this->login = $ini->GetValue('PROVIDER','LOGIN','');
     $this->pw = $ini->GetValue('PROVIDER','PW','');
     $this->db=$ini->GetValue('PROVIDER','DB','IBIS');
     $this->timeout=$ini->GetValue('PROVIDER','TIMEOUT',120);
     $this->IsConnected = false;
     $this->proxy=$ini->GetValue('PROVIDER','PROXY','');
     $this->proxyUser=$ini->GetValue('PROVIDER','PROXYUSER','');
     $this->proxyPassword=$ini->GetValue('PROVIDER','PROXYPASSWORD','');

     //   -   ,  ...

     $this->IsConnected=1;

     return 0;
    }

    function Disconnect($sysconn)
    {
     $this->IsConnected = false;
     return 0;
    }

    function GetFile($nApath,$Adbn,$FileName)
    {
     $odp=new DP($this->odpi);
     return $odp->GetFile($nApath,$Adbn,$FileName);
     //   64
    }

    function GetFormattedRecordsAfterSearch($DbName, $Expression, $Format, $NumRecords =
        0, $FirstRecord = 0, $Min = 0, $Max = 0, $Sequence = '')
    {
        return -9999;
    }

    function GetMaxMfn($DbName)
    {
        return -9999;
    }

    function NoOperation()
    {
        return 0;
    }

    function RecIfUpdate($DbName, $mfn)
    {
        return -9999;
    }

    function RecRead($DbName, $mfn, $bLock,Record $rec)
    {
     $p['task']='download_record';
     $p['rec_id']=$mfn;
     $p['FICTION_C21COM']='4';
     $p['EXP21MFN']=abs($mfn);
     trigger_error('before1',E_USER_NOTICE);
     $irec=$this->ExecRqst($p);
     trigger_error('before2',E_USER_NOTICE);
     $rec->SetFromMarc($irec,'utf-8');
     trigger_error($rec->rDump(),E_USER_NOTICE);
     $rec->SetMfn($mfn);
     return 0;
    }

    function RecReadAndFormat($DbName, $mfn, $bLock, $Format)
    {
     $r=new Record(0);
     $this->RecRead($DbName,$mfn,$bLock,$r->GetId());
     $rf=$this->RecVirtualFormat($DbName,$Format,$r);
     $r->Dispose($r->GetId());
     return $rf;
    }

    function RecVirtualFormat($DbName, $Format, Record $VirtualRecord)
    {
     $odp=new DP($this->odpi);
     return $odp->RecVirtualFormat($DbName, $Format, $VirtualRecord);
     //   64
    }

    function RecWrite($DbName, $bLock, $bIfUpdate, Record $VirtualRecord)
    {
        return -9999;
    }

    function Search($DbName, $Expression, $Sequence, $Format, $NumMfn = 0, $FirstMfn =
        0, $Min = 0, $Max = 0,$IsExt=false)
    {
     //trigger_error('Search started: '.$Expression,E_USER_NOTICE);
     require_once(dirname(__FILE__) . '/DoMultyThreadedCommands.php');
     $p['task']='search_broadcast';
     $Pref=substr($Expression,2,2);
     $StartTerm=substr($Expression,4,-2);
     switch($Pref)
     {
      case 'B=': $p['isbn']=str_replace('-','',$StartTerm); break;
      case 'A=': $p['author']=$StartTerm; break;
      case 'T=': $p['title']=$StartTerm; break;
      case 'G=': $p['year']=$StartTerm; break;
      default: return -9999;
     }
     $r1=$this->ExecRqst($p); // id  
     //trigger_error('r1: '.var_export($r1,true),E_USER_NOTICE);
     //renew_results("-499011563");   -499011563     
     $matches=array();
     $pattern="/renew_results(.*);/";
     preg_match ($pattern, $r1, $matches);
     $rid=trim($matches[1],"(\")");
     //  mfn
     $p=array();
     $p['task']='show_results';
     $p['req_id']=$rid;
     $r1=$this->ExecRqst($p); // id 
     //show_record('711841295')" -    
     //trigger_error('r1: '.var_export($r1,true),E_USER_NOTICE);
     $matches=array();
     $pattern="/show_record(.*)class/";
     preg_match_all($pattern, $r1, $matches);
     $r2=array();
     if ($Format=='')
      return array(0=>count($matches[1]));
     if (is_array($matches[1])) foreach($matches[1] as $k)
     {
      $r2[]=trim($k,"( '\")");
     }
     if (is_array($r2)) foreach ($r2 as $k)
     {
      //task=download_record&rec_id=-2136511515&FICTION_C21COM=4&EXP21MFN=2136511515
      $cmds[]='require_once(dirname(__FILE__) . \'/DP_icorp.php\');$dp=new DP_icorp('.$this->GetId().');$p[\'task\']=\'download_record\';$p[\'rec_id\']=\''.$k.'\';$p[\'FICTION_C21COM\']=\'4\';$p[\'EXP21MFN\']=\''.abs($k).'\';echo $dp->ExecRqst($p);';
     }
     $recs=DoMultyThreadedCommands($cmds,30);
     //trigger_error('recs: '.var_export($recs,true),E_USER_NOTICE);
     
     $res = array(0=>0);
     $ir=new Record(0);
     //trigger_error('Format: '.var_export($Format,true),E_USER_NOTICE);
     if (is_array($recs)) foreach ($recs as $i=>$rec)
     {
      $ir->SetFromMarc($rec,'utf-8');
      //trigger_error('rDump: '.var_export($ir->rDump(),true),E_USER_NOTICE);
      $ir->SetMfn(-1);
      $res[]=str_replace('000000~~~~~', $r2[$i].'~~~~~', $this->RecVirtualFormat($DbName,$Format,$ir));
      $res[0]++;
     }
     $ir->Dispose($ir->GetId());
//     trigger_error('res: '.var_export($res,true),E_USER_NOTICE);
     return $res;
    }

       function RecSearch($DbName, $Expression, $Sequence, $NumMfn = 0, $FirstMfn = 0)
       {
    	$r = $this->Search($DbName,$Expression, $Sequence, "&uf('+0')", $NumMfn, $FirstMfn);
	if (!is_array($r)) return array(0=>$r);
	if ($r[0] < 1) return array(0=>$r[0]);
	$res = array(0=>0);
	foreach ($r as $key => $m)
	{
	 if ($key == 0) $res[0] = $m;
	 else
	 {
	  if ($m != '')
	  {
	   $rr = new Record(0);
	   $rr->ParseIrbisRec($m);
	   $res[] = $rr;
	  }
	 }
	}
	return $res;
       }

    function WriteToIni($IniText)
    {
     $odp=new DP($this->odpi);
     return $odp->WriteToIni($IniText);
     //   64
    }

    function GetTermList($DbName, $Pref, $StartTerm, $NumTerms, $isback=0,$format = '')
    {
     if ($isback==1) return -9999;
     if ($NumTerms>10) $NumTerms=10;
     $p['task']='get_terms';
     switch($Pref)
     {
      case 'B=': $p['dic']='isbn'; $StartTerm=str_replace('-','',$StartTerm); break;
      case 'A=': $p['dic']='author'; break;
      case 'T=': $p['dic']='title'; break;
      case 'G=': $p['dic']='year'; break;
      default: return -9999;
     }
     $p['term']=$StartTerm;
     $jr=$this->ExecRqst($p);
     if ($jr<0) return $jr;
     $r=json_decode($jr,true);
     $res=array();
     if (is_array($r)) foreach($r as $k)
     {
      $nr['key']=$k;
      $nr['refs']=1;
      $res[]=$nr;
     }
     return $res;
    }

    function SetOwnerDb($id)
    {
     $this->odbi=$id;
    }

}
;
?>