<?php 

require_once(dirname(__FILE__).'/../cfg.php');

class LongTask
{

 var $LTP;
 var $LTWP;
 var $FileName;
 var $Progress;
 var $Done;
 var $Action;
 var $Text;

 function LongTask($guid='')
 {
  global $OPTIONS;
  $this->LTP=$OPTIONS['DataPath'].'/LongTasks';
  @mkdir($this->LTP,077,true);
  //$this->LTP=dirname(__FILE__).'/../LongTasks';
  $this->FileName=$guid;
  if ($guid=='') $this->FileName = strtoupper(md5(uniqid(rand(), true)));
  $this->Progress=0;
  $this->Done=0;
  $this->Action='';
  $this->Text='Запуск...';
  $this->Data=array();
  if (file_exists($this->LTP.'/'.$this->FileName.'.data'))
  {
   $fc=file_get_contents($this->LTP.'/'.$this->FileName.'.data');
   eval('$fc='.$fc.';');
   $this->Data=$fc;
  }
 }

 private function UpdateFile()
 {
  $f=fopen($this->LTP.'/'.$this->FileName.'.json','w');
  fwrite($f,"{progress:".$this->Progress.",text:\"".($this->Text==''?sprintf('%0.2f',$this->Progress).'% выполнено':$this->Text)."\",done:".$this->Done.",Action:function(a){".$this->Action."}}");
  fclose($f);
  $f=fopen($this->LTP.'/'.$this->FileName.'.data','w');
  fwrite($f,var_export($this->Data,true));
  fclose($f);
 }

 function Start($title='')
 {
  $this->Title=$title;
  $this->StartTime=time();
  $this->Progress=0;
  $this->Done=0;
  $this->Action='';
  $this->UpdateFile();
  $this->Data=array();
 }

 function Update($progress,$text='')
 {
  $this->Progress=$progress;
  $this->Text=$text;
  $this->UpdateFile();
 }

 function Done($action='')
 {
  $this->Done=true;
  $this->Action=$action;
  $this->UpdateFile();
 }

 function SetData($name,$data)
 {
  $this->Data[$name]=$data;
  $this->UpdateFile();
 }

 function GetData($name)
 {
  return $this->Data[$name];
 }

 function Destroy()
 {
  @unlink($this->LTP.'/'.$this->FileName.'.json');
  @unlink($this->LTP.'/'.$this->FileName.'.data');
 }
}

?>