<?php 

require_once(dirname(__FILE__) . "/OM.php");

class json
{
 var $limit;
 var $start;
 var $dir;
 var $sort;

 function json()
 {
  $this->limit=REQUEST('limit');
  $this->start=REQUEST('start');
  $this->dir=REQUEST('dir');
  $this->sort=REQUEST('sort');
  if ($this->start=='') $this->start=0;
 }

 function GetMnu()
 {
  require_once(dirname(__FILE__) . "/mnu.php");
  $dbid=REQUEST('db');
  $mnu=new mnu(0);
  $mnu->LoadMnu($dbid,REQUEST('mnu'));
  $res.=$mnu->GetAsJson($this->start,$this->limit);
  $mnu->Dispose($mnu->GetId());
  echo $res;
 }
 function GetWss()
 {
  $dbid=REQUEST('db');
  $val=REQUEST('val');
  $wssn=REQUEST('wss');
  require_once(dirname(__FILE__) . "/WSS.php");
  $wss=new WSS(0);
  $wss->LoadWSS($dbid,$wssn);
  $wss->SetField($val);
  echo $wss->GetAsJson();
  $wss->Dispose($wss->GetId());
 }

 function GetSearchList()
 {
  $dbid=REQUEST('db');
  require_once(dirname(__FILE__) . "/DB.php");
  require_once(dirname(__FILE__) . "/Ini.php");
  $db=new DB($dbid);
  $ini=new Ini($db->Ini);
  $ItemNumb=$ini->GetValue("SEARCH","ITEMNUMB");
  $res='{totalCount:'.$ItemNumb.', RecList: [';
  for ($i=0;$i<$ItemNumb;$i++)
  {
   if ($i>0) $res.=',';
   $res.='{Name:"'.iconv("windows-1251","utf-8",$ini->GetValue("SEARCH","ITEMNAME".$i));
   $res.='",Pref:"'.iconv("windows-1251","utf-8",$ini->GetValue("SEARCH","ITEMPREF".$i));
   $res.='",DictionType:"'.iconv("windows-1251","utf-8",$ini->GetValue("SEARCH","ITEMDICTIONTYPE".$i));
   $res.='",Logic:"'.iconv("windows-1251","utf-8",$ini->GetValue("SEARCH","ITEMLOGIC".$i));
   $res.='",Menu:"'.iconv("windows-1251","utf-8",$ini->GetValue("SEARCH","ITEMMENU".$i));
   $res.='",F8For:"'.iconv("windows-1251","utf-8",$ini->GetValue("SEARCH","ITEMF8FOR".$i));
   $res.='",ModByDic:"'.iconv("windows-1251","utf-8",$ini->GetValue("SEARCH","ITEMMODBYDIC".$i));
   $res.='",Tranc:"'.iconv("windows-1251","utf-8",$ini->GetValue("SEARCH","ITEMTRANC".$i));
   $res.='",Hint:"'.iconv("windows-1251","utf-8",$ini->GetValue("SEARCH","ITEMHINT".$i));
   $res.='",ModByDicAuto:"'.iconv("windows-1251","utf-8",$ini->GetValue("SEARCH","ITEMMODBYDICAUTO".$i));
   $res.='",Adv:"'.iconv("windows-1251","utf-8",$ini->GetValue("SEARCH","ITEMADV".$i)).'"}';
  }
  $res.=']}';
  echo $res;
 }

 function GetDictionItems()
 {
  $dbid=REQUEST('db');
  $start=REQUEST('start');
  $term=REQUEST('term');
  $isback=0;
  if (REQUEST('back')=='true') $isback=1;
  require_once(dirname(__FILE__) . "/DB.php");
  $db=new DB($dbid);
  $r=$db->GetTermList($start,$term,50,$isback);
  $cnt=0;
  $err=$r['errorcode'];
  unset ($r['errorcode']);

  if (is_array($r)) foreach ($r as $i)
  {
   if ($cnt>0) $res.=','; $cnt++;
     $res.='{key:"'.addslashes($i['key']).'",docs:'.addslashes($i['refs']).'}';
  }
  $res='{totalCount:'.$cnt.', RecList: ['.$res;
  $res.=']}';
  echo $res;
 }

 function GetDictionItemsWDesc()
 {
  $dbid=REQUEST('db');
  $start=REQUEST('start');
  $mnuname=REQUEST('mnu');
  $term=REQUEST('term');
  $isback=REQUEST('back');
  require_once(dirname(__FILE__) . "/DB.php");
  require_once(dirname(__FILE__) . "/mnu.php");
  $db=new DB($dbid);
  $mnu=new mnu(0);
  $mnu->LoadMnu($dbid,$mnuname);
  $r=$db->GetTermList($start,$term,50,$isback);
  $cnt=0;
  $err=$r['errorcode'];
  unset ($r['errorcode']);
  $c=$mnu->Content;
  $mnu->Dispose($mnu->GetId());
  if (is_array($c)) foreach($c as $key=>$val)
  {
   $c[strtoupper($key)]=$val;
  }
  if (is_array($r)) foreach ($r as $i)
  {
   if ($cnt>0) $res.=','; $cnt++;
     $res.='{key:"'.addslashes($i['key']).'",docs:'.addslashes($i['refs']).',desc:"'.addslashes($c[$i['key']]).'"}';
  }
  $res='{totalCount:'.$cnt.', RecList: ['.$res;
  $res.=']}';
  echo $res;
 }

 function GetDictionItemsT2()
 {
  echo "[{
    desc:'ColumnTree Example',
    docs:'3',
    uiProvider:'col',
    cls:'master-task',
    iconCls:'task-folder',
    children:[{
        desc:'Abstract rendering in TreeNodeUI',
        docs:'15',
        uiProvider:'col',
        leaf:true,
        iconCls:'task'
    },{
        desc:'Create TreeNodeUI with column knowledge',
        docs:'45',
        uiProvider:'col',
        leaf:true,
        iconCls:'task'
    },{
        desc:'Create TreePanel to render and lock headers',
        docs:'30',
        uiProvider:'col',
        leaf:true,
        iconCls:'task'
    },{
        desc:'Add CSS to make it look fly',
        docs:'30',
        uiProvider:'col',
        leaf:true,
        iconCls:'task'
    },{
        desc:'Test and make sure it works',
        docs:'1',
        uiProvider:'col',
        leaf:true,
        iconCls:'task'
    }]
},{
    desc:'Custom Field Example',
    docs:'25',
    uiProvider:'col',
    cls:'master-task',
    iconCls:'task-folder',
    children:[{
        desc:'Implement \"Live Search\" on extjs.com from Alex',
        docs:'10',
        uiProvider:'col',
        leaf:true,
        iconCls:'task'
    },{
        desc:'Extend TwinTrigger',
        docs:'5',
        uiProvider:'col',
        leaf:true,
        iconCls:'task'
    },{
        desc:'Testing and debugging',
        docs:'10',
        uiProvider:'col',
        leaf:true,
        iconCls:'task'
    }]
},{
    desc:'Foo Bar Item',
    docs:'30',
    uiProvider:'col',
    cls:'master-task',
    iconCls:'task-folder',
    children:[{
        desc:'Abstract rendering in TreeNodeUI',
        docs:'25',
        uiProvider:'col',
        leaf:true,
        iconCls:'task'
    },{
        desc:'Create TreeNodeUI with column knowledge',
        docs:'45',
        uiProvider:'col',
        leaf:true,
        iconCls:'task'
    },{
        desc:'Create TreePanel to render and lock headers',
        docs:'30',
        uiProvider:'col',
        leaf:true,
        iconCls:'task'
    },{
        desc:'Add CSS to make it look fly',
        docs:'30',
        uiProvider:'col',
        leaf:true,
        iconCls:'task'
    },{
        desc:'Test and make sure it works',
        docs:'10',
        uiProvider:'col',
        leaf:true,
        iconCls:'task'
    }]
},{
    desc:'WTF Item',
    docs:'3',
    uiProvider:'col',
    cls:'master-task',
    iconCls:'task-folder',
    children:[{
        desc:'Abstract rendering in TreeNodeUI',
        docs:'15',
        uiProvider:'col',
        leaf:true,
        iconCls:'task'
    },{
        desc:'Create TreeNodeUI with column knowledge',
        docs:'45',
        uiProvider:'col',
        leaf:true,
        iconCls:'task'
    },{
        desc:'Create TreePanel to render and lock headers',
        docs:'30',
        uiProvider:'col',
        leaf:true,
        iconCls:'task'
    },{
        desc:'Add CSS to make it look fly',
        docs:'30',
        uiProvider:'col',
        leaf:true,
        iconCls:'task'
    },{
        desc:'Test and make sure it works',
        docs:'60',
        uiProvider:'col',
        leaf:true,
        iconCls:'task'
    }]
}]";
 }
 function GetDbList()
 {
  require_once(dirname(__FILE__) . '/ARM.php');
  $s=new ARM(REQUEST('arm'));
  $res='';
  $cnt=0;
  $dbl=$s->DbList;
  if (is_array($dbl)) foreach($dbl as $cdb)
  {
   $db=new OM($cdb);
   if ($cnt>0) $res.= ',';
   $res.= '{Name: "'.$db->Name.'", Desc: "'.$db->Name.' - '.str_replace("\"","\\\"",$db->Description).'", irbDb:'.$db->GetId().'}';
   $cnt++;
  }
  $res='{totalCount:'.$cnt.', value:"IBIS",RecList: ['.$res;
  $res.=']}';
  echo $res;
 }

 function FormatRec()
 {
  if (REQUEST('rec')<1) die('');
  require_once(dirname(__FILE__) . '/DB.php');
  require_once(dirname(__FILE__) . '/Record.php');
  $db=new DB(REQUEST('db'));
  $pft=REQUEST('pft');
  $rec=new Record(REQUEST('rec'));
  echo $db->RecVirtualFormat($pft,$rec);
 }

 function DoSearch()
 {
  $dbid=REQUEST('db');
  $term=REQUEST('term');
  $pref=REQUEST('pref');
  require_once(dirname(__FILE__) . '/ARM.php');
  $db=new DB($dbid);
  $db->DoSearch($pref,$term);
//  echo $term;
  echo '{pref:"'.addslashes($pref).'",term:"'.addslashes($term).'"}';
 }
};

$jj=new json();

switch(REQUEST('action'))
{
 case 'GetMnu': $jj->GetMnu(); break;
 case 'GetWss': $jj->GetWss(); break;
 case 'GetSearchList': $jj->GetSearchList(); break;
 case 'GetDbList': $jj->GetDbList(); break;
 case 'GetDictionItems': $jj->GetDictionItems(); break;
 case 'GetDictionItemsWDesc': $jj->GetDictionItemsWDesc(); break;
 case 'GetDictionItemsT2': $jj->GetDictionItemsT2(); break;
 case 'FormatRec': $jj->FormatRec(); break;
 case 'DoSearch': $jj->DoSearch(); break;
};

?>