<?php 

require_once(dirname(__FILE__) . "/OM.php");
require_once(dirname(__FILE__) . "/DB.php");
require_once(dirname(__FILE__) . "/mnu.php");
require_once(dirname(__FILE__) . "/DoMultyThreadedCommands.php");

class Search extends OM
{
 // Pref
 // Term
 // ResCount
 // format
 

 function Search($id)
 {
  $this->OM($id,'Search');
 }

 function SetData($pref,$term,$resCount,$format="")
 {
  $this->Pref=$pref;
  $this->Term=$term;
  $this->ResCount=$resCount;
  $this->format=$format;
 }

 function Clear()
 {
  $this->SetData('','',0);
 }

 function GetSearchConfig($dbid)
 {
  if ($db->Ini<=0) return array();
  $ini=new Ini($db->Ini);
  $itemnumb=$ini->GetValue('SEARCH','ITEMNUMB',0);
  $res=array();
  for ($i=0;$i<$itemnumb;$i++)
  {
   $r=array();
   $r['name']=$ini->GetValue('SEARCH','ITEMNAME'.$i,'');
   $r['pref']=$ini->GetValue('SEARCH','ITEMPREF'.$i,'');
   $r['dictiontype']=$ini->GetValue('SEARCH','ITEMDICTIONTYPE'.$i,'');
   $r['logic']=$ini->GetValue('SEARCH','ITEMLOGIC'.$i,'');
   $r['menu']=$ini->GetValue('SEARCH','ITEMMENU'.$i,'');
   $r['f8for']=$ini->GetValue('SEARCH','ITEMF8FOR'.$i,'');
   $r['modbydic']=$ini->GetValue('SEARCH','ITEMMODBYDIC'.$i,'');
   $r['tranc']=$ini->GetValue('SEARCH','ITEMTRANC'.$i,'');
   $r['hint']=$ini->GetValue('SEARCH','ITEMHINT'.$i,'');
   $r['modbydicauto']=$ini->GetValue('SEARCH','ITEMMODBYDICAUTO'.$i,'');
   $r['adv']=$ini->GetValue('SEARCH','ITEMADV'.$i,'');
   $res[]=$r;
  }
  return $res;
 }

 function GetSearchMnuNameByPref($dbid,$pref)
 {
  if ($dbid<=0) return '';
  $srccfg=$this->GetSearchConfig($dbid);
  foreach($srccfg as $c) if ($c['pref']==$pref) return $c['menu'];
  return '';
 }

 function GetDictionItemsArray($dblist, $start='', $term='', $count=50, $isback=0, $mnunam='', $format='')
 {
   $trms = array();
   $cmds = array();
   if ($count == '') $count = 50;
   //print_r($dblist);
   foreach ($dblist as $dbid)
   {
     $mnuname=$mnunam; if ($mnunam=='') $mnuname=$this->GetSearchMnuNameByPref($dbid,$start);
     if ($dbid > 0)
     {
       $cc = 'require_once("'.
             str_replace('\\','/',dirname(__FILE__)).
             "/DB.php\");require_once(\"".
             str_replace('\\','/',dirname(__FILE__)).
             "/mnu.php\");\$db=new DB(".$dbid.");";
       if ($mnuname != '')
       {
         $cc .= "\$mnu=new mnu(0);\$mnu->LoadMnu($dbid,\"".addslashes($mnuname);
         $cc.="\");\$c=\$mnu->Content;\$mnu->Dispose(\$mnu->GetId());if (is_array(\$c)) foreach(\$c as \$key=>\$val){\$c[strtoupper(\$key)]=\$val;}";
       }
       $cc .= "\$r=\$db->GetTermList(\"".addslashes($start)."\",\"".addslashes($term)."\",$count,$isback,'";
       $cc .= $format."');\$err=\$r['errorcode']; unset (\$r['errorcode']);\$trms=array();if (is_array(\$r)) foreach (\$r as \$i) { \$trms[addslashes(\$i['key'])]['refs']+=\$i['refs'];";
       if ($mnuname != '')
       {
         $cc .= "\$trms[addslashes(\$i['key'])]['desc']=addslashes(\$c[\$i['key']]);";
       }
       else
       {
         $cc .= "\$trms[addslashes(\$i['key'])]['desc']=addslashes(\$i['key']);";
       }
       if ($format!='')
       {
         $cc .= "\$trms[addslashes(\$i['key'])]['mfn']=\$i['mfn'];";
         $cc .= "\$trms[addslashes(\$i['key'])]['tag']=\$i['tag'];";
         $cc .= "\$trms[addslashes(\$i['key'])]['occ']=\$i['occ'];";
         $cc .= "\$trms[addslashes(\$i['key'])]['cnt']=\$i['cnt'];";
         $cc .= "\$trms[addslashes(\$i['key'])]['format']=\$i['format'];";
       }
       if ($format=='*')
       {
         $cc .= "\$trms[addslashes(\$i['key'])]['format']=addslashes(\$i['key']);";
       }
       $cc .= "} echo (json_encode(\$trms));";
       $cmds[] = $cc;
     }
   }
   $hitses = DoMultyThreadedCommands($cmds, 30);
   //$hitses[0]='';
   //eval($cmds[0]);
   //print_r($hitses);
   //print_r($cmds);
   $id = 0;
   $cmds = array();
   foreach ($dblist as $dbid)
   {
     $db = new DB($dbid);
     $r = json_decode($hitses[$id]);
     //print_r($r);
     $id++;
     if (is_object($r)) foreach ($r as $key => $t)
     {
       $trms[$key]['refs'] += $t->refs;
       $trms[$key]['desc'] = $t->desc;
       if ($format!='')
       {
         $trms[$key]['mfn']=$t->mfn;
         $trms[$key]['tag']=$t->tag;
         $trms[$key]['occ']=$t->occ;
         $trms[$key]['cnt']=$t->cnt;
       }
       $trms[$key]['format']=$t->format;
     }
   }
   ksort($trms);
   $trms = array_slice($trms, 0, $count, true);
   return $trms;
 }

}