<?php

require_once (dirname(__FILE__).'/../classes/OM.php');
require_once (dirname(__FILE__).'/../classes/ARM.php');
require_once (dirname(__FILE__).'/../classes/Ini.php');

function vid_Editor_GetWs()
{
 require_once (dirname(__FILE__).'/../classes/DB.php');
 require_once (dirname(__FILE__).'/../classes/WS.php');

 $dbid=REQUEST('irbDb');
 $wsName=REQUEST('wsName');
 $rec=REQUEST('rec');
 
 $db=new DB($dbid);
 
 if ($wsName=='')
 {
  require_once (dirname(__FILE__).'/../classes/opt.php');
  $ini=new Ini($db->Ini);
  $optid=$db->WsOpt;
  $o=new opt($optid);
  if ($rec!='')
  {
   require_once (dirname(__FILE__).'/../classes/Record.php');
   $r=new Record(0);
   $r->ParseFromJson($rec);
   $wsName=$o->GetOptValue($r->GetField($ini->GetValue("MAIN","TAGVID",920),1));
   $s=$o->Content;
   $r->Dispose($r->GetId());
  }
  else
  {
   $wsName=$o->GetOptValue('');
  }
 }
 // ok. we have dbid and ws name...
 $ws=new WS(0);
 $ws->LoadWS($dbid,$wsName);
 $wc=$ws->Content;
 $ws->Dispose($ws->GetId());
 $wct=0;
 $res='';
 foreach($wc as $tabtitle=>$tabinfo)
 {
  if ($wct>0) $res.=','; $wct++;
  $res.='{title:"'.addslashes($tabtitle).'",data:[';
  $wcf=0;
  foreach($tabinfo as $fld=>$fi)
  {
   if (is_numeric($fld))
   {
    if ($wcf>0) $res.=','; $wcf++;
    $res.='{fieldno:"'.addslashes($fld).'",caption:"'.addslashes($fi['caption']).'",repeat:"'.addslashes($fi['repeat']).'",helpid:"'.addslashes($fi['helpid']).'",inmode:"'.addslashes($fi['inmode']).'",dopinf:"'.addslashes($fi['dopinf']).'",flk:"'.addslashes($fi['flk']).'",help:"'.addslashes($fi['help']).'",defaultv:"'.addslashes($fi['default']).'"}';
   }
  }
  $res.=']}';
 }
 
 echo '['.$res.']';


 /*echo "[{
        title: 'Tab 1',
        data:[
        {fieldno:'907',fname:'907'},
        {fieldno:'920',fname:'first2'},
        {fieldno:'922',fname:'922:first'}]
    },{
        title: 'Tab 2',
        data:[{fieldno:'920',fname:'first'}]
    },{
        title: 'Tab 3rd',
        data:[{fieldno:'903',fname:'first'}]
    }]";*/
}

function vid_Editor_GetRec()
{
 $dbid=REQUEST('irbDb');
 $mfn=REQUEST('mfn');
 $allowInline=true;
 require_once (dirname(__FILE__).'/../classes/Record.php');
 $db=new DB($dbid);
 $rec=new Record(0);
 if ($mfn!=-1)
 	$recid=$db->RecRead($mfn,false,$rec);
 else
 {
	require_once (dirname(__FILE__).'/../classes/opt.php');
 	require_once (dirname(__FILE__).'/../classes/WS.php');
 	require_once (dirname(__FILE__).'/../classes/Ini.php');
 	$rec=new Record(0);
 	$ini=new Ini($db->Ini);
 	$wsName=$ini->GetValue('MAIN','WSFDT','DEFAULT');
 	/*$optid=$db->WsOpt;
    $o=new opt($optid);
    $wsName=$o->GetOptValue('');*/
    $ws=new WS(0);
 	$ws->LoadWS($dbid,$wsName);
 	$ws->ApplyToRec($rec->GetId());
 	$ws->Dispose($ws->GetId());
 	$recid=$rec->GetId();
 }
 
 $ver=$rec->GetVersion();
 $rc=$rec->Content;
 $inlineSearches=array();
 $inlineSearch='';
 $isr=new Record(0);
 $armid=$db->GetArmId();
 $arm=new ARM($armid);
 if ($allowInline)
 {
  trigger_error(var_export($t1,true),E_USER_NOTICE);
  //$inlineSearches=explode("\n",$db->RecVirtualFormat('@i128_iscons',$rec));
  $inlineSearches[]='("B='.$rec->GetSubField(10,1,'A').'")';
  $isc=0;
  foreach ($inlineSearches as $src)
  {
   $inlineSearch.=trim($src,'*');
  }
  // now get list of databases for search
  $is_dblist[]=$arm->GetDbIdByName('OMSU');
//  $is_dblist[]=$arm->GetDbIdByName('IBIS');
  if ($inlineSearch!='')
  {
   $d1=new DB($is_dblist[0])
   $t1=$d1->FindRecords($src,'',1,1);
   trigger_error(var_export($t1,true),E_USER_NOTICE);
   if ($t1[0]>0) $isr=$t1[1];
//   $iscr=$arm->MultyDbSearch($is_dblist,$src,'','&uf(\'+0\')',1,1);
//   print_r ($iscr);
/*   if (is_array($iscr)&&($iscr[0]>0))
   {
    $isr->ParseIrbisRec($iscr[1]);
   }*/
  }
 }
 $rcis=$isr->Content;
 $isr->Dispose($isr->GetId());
 $cn=0;
 $res='';
 $cf=0;
 $trc=array();
 foreach ($rc as $field=>$occs)
 {
  if ((is_numeric($field))&&($cn>0))
  {
   foreach ($occs as $occ=>$val)
   {
    $trc[$field][$occ]['val']=$val;
   }
  }
  $cn++;
 }
 $cn=0;
 if (is_array($rcis)) foreach ($rcis as $field=>$occs)
 {
  if ((is_numeric($field))&&($cn>0))
  {
   foreach ($occs as $occ=>$val)
   {
    $trc[$field][$occ]['isr']=$val;
   }
  }
  $cn++;
 }
 $cn=0;
 foreach ($trc as $field=>$occs)
 {
  if ((is_numeric($field))&&($cn>0))
  {
   if ($cf>0) $res.=','; $cf++;
   $res.="'$field':{data:["; 
   $res1='';
   foreach ($occs as $occ=>$val)
   {
    if ($occ>0) {$res.=',';$res1.=',';}
    $res.='"'.addslashes($val['val']).'"';
    $res1.='"'.addslashes($val['isr']).'"';
   }
   $res.="],inlineS:[".$res1."]}";
  }
  $cn++;
 }
 $res1="{inlinesearch:\"".addslashes($inlineSearch)."\",record:{mfn:\"$mfn\",ver:\"$ver\",data:{".$res."}}}";
 echo $res1;
}

function vid_Editor_RecSave()
{
	//$t=json_decode(stripslashes(REQUEST('rec')),true);
	require_once (dirname(__FILE__).'/../classes/Record.php');
	require_once (dirname(__FILE__).'/../classes/DB.php');
	$r=new Record(0);
	$r->ParseFromEditorJson(stripslashes(REQUEST('rec')));
	//$r->SetMfn($t['mfn']);
	//$r->SetVersion($t['ver']);
	//$c=array
	//$r->Dump();
	$db=new DB(REQUEST('irbDb'));
	//$r->Dump();
	$res=$db->SaveAndUpdateRecord($r,true);
	if ($res>0)
		echo "{success:true,irbResult:$res,irbMessage:'Запись сохранена'}";
	else
		echo "{success:false,irbResult:$res,irbMessage:'Ошибка! Код возврата $res'}";
	$r->Dispose($r->GetId());	
	//print_r($t);
}

switch (REQUEST('act'))
{
 case 'GetWs': vid_Editor_GetWs(); break;
 case 'GetRec': vid_Editor_GetRec(); break;
 case 'SaveRec': vid_Editor_RecSave(); break;
}

?>