<?php

require_once (dirname(__FILE__).'/../classes/Record.php');

$irbDb=REQUEST('irbDb');
$irbRec=REQUEST('irbRec');
$cat=REQUEST('cat');
$wsname=REQUEST('wsname');
$wstab=REQUEST('wstab');
$fldno=REQUEST('fldno');
$occ=REQUEST('occ');
$occstart=REQUEST('occstart');
$occend=REQUEST('occend');
$armid=REQUEST('arm');
$cancelchanges=REQUEST('cancelchanges');


$r=new Record($irbRec);

if ($cancelchanges=='true')
{
 require_once (dirname(__FILE__).'/../classes/DB.php');
 $db=new DB($irbDb);
 $db->RecRead($r->GetMfn(),false,$r);
}

$rid=0;
if (file_exists('../classes/inlinecat.php'))
{
 require_once(dirname(__FILE__).'/../classes/inlinecat.php');
 require_once(dirname(__FILE__).'/../classes/ARM.php');

 $inlineid=$r->inline;
 $inline=new InlineCat($r->inline);
 $r->inline=$inline->GetId();
 $arm=new ARM($armid);
 $inline->Update($r,$arm->GetDbIdByName('IMPORT'));
 $rid=$inline->inlineRec;
}
$ri=new Record($rid);

function getJsonFieldInfo($r,$wstab,$fld,$occ)
{
 $wc=$r->EditorLoader_wc;
 $td=$wc[$wstab]['tabinfo'][$fld];
// print_r($td);
 $res='fldno:'.$fld.',occ:'.$occ.',repeat:'.($td['repeat']==''?0:$td['repeat']).',inmode:'.($td['inmode']==''?0:$td['inmode']).',dopinf:"'.addslashes($td['dopinf']).'"';
 if ($td['help']!='')
  $res.=',qtip:"'.addslashes($td['help']).'"';
 if ($fld==701)
  $res.=',inline:"test inline input"';

 return $res;
}

if ($cat=='root')
{
 require_once (dirname(__FILE__).'/../classes/DB.php');
 require_once (dirname(__FILE__).'/../classes/WS.php');

 $db=new DB($irbDb);

 //trigger_error('irbDb: '.$irbDb.', iniid: '.$db->Ini,E_USER_NOTICE);

 if ($wsname=='')
 {
  require_once (dirname(__FILE__).'/../classes/opt.php');
  $ini=new Ini($db->Ini);
  $optid=$db->WsOpt;  
  //trigger_error('optid: '.$optid,E_USER_NOTICE);
//  echo $optid;
  $o=new opt($optid);
  //$ttt='"'.$r->GetField($ini->GetValue("MAIN","TAGVID",920),1).'"';
  //trigger_error('920: '.$r->GetField($ini->GetValue("MAIN","TAGVID",920),1),E_USER_NOTICE);
  if ($r->GetField($ini->GetValue("MAIN","TAGVID",920),1)!='')
   $wsname=$o->GetOptValue($r->GetField($ini->GetValue("MAIN","TAGVID",920),1));
  else
  {
   $dws=new WS(0);
   $dws->LoadWS($irbDb,'default');
   $wsname=$o->GetOptValue($dws->GetFieldDefaultValue($ini->GetValue("MAIN","TAGVID",920)));
   $dws->Dispose($dws->GetId());
  }
  $s=$o->Content;
 }
 //trigger_error('wsname: '.$wsname,E_USER_NOTICE);
 // ok. we have dbid and ws name...
 $ws=new WS(0);
 $ws->LoadWS($irbDb,$wsname);
 //trigger_error('ws: '.$ws->rDump(),E_USER_NOTICE);
 //$ws->ApplyToRec($r->GetId());
 $wc=$ws->Content;
 
 $ws->Dispose($ws->GetId());
 $wct=0;
 $wc2=array();
 $res='[';
 foreach($wc as $tabtitle=>$tabinfo)
 {
  if ($wct>0) $res.=','; $wct++;
  $res.='{nodetype:"async",editable:false,text:"<b>'.addslashes($tabtitle).'</b>",cat:"rl",wstab:'.($wct-1).'}';
  $wc2[$wct-1]['tabtitle']=$tabtitle;
  $wc2[$wct-1]['tabinfo']=$tabinfo;
 }
 $res.=']';
 $r->EditorLoader_wc=$wc2;
 echo $res;
}
else if ($cat=='rl')
{
 $wc=$r->EditorLoader_wc;
 //print_r($wc);
 $td=$wc[$wstab]['tabinfo'];
 $res='[';
 $wct=0;
 foreach ($td as $fn=>$fd)
 {
   /*
            [caption] => 
            [repeat] => 0
            [helpid] => 0
            [inmode] => 5
            [dopinf] => 701.wss
            [flk] => 
            [help] => 
            [default] => 
   */
  if (($fn!='fldcount')&&($fn!='ee'))
  {
   $tAddNew='';
   $oc=max($r->GetFieldOcc($fn),$ri->GetFieldOcc($fn));
   $btext='<b>'; $etext='</b>';
   if ($oc<1) 
   {
    $btext=''; 
    $etext=' ';
    if ($fd['default']=='')
     $tAddNew='<i><font color=\"#0000FF\">(Добавить значение)</font></i>';
   }
   if ($fd['repeat']=='1')
   {
    if ($oc>50) // many-many occs
    {
     $oc1=1;
     if ($wct>0) $res.=','; $wct++;
     $res.='{nodetype:"async",fldno:'.$fn.',text:"'.$btext.addslashes($fd['caption']).$etext.' <font color=\"#888888\">(Повторений поля: '.$oc.')</font>",expanded:true,children:[';
     while ($oc1<=$oc)
     {
      if ($oc1>1) $res.=',';
      $res.='{nodetype:"async",cat:"fset",';
      $res.='occstart:'.$oc1.',occend:'.min(($oc1+49),$oc).',';
      $res.='wstab:'.$wstab.',';
      $res.=getJsonFieldInfo($r,$wstab,$fn,0).',';
      $res.='text:"<b>Повторения '.$oc1.' - '.min(($oc1+49),$oc).'</b>"';
      $res.='}';
      $oc1+=50;
     }
     $res.=']}';
    }
    else // less then 50 occs
    {
     if ($wct>0) $res.=','; $wct++;
     $res.='{nodetype:"async",';
     $res.=getJsonFieldInfo($r,$wstab,$fn,0);
     $res.=',wstab:'.$wstab;
     $res.=',editable:false';
     $res.=',nodetype:"async"';
     $res.=',cat:"fset"';
//     $res.=',inline:"'.addslashes($ri->GetField($fn,$)).'"';
     $res.=',text:"'.$btext.addslashes($fd['caption']).$etext.' <font color=\"#888888\">(Повторений поля: '.$r->GetFieldOcc($fn).')</font>';
     if ($ri->GetFieldOcc($fn)>$r->GetFieldOcc($fn))
      $res.='<font color=\"#999955\"><b> Найдено '.($ri->GetFieldOcc($fn) - $r->GetFieldOcc($fn)).' полей посредством inline-каталогизации</b></font>';
     $res.='"';
     $res.=',occstart:1,occend:'.$oc;
     $res.='}';
    }
   }
   else
   {
    if ($wct>0) $res.=','; $wct++;
    $res.='{nodetype:"async",';
    $res.=getJsonFieldInfo($r,$wstab,$fn,1).',';
    if ($fd['inmode']!='5')
     $res.='leaf:true,cat:"fld"';
    else
    {
     $res.='cat:"subfs"';
    }
    $res.=',value:"'.addslashes($r->GetField($fn,1)).'"';
    $res.=',text:"'.$btext.addslashes($fd['caption']).':'.$etext.' ';
    if (($ri->GetFieldOcc($fn,1)>0)&&($r->GetField($fn,1)==''))
     $res.='<font color=\"#999955\"><img src=\"../img/folder_go.png\" border=\"0\"/> <b>'.addslashes($ri->GetField($fn,1)).'</b></font>';
    else
    {
      $res.=$tAddNew;
    }
    //default values from ws
    if ($fd['default']!='')
    {
     $sfs=$r->ParseField($fd['default']);
     if (is_array($sfs)) foreach($sfs as $sfc=>$sfdata)
     {
      if ($r->GetSubField($fn,1,$sfc)=='')
      {
       $res.='<i><font color=\"#0000FF\">';
       if ($sfc!='*') $res.='^'.$sfc;
       $res.=addslashes($sfdata).'</font></i>';
      }
     }
    }
    //real value
    $res.=addslashes($r->GetField($fn,1)).'"';
    $res.=',caption:"'.addslashes($fd['caption']).'"';
    $res.=',inline:"'.addslashes($ri->GetField($fn,1)).'"';
    $res.=',wstab:'.$wstab;
    $res.='}';
   }
  }
 }
 $res.=']';
 echo $res;
}
else if ($cat=='fset')
{
 $tAddNew='<i><font color=\"#0000FF\">(Добавить значение)</font></i>';
 $res='[';
 $o=max($r->GetFieldOcc($fldno),$ri->GetFieldOcc($fldno));
 $wc=$r->EditorLoader_wc;
 $td=$wc[$wstab]['tabinfo'][$fldno];
 $tAddNew1='<i><font color=\"#0000FF\">(Добавить значение)</font></i>';
 //if ($td['default']!='') $tAddNew1='<i><font color=\"#0000FF\">'.$td['default'].'</font></i>';
 if ($occend==0) $occend=$o;
 for ($i=$occstart;$i<=min($occend,$o)+1;$i++)
 {
  if ($i>$occstart) $res.=',';
  $res.='{nodetype:"async",';
  $res.='wstab:'.$wstab.',';
  if ($td['inmode']!='5')
   $res.='leaf:true,cat:"fld"';
  else
  {
   $res.='cat:"subfs"';
  }
  $res.=','.getJsonFieldInfo($r,$wstab,$fldno,$i);
  //if ($i==(min($occend,$o)+1))
  //{
   $res.=',text:"<b>#'.$i.':</b> ';
   if (($i==1)&&($td['default']!=''))
   {
    $sfs=$r->ParseField($td['default']);
    if (is_array($sfs)) foreach($sfs as $sfc=>$sfdata)
    {
     if ($r->GetSubField($fldno,1,$sfc)=='')
     {
      $res.='<i><font color=\"#0000FF\">';
      if ($sfc!='*') $res.='^'.$sfc;
      $res.=addslashes($sfdata).'</font></i>';
     }
    }
   }
   else
   {
    if (($r->GetFieldOcc($fldno)<$i)&&($r->GetField($fldno,$i)==''))
    {
     if (($ri->GetFieldOcc($fldno)<$i)&&($ri->GetField($fldno,$i)==''))
     {
      if ($i==1) $res.=$tAddNew1; else $res.=$tAddNew;
     }
     else
      $res.='<font color=\"#999955\"><img src=\"../img/folder_go.png\" border=\"0\"/> <b>'.addslashes($ri->GetField($fldno,$i)).'</b></font>';
    }
   }
   $res.=addslashes($r->GetField($fldno,$i));
   $res.='"';
  //}
  //else
  // $res.='text:"<b>#'.$i.':</b> '.$r->GetField($fldno,$i).'",';
  $res.=',value:"'.addslashes($r->GetField($fldno,$i)).'"';
  $res.=',inline:"'.addslashes($ri->GetField($fldno,$i)).'"';
  $res.='}';
 }
 $res.=']';
 echo $res;
}
else if ($cat=='subfs')
{
 //$r->Dump();
 $res='[';
 $dopinf=REQUEST('dopinf');
 require_once(dirname(__FILE__).'/../classes/WSS.php');
 $wss=new WSS(0);
 $wss->LoadWSS($irbDb,$dopinf);
 $cn=$wss->Content;
 $wct=0;
 if ($occ==0) $occ=1;
 if (is_array($cn)) foreach($cn as $s=>$d)
 {
 // print_r($d);
  if ($wct>0) $res.=','; $wct++;
  $fnbs='';
  $fnbe=' <font color=\"#0000FF\"><i>(Добавить значение)</i></font>';
  $wc=$r->EditorLoader_wc;
  $td=$wc[$wstab]['tabinfo'][$fldno];
  if (($occ==1)&&($td['default']!=''))
  {
   $fa=Record::ParseField($td['default']);
   if ($fa[$s]!='')
    $fnbe=' <font color=\"#0000FF\"><i>'.addslashes($fa[$s]).'</i></font>';
  }
  if ($ri->GetSubField($fldno,$occ,$s)!='')
  {
   $fnbe=' <font color=\"#999955\"><img src=\"../img/folder_go.png\" border=\"0\"/> <b>'.addslashes($ri->GetSubField($fldno,$occ,$s)).'</b></font>';
  }
  if ($r->GetSubField($fldno,$occ,$s)!='') 
  {
   $fnbs='<b>';
   $fnbe='</b>';
  }
  $res.='{nodetype:"async",leaf:true,';
  $res.='cat:"subf",value:"'.addslashes($r->GetSubField($fldno,$occ,$s)).'",caption:"'.addslashes($d['Desc']).'",fldno:'.$fldno.',occ:'.$occ.',subf:"'.addslashes($s).'"';
  $res.=',text:"'.$fnbs.addslashes($d['Desc']).': '.$fnbe.addslashes($r->GetSubField($fldno,$occ,$s)).'",qtip:"'.addslashes($d['Help']).'",inmode:'.$d['InMode'].',dopinf:"'.addslashes($d['DopInf']).'"';
  if ($ri->GetField($fldno,$occ)!='')
   $res.=',inline:"'.addslashes($ri->GetSubField($fldno,$occ,$s)).'"';
  $res.='}';
 }
 $res.=']';
 echo $res;
}
else if ($cat=='updaterec')
{
 $subf=REQUEST('subf');
 $value=stripslashes($_REQUEST['value']);
 if ($occ>$r->GetFieldOcc($fldno))
  $r->SetField($fldno,$occ,'');
 if ($subf!='')
 {
  if ($value!='')
   $r->SetSubField($fldno,$occ,$subf,$value);
  else
   $r->RemoveSubField($fldno,$occ,$subf);
 }
 else
 {
  if ($value!='')
   $r->SetField($fldno,$occ,$value);
  else
   $r->FieldDelete($fldno,$occ);
 }
 echo '{}';
}

else if ($cat=='saverec')
{
 require_once(dirname(__FILE__).'/../classes/DB.php');
 $db=new DB($irbDb);
 $arm=new ARM($db->GetArmId());

 $res=$db->SaveAndUpdateRecord($r);
 $err=$arm->ParseError($res);
 echo $err;
 //$r->Dump();
}

else if ($cat=='applyallinline')
{
 require_once(dirname(__FILE__).'/../classes/DB.php');
 $db=new DB($irbDb);
 $c=$r->GetContentA();
 $ci=$ri->GetContentA();
 foreach ($ci as $fld=>$occinf)
 {
  if (!isset($c[$fld])) $c[$fld]=$ci[$fld];
  else
  {
   foreach ($occinf as $occ=>$fldinfo)
   {
    //if ($fld==700) {echo "$occ\n";}
    if(!isset($c[$fld][$occ])) $c[$fld][$occ]=$ci[$fld][$occ];
    else
    {
     $applysf=true;
     $mfld=$c[$fld][$occ];
     foreach($fldinfo as $sfld=>$data)
     {
      if ($mfld[$sfld]=='') $mfld[$sfld]=$data;
      if ( ($data!='') && ($mfld[$sfld]!=$data)) { $applysf=false;}
     }
     if ($applysf) $c[$fld][$occ]=$mfld;
    }
   }
  }
 }
 $r->SetContentA($c);
}

else if ($cat=='newrec')
{
 $r->Clear();
}

else if ($cat=='newrecfromcur')
{
 $r->SetMfn(-1);
}

?>