<?php
require_once (dirname(__FILE__)."/../classes/OM.php");
require_once (dirname(__FILE__)."/../classes/DB.php");
require_once (dirname(__FILE__)."/../classes/Ini.php");
require_once (dirname(__FILE__)."/../classes/mnu.php");
require_once (dirname(__FILE__).'/../classes/DoMultyThreadedCommands.php');

function widSearchPanel_GetSearchList()
{
	$dbid = json_decode(stripslashes(REQUEST('irbDb')));
	if ($dbid <= 0) die('{totalCount:0, RecList:[]}');
	$dblist = array();
	if (is_array($dbid)) $dblist = $dbid;
	else  $dblist[] = $dbid;
	$tin = 0;
	$srcs = array();
	foreach ($dblist as $dbid)
	{
		$db = new DB($dbid);
		$ini = new Ini($db->Ini);
		$ItemNumb = $ini->GetValue("SEARCH", "ITEMNUMB");

		for ($i = 0; $i < $ItemNumb; $i++)
		{
			$s = array();

			//if ($i>0) $res.=',';
			$s['Name'] = addslashes(iconv("windows-1251", "utf-8", $ini->GetValue("SEARCH",
				"ITEMNAME".$i)));
			$s['Pref'] = addslashes(iconv("windows-1251", "utf-8", $ini->GetValue("SEARCH",
				"ITEMPREF".$i)));
			$s['DictionType'] = addslashes(iconv("windows-1251", "utf-8", $ini->GetValue("SEARCH",
				"ITEMDICTIONTYPE".$i)));
			$s['Logic'] = addslashes(iconv("windows-1251", "utf-8", $ini->GetValue("SEARCH",
				"ITEMLOGIC".$i)));
			$s['Menu'] = addslashes(iconv("windows-1251", "utf-8", $ini->GetValue("SEARCH",
				"ITEMMENU".$i)));
			$s['F8For'] = addslashes(iconv("windows-1251", "utf-8", $ini->GetValue("SEARCH",
				"ITEMF8FOR".$i)));
			$s['ModByDic'] = addslashes(iconv("windows-1251", "utf-8", $ini->GetValue("SEARCH",
				"ITEMMODBYDIC".$i)));
			$s['Tranc'] = addslashes(iconv("windows-1251", "utf-8", $ini->GetValue("SEARCH",
				"ITEMTRANC".$i)));
			$s['Hint'] = addslashes(iconv("windows-1251", "utf-8", $ini->GetValue("SEARCH",
				"ITEMHINT".$i)));
			$s['ModByDicAuto'] = addslashes(iconv("windows-1251", "utf-8", $ini->GetValue("SEARCH",
				"ITEMMODBYDICAUTO".$i)));
			$s['Adv'] = addslashes(iconv("windows-1251", "utf-8", $ini->GetValue("SEARCH",
				"ITEMADV".$i)));
			if ($srcs[$s['Pref']]['Pref'] == '')
			{
				$tin++;
				$srcs[$s['Pref']] = $s;
			}
		}
	}
	$res = '{totalCount:'.$tin.', RecList: [';
	$i = 0;
	foreach ($srcs as $s)
	{
		if ($i > 0) $res .= ',';
		$i++;
		$res .= '{Name: "'.$s['Name'].'",Pref:"'.$s['Pref'].'",DictionType:"'.$s['DictionType'].
			'",Logic:"'.$s['Logic'].'",Menu:"'.$s['Menu'].'",F8For:"'.$s['F8For'].
			'",ModByDic:"'.$s['ModByDic'].'",
  Tranc:"'.$s['Tranc'].'",Hint:"'.$s['Hint'].'",ModByDicAuto:"'.$s['ModByDicAuto'].
			'",Adv:"'.$s['Adv'].'"}';
	}
	$res .= ']}';

	echo $res;
}
;

function widSearchPanel_GetDictionItemsArray($count = 50)
{
 require_once(dirname(__FILE__)."/../classes/DB.php");
 require_once(dirname(__FILE__)."/../classes/mnu.php");
 $dbid = json_decode(stripslashes(REQUEST('irbDb')));
 $start = REQUEST('start');
 $term = REQUEST('term');
 $mnuname = REQUEST('mnu');
 $format = REQUEST('format');
 //if ($format=='*') $format='';
 //echo('~'.$format);
 //print_r($_REQUEST);
 $isback = 0;
 if (REQUEST('back') == 'true') $isback = 1;
 $dblist = array();
 if (is_array($dbid)) $dblist = $dbid;
 else  $dblist[] = $dbid;
 $trms = array();
 $cmds = array();
 if ($count == '') $count = 50;
 $trms=array();
 foreach ($dblist as $dbid)
 {
  if ($dbid > 0)
  {
   $db=new DB($dbid);
   if ($mnuname != '')
   {
    $mnu=new mnu(0);
    $mnu->LoadMnu($dbid,$mnuname);
    $c=$mnu->Content;
    $mnu->Dispose($mnu->GetId());
    if (is_array($c)) foreach($c as $key=>$val)
    {
     $c[strtoupper($key)]=$val;
    }
   }
   $r=$db->GetTermList($start,$term,$count,$isback,$format);
   if (!is_array($r)) {die();}; 
   $err=$r['errorcode']; 
   unset ($r['errorcode']);
   
   if (is_array($r)) foreach ($r as $i) 
   { 
    $trms[$i['key']]['refs']+=$i['refs'];
    if ($mnuname != '')
    {
     $trms[$i['key']]['desc']=$c[$i['key']];
    }
    else
    {
     $trms[$i['key']]['desc']=$i['key'];
    }
    if ($format!='')
    {
     $trms[$i['key']]['mfn']=$i['mfn'];
     $trms[$i['key']]['tag']=$i['tag'];
     $trms[$i['key']]['occ']=$i['occ'];
     $trms[$i['key']]['cnt']=$i['cnt'];
     $trms[$i['key']]['format']=$i['format'];
    }
    if ($format=='*')
    {
     $trms[$i['key']]['format']=$i['key'];
    }
   }
  }
 }
 ksort($trms);
 $trms = array_slice($trms, 0, 50, true);
 return $trms;
}

function widSearchPanel_GetDictionItems()
{
        global $SESSION_OM;
	if (REQUEST('inModeInitStr')!='')
	{
		// parse [DbName],Prefix,Format
		// to irbDb,term,format
		$ss=REQUEST('inModeInitStr');
		$j=0;
		for ($j = 0; (($j < strlen($ss)) && ($ss[$j] != ",")); $j++) ;
		$n=substr($ss, $j + 1);
		$dbname=substr($ss, 0, $j);
		//echo $n;
		for ($j = 0; (($j < strlen($n)) && ($n[$j] != ",")); $j++) ;
		$format=substr($n, $j + 1);
		$prefix=substr($n, 0, $j);
		//echo $dbname;
		if ($dbname!='') 
		{
			// search irbDb by name
			$om=$_SESSION[$SESSION_OM];
			foreach($om as $id=>$o)
			{
				//echo "check id $id (".$o['type'].") name=".$o['Name']."\n";
				if (($o['type']=='DB')&&($o['Name']==$dbname))
				{
					//echo "FOUND!!!\n";
					REQUEST_SET('irbDb',$id);
				}
			}
		}
		REQUEST_SET('start',$prefix);
		REQUEST_SET('format',$format);
	}
	$trms = widSearchPanel_GetDictionItemsArray();
	//print_r($trms);
	$cnt = 0;
	$res1 = '';
	foreach ($trms as $trm => $td)
	{
		//str_replace("\n","\\n",$td['format']);
		//str_replace("\r","\\r",$td['format']);
		//echo $td['format'];
		$f1=explode("\r",$td['format']);
		//print_r($f1);
		if ($cnt > 0) $res1 .= ',';
		$cnt++;
		$res1 .= '{key:"'.addslashes($trm).'",docs:'.addslashes($td['refs']);
		$res1.=',mfn:"'.$td['mfn'].'"';
		$res1.=',tag:"'.$td['tag'].'"';
		$res1.=',occ:"'.$td['occ'].'"';
		$res1.=',cnt:"'.$td['cnt'].'"';
		if (REQUEST('format')!='')
			$res1.=',format:"'.addslashes(trim($f1[$td['occ']-1],"\n\r")).'"';
		else
			$res1.=',format:"'.addslashes($trm).'"';
		$res1.='}';
	}
	$res = '{totalCount:'.$cnt.', RecList: ['.$res1.']}';
	//trigger_error("res=".$res, E_USER_NOTICE);
	echo $res;
	//print_r($_REQUEST);
}
;


function widSearchPanel_GetDictionItemsWDesc()
{
	$trms = widSearchPanel_GetDictionItemsArray();
	$cnt = 0;
	$res1 = '';
	foreach ($trms as $trm => $td)
	{
		if ($cnt > 0) $res1 .= ',';
		$cnt++;
		$res1 .= '{key:"'.addslashes($trm).'",docs:'.$td['refs'].',desc:"'.addslashes($td['desc']).'"';
		$res1.=',mfn:"'.$td['mfn'].'"';
		$res1.=',tag:"'.$td['tag'].'"';
		$res1.=',occ:"'.$td['occ'].'"';
		$res1.=',cnt:"'.$td['cnt'].'"';
		$res1.='}';
	}
	$res = '{totalCount:'.$cnt.', RecList: ['.$res1.']}';
	//trigger_error("res=".$res, E_USER_NOTICE);
	echo $res;

	/* $dbid=REQUEST('irbDb');
	$start=REQUEST('start');
	$mnuname=REQUEST('mnu');
	$term=REQUEST('term');
	$isback=REQUEST('back');
	$db=new DB($dbid);
	$mnu=new mnu(0);
	$mnu->LoadMnu($dbid,$mnuname);
	$r=$db->GetTermList($start,$term,50,$isback);
	$cnt=0;
	$err=$r['errorcode'];
	unset ($r['errorcode']);
	$c=$mnu->Content;
	$mnu->Dispose($mnu->GetId());
	if (is_array($c)) foreach($c as $key=>$val)
	{
		$c[strtoupper($key)]=$val;
	}
	if (is_array($r)) foreach ($r as $i)
	{
		if ($cnt>0) $res.=','; $cnt++;
		$res.='{key:"'.addslashes($i['key']).'",docs:'.addslashes($i['refs']).',desc:"'.addslashes($c[$i['key']]).'"}';
	}
	$res='{totalCount:'.$cnt.', RecList: ['.$res;
	$res.=']}';
	echo $res;*/
}
;

function widSearchPanel_GetDbMultySelectTreeItems()
{
	echo '[{text:"<b>Научная библиотека Омского государственного университета им. Ф. М. Достоевского</b>",libname:"OmSU",checked:false,disabled:false,listeners:{checkchange:function(n,c){n.eachChild(function(n){n.getUI().toggleCheck(this.getUI().isChecked())});}},children:[{text:"Основной каталог",dbname:"IBIS",leaf:true,disabled:false,checked:false}]}]';
	/*      $i64f=UseModule('i64f');
	$libs=$i64f->GetLibList();
	$dbs=$i64f->GetDbList();
	$res='';
	if (is_array($dbs)) foreach ($dbs as $d=>$db)
	{
	if ($db['pubEC']=='true')
	$libs[$db['Library']]['dbs'][$d]=$db;
	}
	$cnt=0;
	if (is_array($libs)) foreach ($libs as $l=>$lib)
	{
	if ((is_array($lib['dbs']))&&(count($lib['dbs'])>0))
	{
	if ($cnt>0) $res.=',';
	$cnt++;
	$hr=true;
	$res.="{text:\"".$lib['Desc']."\",libname:\"$l\",checked:false,";
	if (!UseModule('Security')->IsHaveRightsView($lib['sid']))
	{
	$res.='disabled:true,';
	$hr=false;
	}
	$res.="listeners:{checkchange:function(n,c){n.eachChild(function(n){n.getUI().toggleCheck(this.getUI().isChecked())});}},children:[";
	$cn=0;
	foreach($lib['dbs'] as $d=>$db)
	{
	if ($cn>0) $res.=',';
	$cn++;
	$res.="{text:\"".$db['desc']."\",dbname:\"".$d."\",leaf:true,";
	if ((!UseModule('Security')->IsHaveRightsView($db['sid']))||($hr!=true))
	$res.='disabled:true,';
	$res.="checked:false}";
	}
	$res.="]}";
	}
	}
	echo '['.$res.']';*/
}

//trigger_error("action=".REQUEST('action'), E_USER_NOTICE);
//trigger_error("dbg=".REQUEST('irbDb'), E_USER_NOTICE);

switch (REQUEST('action'))
{
	case 'GetSearchList':
		widSearchPanel_GetSearchList();
		break;
	case 'GetDictionItems':
		widSearchPanel_GetDictionItems();
		break;
	case 'GetDictionItemsWDesc':
		widSearchPanel_GetDictionItemsWDesc();
		break;
	case 'GetDbMultySelectTreeItems':
		widSearchPanel_GetDbMultySelectTreeItems();
		break;
}

/*

//---------------------------------------------------------------------
class json
{
var $limit;
var $start;
var $dir;
var $sort;

function json()
{
$this->limit=REQUEST('limit');
$this->start=REQUEST('start');
$this->dir=REQUEST('dir');
$this->sort=REQUEST('sort');
if ($this->start=='') $this->start=0;
}

function GetMnu()
{
require_once(dirname(__FILE__)."/mnu.php");
$dbid=REQUEST('db');
$mnu=new mnu(0);
$mnu->LoadMnu($dbid,REQUEST('mnu'));
$res.=$mnu->GetAsJson($this->start,$this->limit);
$mnu->Dispose($mnu->GetId());
echo $res;
}
function GetWss()
{
$dbid=REQUEST('db');
$val=REQUEST('val');
$wssn=REQUEST('wss');
require_once(dirname(__FILE__)."/WSS.php");
$wss=new WSS(0);
$wss->LoadWSS($dbid,$wssn);
$wss->SetField($val);
echo $wss->GetAsJson();
$wss->Dispose($wss->GetId());
}

function GetDictionItemsT2()
{
echo "[{
desc:'ColumnTree Example',
docs:'3',
uiProvider:'col',
cls:'master-task',
iconCls:'task-folder',
children:[{
desc:'Abstract rendering in TreeNodeUI',
docs:'15',
uiProvider:'col',
leaf:true,
iconCls:'task'
},{
desc:'Create TreeNodeUI with column knowledge',
docs:'45',
uiProvider:'col',
leaf:true,
iconCls:'task'
},{
desc:'Create TreePanel to render and lock headers',
docs:'30',
uiProvider:'col',
leaf:true,
iconCls:'task'
},{
desc:'Add CSS to make it look fly',
docs:'30',
uiProvider:'col',
leaf:true,
iconCls:'task'
},{
desc:'Test and make sure it works',
docs:'1',
uiProvider:'col',
leaf:true,
iconCls:'task'
}]
},{
desc:'Custom Field Example',
docs:'25',
uiProvider:'col',
cls:'master-task',
iconCls:'task-folder',
children:[{
desc:'Implement \"Live Search\" on extjs.com from Alex',
docs:'10',
uiProvider:'col',
leaf:true,
iconCls:'task'
},{
desc:'Extend TwinTrigger',
docs:'5',
uiProvider:'col',
leaf:true,
iconCls:'task'
},{
desc:'Testing and debugging',
docs:'10',
uiProvider:'col',
leaf:true,
iconCls:'task'
}]
},{
desc:'Foo Bar Item',
docs:'30',
uiProvider:'col',
cls:'master-task',
iconCls:'task-folder',
children:[{
desc:'Abstract rendering in TreeNodeUI',
docs:'25',
uiProvider:'col',
leaf:true,
iconCls:'task'
},{
desc:'Create TreeNodeUI with column knowledge',
docs:'45',
uiProvider:'col',
leaf:true,
iconCls:'task'
},{
desc:'Create TreePanel to render and lock headers',
docs:'30',
uiProvider:'col',
leaf:true,
iconCls:'task'
},{
desc:'Add CSS to make it look fly',
docs:'30',
uiProvider:'col',
leaf:true,
iconCls:'task'
},{
desc:'Test and make sure it works',
docs:'10',
uiProvider:'col',
leaf:true,
iconCls:'task'
}]
},{
desc:'WTF Item',
docs:'3',
uiProvider:'col',
cls:'master-task',
iconCls:'task-folder',
children:[{
desc:'Abstract rendering in TreeNodeUI',
docs:'15',
uiProvider:'col',
leaf:true,
iconCls:'task'
},{
desc:'Create TreeNodeUI with column knowledge',
docs:'45',
uiProvider:'col',
leaf:true,
iconCls:'task'
},{
desc:'Create TreePanel to render and lock headers',
docs:'30',
uiProvider:'col',
leaf:true,
iconCls:'task'
},{
desc:'Add CSS to make it look fly',
docs:'30',
uiProvider:'col',
leaf:true,
iconCls:'task'
},{
desc:'Test and make sure it works',
docs:'60',
uiProvider:'col',
leaf:true,
iconCls:'task'
}]
}]";
}
function GetDbList()
{
require_once(dirname(__FILE__).'/ARM.php');
$s=new ARM(REQUEST('arm'));
$res='';
$cnt=0;
$dbl=$s->DbList;
if (is_array($dbl)) foreach($dbl as $cdb)
{
$db=new OM($cdb);
if ($cnt>0) $res.= ',';
$res.= '{Name: "'.$db->Name.'", Desc: "'.$db->Name.' - '.iconv("windows-1251","utf-8",str_replace("\"","\\\"",$db->Description)).'"}';
$cnt++;
}
$res='{totalCount:'.$cnt.', value:"IBIS",RecList: ['.$res;
$res.=']}';
echo $res;
}

function FormatRec()
{
require_once(dirname(__FILE__).'/DB.php');
require_once(dirname(__FILE__).'/Record.php');
$db=new DB(REQUEST('db'));
$pft=REQUEST('pft');
$rec=new Record(REQUEST('rec'));
echo $db->RecVirtualFormat($pft,$rec);
}

function DoSearch()
{
$dbid=REQUEST('db');
$term=REQUEST('term');
$pref=REQUEST('pref');
require_once(dirname(__FILE__).'/ARM.php');
$db=new DB($dbid);
$db->DoSearch($pref,$term);
//  echo $term;
echo '{pref:"'.addslashes($pref).'",term:"'.addslashes($term).'"}';
}
};

$jj=new json();

switch(REQUEST('action'))
{
case 'GetMnu': $jj->GetMnu(); break;
case 'GetWss': $jj->GetWss(); break;
case 'GetSearchList': $jj->GetSearchList(); break;
case 'GetDbList': $jj->GetDbList(); break;
case 'GetDictionItems': $jj->GetDictionItems(); break;
case 'GetDictionItemsWDesc': $jj->GetDictionItemsWDesc(); break;
case 'GetDictionItemsT2': $jj->GetDictionItemsT2(); break;
case 'FormatRec': $jj->FormatRec(); break;
case 'DoSearch': $jj->DoSearch(); break;
};
*/
?>