<?php

require_once (dirname(__FILE__).'/../classes/Record.php');

function widWS_GetRLItems()
{
 require_once (dirname(__FILE__).'/../classes/WS.php');
 require_once (dirname(__FILE__).'/../classes/DB.php');

 $RLName=REQUEST('RL');
 $dbid=REQUEST('dbid');
 $recid=REQUEST('recid');
 $wsname=REQUEST('wsname');

 $dbrdr=new DB($dbid);
 $rc=new Record($recid);
 $ws=new WS(0);
 $ws->LoadWS($dbrdr->GetId(),$wsname);
 $ws->ApplyToRec($rc->GetId());

 $wsc=$ws->Content;
 $rl=$wsc[REQUEST('RL')];
 echo "{ RLItems: [";
 if (is_array($rl))
 {
  $idx=1;
  $cnt=0;
  $r=$rc->Content;
  foreach($rl as $key=>$fld)
   if (is_numeric($key))
   {
    $f=$fld;
    $ff=$r[$key];
    if(count($ff)==0)
    {
     if ($cnt>0) echo ','; $cnt++;
     $vocc=($fld['repeat']>0)?'1':'""';
     echo "{FieldId:".$cnt.",Desc:'".$fld['caption']."',Field:".$key.",Occ:$vocc,Value:'',HelpId:'".$fld['helpid']."',DopInf:'".$fld['dopinf']."',InMode:".$fld['inmode'].",Help:'".$fld['help']."'}";
    }
    else
    {
     if (is_array($ff)) foreach($ff as $occ=>$cf)
     {
      if ($cnt>0) echo ','; $cnt++;
      echo "{FieldId:".$cnt.",Desc:'";
      if ($occ==0)
       echo $fld['caption'];
      $vocc=($fld['repeat']>0)?($occ+1):'""';
      echo "',Field:".$key.",Occ:".$vocc.",Value:'".$cf."',HelpId:'".$fld['helpid']."',DopInf:'".$fld['dopinf']."',InMode:".$fld['inmode'].",Help:'".$fld['help']."'}";
     }
    }
   }
 }
 echo "]}";
}

function widWS_WsRecFieldSet()
{
 $fld=REQUEST('field');
 $occ=REQUEST('occ');
 $value=REQUEST('value');
 $recid=REQUEST('recid');
 if ($occ=='') $occ=1;
 $rc=new Record($recid);
 $rc->SetField($fld,$occ,$value);
}

switch (REQUEST('op'))
{
 case 'GetRLList': widWS_GetRLItems(); break;
 case 'WsRecFieldSet': widWS_WsRecFieldSet(); break;
}
?>