<?php 

require_once(dirname(__FILE__).'/ButtonManagers.inc');

class rlbManageRecs extends ButtonManagerPreselected
{
 var $fres;
 var $rowtype;
 var $cols;
 var $scls;
 var $params;

 function Start(&$res)
 {
  $this->fres=array();
  $this->rowtype=$_REQUEST['key'];
  $cols=$_REQUEST['colConfigName'];

  $fname=dirname(__FILE__).'/../classes/stt/'.$this->rowtype;
  if (file_exists($fname.'.user.stt128')) $fname=$fname.'.user.stt128';
  else if (file_exists($fname.'.stt128')) $fname=$fname.'.stt128';
//  else return FALSE;
  require_once($fname);
  $classname='stt_'.$this->rowtype;
  $this->scls=new $classname();
  $this->ActionSetNewWindow('../vidget/rlbStatForms.php','Статистика');
  $this->clsinf=$this->scls->_info();
  $res['cols']=array();
  $res['cols'][]=array('type' => $this->clsinf['elms'][$this->rowtype]['type'],'func' => $this->rowtype,'name'=>$this->clsinf['elms'][$this->rowtype]['name']);

  foreach($cols as $colname)
  {
   $res['cols'][]=array
   (
    'type' => $this->clsinf['elms'][$colname]['type'],
    'func' => $colname,
    'name'=>$this->clsinf['elms'][$colname]['name'],
    'operation'=>$this->clsinf['elms'][$colname]['defoperation']
   );
  }

  return TRUE;
 }

 function DoWork($db,$r,&$res)
 {
  /*
    cols:array(
    'type' => internal column type. may be: 'record', 'colname', 'multy','const'
    'func' => stat function name
    'value' => const value of column. May be changed for each row
    'name'=> column name (if const)
    'subcols'=>sub columns
    )
  */
  $this->dres=&$res;
  $tres=array();
  foreach ($res['cols'] as $key=>&$colinfo)
  {
   $tres=array();
   if ($colinfo['type']!='record') 
   {
    if ($this->scls->$colinfo['func']($db,$r,$tres,$this,$colinfo,$this->params))
    {
     //$res['dbg'][]=$tres;
     foreach($tres as $row=>$resi) //tres[row][resi][col2name][0][data]
     {
      if (!isset($res['fres'][$row])) $res['fres'][$row]='';
      $ares=$this->ApplyVal($res['fres'],$colinfo,$row,$resi);
      $res['fres']=$ares['fres'];
      $res['cols'][$key]=$ares['cols'];
     }
    }
   }
  }
 }

 function End(&$res)
 {
 }

 function GetResult($res)
 {
  header("Content-Type: text/html; charset=utf-8");
  echo $this->GetAsHtmlTable($res['fres'],$res['cols']);
  /*echo '<hr><pre>';
  print_r($res);
  echo '</pre>';*/
 }


 function ApplyOperation($elm,$operation,$val)
 {
  if ($operation=='sum') { $elm['data']+=$val; }
  else if ($operation=='count') { $elm['data']++; }
  else if ($operation=='avg') { $elm['sum']+=$val; $elm['cnt']++; $elm['data']=$elm['sum']/$elm['cnt']; }
  else if ($operation=='min') { if ($elm['data']=='') $elm['data']=$val; else $elm['data']=min($elm['data'],$val); }
  else if ($operation=='max') { if ($elm['data']=='') $elm['data']=$val; else $elm['data']=max($elm['data'],$val); }
  else if ($operation=='concatenate') { $elm['data'].=$val; }
  else if ($operation=='first') { if ($elm['data']=='') $elm['data']=$val; }
  else if ($operation=='last') { $elm['data']=$val; }
  else { $elm['data']=$val; }
  return $elm;
 }

 function ApplyVal($fres,$colinfo,$col,$val)
 {
  $operation=$colinfo['operation'];

  if (is_array($val)) foreach($val as $k=>$v)
  {
   if ($colinfo['type']=='colname')
   {
    $fres[$col][$colinfo['name']]=$this->ApplyOperation($fres[$col][$colinfo['name']],$operation,$v);
   }
   else if ($colinfo['type']=='multy')
   {
    $ifn=$colinfo['func'].'_info';
    $colinfo['subcols'][$k]=$this->scls->$ifn();
    $colinfo['subcols'][$k]['name']=$k;
    $colinfo['subcols'][$k]['operation']=$colinfo['subcols'][$k]['defoperation'];
    $tres=$this->ApplyVal($fres[$col],$colinfo['subcols'][$k],$colinfo['name'],$v);
    $fres[$col]=$tres['fres'];
    $colinfo['subcols'][$k]=$tres['cols'];
   }
  }
  return array('fres'=>$fres,'cols'=>$colinfo);
 }


 function GetAsHtmlTable($arr,$cols)
 {
//  print_r($cols);
  // create table header
  $res='<table border="1"><tr>';
  $usemulty=false;
  foreach ($cols as $colinfo) if ($colinfo['type']=='multy') $usemulty=true;
  foreach ($cols as $colinfo)
  {
   if ($colinfo['type']=='multy')
   {
    $res.='<td colspan="'.count($colinfo['subcols']).'"'.'><center>'.$colinfo['name'].'</center></td>';
   }
   else if ($colinfo['type']!='hidden')
   {
    $res.='<td';
    if ($usemulty) $res.=' rowspan="2"';
    $res.='><center>'.$colinfo['name'].'</center></td>';
   }
  }
  if ($usemulty)
  {
   $res.='<tr>';
   foreach ($cols as $colinfo)
   {
    if ($colinfo['type']=='multy')
    {
     if (is_array($colinfo['subcols'])) foreach($colinfo['subcols'] as $colname=>$coldata)
     {
      $res.='<td><center>'.$colname.'</center></td>';
     }
    }
   }
   $res.='</tr>';
  }
  $res.='</td>';
  foreach($arr as $row)
  {
   $res.='<tr>';
   foreach ($cols as $colinfo)
   {
    if ($colinfo['type']=='multy')
    {
     if (is_array($colinfo['subcols'])) foreach($colinfo['subcols'] as $colname=>$coldata)
     {
      if (isset($row[$colinfo['name']][$colname]))
       $res.='<td>'.$row[$colinfo['name']][$colname]['data'].'</td>';
      else
       $res.='<td>&nbsp;</td>';
     }
    }
    else if ($colinfo['type']!='hidden')
    {
     if (isset($row[$colinfo['name']]))
      $res.='<td>'.$row[$colinfo['name']]['data'].'</td>';
     else
      $res.='<td>&nbsp;</td>';
    }
   }
   $res.='</tr>';
  }
  $res.='</table>';
  return $res;
 }

}

$m=new rlbManageRecs;
$m->Run();

?>