<?php 
/*
Manage SCHOOLBRIEFMODE=1
*/

require_once(dirname(__FILE__).'/../classes/DB.php');
require_once(dirname(__FILE__).'/../classes/Record.php');

$dbid=REQUEST('irbDb');
$mfn=REQUEST('mfn');

$db=new DB($dbid);


// load record

$rec=new Record(0);
if ($mfn!='')
{
 $rec->Clear();
 $db->RecRead($mfn,false,$rec);
}


if (REQUEST('action')=='form')
{
 $occ=$rec->GetFieldOcc('910');
 $ekzc=0;
 $sigla=$db->GetIniValue('MAIN','ORGSIGLA','');
 for ($i=1;$i<=$occ;$i++)
 {
  if ($rec->GetSubField('910',$i,'D')==$sigla)
   $ekzc=$rec->GetSubField('910',$i,'1')+0;
 }
 //create answer

  echo "{success:true,Action:function(arm){
  var form=new Ext.form.FormPanel
     ({
       labelWidth: 150,
       bodyStyle:'padding:15px',
       width: 350,
       labelPad: 10,
       defaults: {
        // applied to each contained item
        width: 230,
        msgTarget: 'side'
       },
       url:'schoolbriefmode.php',
       items: 
       [
        new Ext.form.Hidden({
         name: 'action',
         value: 'setekz',
         inputType:'hidden'
        }),
        new Ext.form.Hidden({
         name: 'irbDb',
         value: '".$dbid."',
         inputType:'hidden'
        }),
        new Ext.form.Hidden({
         name: 'mfn',
         value: '".$mfn."',
         inputType:'hidden'
        }),
        new Ext.ux.form.SpinnerField//Ext.form.NumberField
        ({
          allowBlank:false,
          allowDecimals:false,
          allowNegative:false,
          minValue: 0,
          accelerate:true,
          fieldLabel:'Количество экземпляров',
          name:'ekzs',
          value:".$ekzc."
        })
       ],
       buttons:
      [
       {
        listeners:
        {
         click:function(butt,e)
         {
          form.getForm().submit
          ({
            waitMsg:'Processing...',
            reset:true,
            scope:this,
            success:function(form,action)
            {
             w.close();
             action.result.Action(form.arm);
            },
            failure: function(form, action) 
            {
             w.close();
             action.result.Action();
            }
          })
         },
         scope:this
        },
        text:'Ок',
        formBind:true
       },
       {
        listeners:
        {
         click:function(butt,e)
         {
          w.close();
         }
        },
        text:'Отмена'
       }
      ]
     });
  form.arm=arm;
  var w=new Ext.Window
  ({
    irbDb:".$dbid.",
    modal:true,
    title: 'Редактирование количества экземпляров',
    width:450,
    height:125,
    layout:'fit',
    maximizable:false,
    items:
    [
     form
    ]
  });
  w.show();
  w.center();
 }}";
}
else if (REQUEST('action')=='setekz')
{
 $occs=$rec->GetFieldOcc('910');
 $ekzc=0;
 $occ=0;
 $sigla=$db->GetIniValue('MAIN','ORGSIGLA','');
 for ($i=1;$i<=$occs;$i++)
 {
  if ($rec->GetSubField('910',$i,'D')==$sigla)
   $occ=$i;
 }
 $val="^AU^1".REQUEST('ekzs').'^D'.$sigla.'^B'.$sigla.'-'.date('Ymdhis').'^C'.date('Ymd');
 if ($occ>0)
 {
  $rec->SetField('910',$occ,$val);
 }
 else
 {
  $rec->FieldAdd('910',$val);
 }
 $db->SaveAndUpdateRecord($rec,true);
 echo "{Action:function(arm){/*arm.m_RecList.Reload();*/}}";
}

$rec->Dispose($rec->GetId());
?>