Ext.Irbis={version:"2012.1"};
Irbis={version:"2012.1"};

Irbis.setCookie=function (name, value, expires, path, domain, secure) 
{
 if (!name || !value) return false;
 var str = name + '=' + encodeURIComponent(value);
 
 if (expires) str += '; expires=' + expires.toGMTString();
 if (path)    str += '; path=' + path;
 if (domain)  str += '; domain=' + domain;
 if (secure)  str += '; secure';
 
 document.cookie = str;
 return true;
}

Irbis.getCookie=function (name) 
{
 var pattern = "(?:; )?" + name + "=([^;]*);?";
 var regexp  = new RegExp(pattern);
 if (regexp.test(document.cookie)) return decodeURIComponent(RegExp["$1"]);
 return false;
}

Irbis.deleteCookie=function (name, path, domain) 
{
 Irbis.setCookie(name, null, new Date(0), path, domain);
 return true;
}

Irbis.addslashes=function (str) 
{
 str=str.replace(/\\/g,'\\\\');
 str=str.replace(/\'/g,'\\\'');
 str=str.replace(/\"/g,'\\"');
 str=str.replace(/\0/g,'\\0');
 return str;
};

Irbis.stripslashes=function (str) 
{
 str=str.replace(/\\'/g,'\'');
 str=str.replace(/\\"/g,'"');
 str=str.replace(/\\0/g,'\0');
 str=str.replace(/\\\\/g,'\\');
 return str;
};

Irbis.LongRequest=function(params,url)
{
 var u=url; if (typeof(url)=='undefined') u='../C/c.php';
 this.guid='xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) 
 {
    var r = Math.random()*16|0, v = c == 'x' ? r : (r&0x3|0x8);
    return v.toString(16);
 });
 var p1=params;
 p1.guid=this.guid;
 Ext.Ajax.request
 ({
   url: u,
   params:p1,
   scope: this
 });
 this.pbar = new Ext.ProgressBar
 ({
   text:'Waiting on you...'
 });
 this.task = 
 {
  run: function()
  {
   Ext.Ajax.request
   ({
     url: '../vidget/LongTask.php?guid='+this.guid,
     success: function(r) 
     {
      if (r.responseText!='')
      {
       var resp = Ext.decode(r.responseText);
       this.pbar.updateProgress(resp.progress, resp.text,true);
       if (resp.done) 
       {
        this.runner.stop(this.task);
        this.wWait.close();
        resp.Action(this);
       }
      }
     },
     scope: this
   });
  },
  interval: 1000,
  scope:this
 };

 this.wWait=new Ext.Window
 ({
   modal:true,
   title:'Ожидание',
   border:false,
   closable:false,
   resizable:false,
   width:400,
   height:200,
   draggable:false,
   items:
   [
    this.pbar
   ]
 });
 this.wWait.show();
 this.runner = new Ext.util.TaskRunner();
 this.runner.start(this.task);
};

Irbis.ModalRequest=function(params,url)
{
 var u=url; if (typeof(url)=='undefined') u='../C/c.php';
 this.wWait=new Ext.Window
 ({
   modal:true,
   title:'Ожидание',
   border:false,
   closable:false,
   resizable:false,
   draggable:false,
   html:'<img src="../resources/images/default/irb/loading.gif"/> Обработка данных...'
 });
 this.wWait.show();
 Ext.Ajax.request
 ({
   url: u,
   params:params,
   success: function(response)
   {
   	this.wWait.close();
   	resp=Ext.decode(response.responseText); 
   	resp.Action(this);
   },
   failure: function(response)
   {
       this.wWait.close();
       Ext.Msg.alert("Error! (Ext.Ajax.request)",'');
   },
   scope: this
 });
};
