Irbis.Editor=function(cfg) 
{
 Ext.apply(this, cfg);
 this.wsname='';
 this.treeLoader=new Ext.tree.TreeLoader
 ({
   dataUrl:'../vidget/EditorLoader.php',
   baseParams:{arm:this.irbArm,irbDb:this.irbDb,irbRec:this.irbRec,wsname:this.wsname},
   listeners:
   {
    beforeload:function(tree,node)
    {
     this.baseParams.cat = node.attributes.cat;
     this.baseParams.wstab = node.attributes.wstab;
     this.baseParams.occstart = node.attributes.occstart;
     this.baseParams.occend = node.attributes.occend;
     this.baseParams.fldno = node.attributes.fldno;
     this.baseParams.occ = node.attributes.occ;
     this.baseParams.dopinf = node.attributes.dopinf;
     this.baseParams.cancelchanges=node.attributes.cancelchanges;
     node.attributes.cancelchanges=false;
    }
   }
 });
 this.bbartext=new Ext.Toolbar.TextItem({text:'&nbsp;'});
 this.panelTree=new Ext.tree.TreePanel
 ({
   panelEditor:this,
   region:'west',
   layout:'fit',
   singleExpand:true,
   useArrows: true,
   autoScroll: true,
   animate: true,
   containerScroll: true,
   border: false,
   rootVisible:false,
   loader:this.treeLoader,
   keys:[{key:113,fn:this.handleF2,scope:this},{key:'l',alt:true,fn:this.handleAltL,scope:this}],
   selModel:new Ext.tree.DefaultSelectionModel({listeners:{selectionchange : this.selChanged,scope:this}}),
   bbar:[this.bbartext],
   root:
   {
    nodeType: 'async',
    text: 'Ext JS',
    cat:'root',
    id: 'root'
   }
 });

 this.treeEditorField=new Ext.form.TextField
 ({
   enableKeyEvents:true,
   listeners:
   {
    keydown:function(field,e)
    {
     //if (e.keyCode==18) field.altPressed=true;
     //field.setRawValue(field.getRawValue()+' '+e.keyCode);
    },
    keyup:function(field,e)
    {
     //alert(e.keyCode);
     if (e.keyCode==113) this.handleF2();
     if ( (e.keyCode==76) && (e.altKey))
     {
      var d=new Date();
      field.setValue(field.getValue()+Ext.util.Format.date(d,'Ymd'));
     }
    },
    scope:this
   }
   //keys:[{key:113,fn:this.handleF2,scope:this},{key:'l',alt:true,fn:this.handleAltL,scope:this}]
 });

 this.treeEditor=new Ext.tree.TreeEditor
 (
  this.panelTree,
  {
   irbDb:this.irbDb,
   irbRec:this.irbRec,
   name:'attributes.value',
   selectOnFocus: true
  },
/*   xtype: "tinymce",
   tinymceSettings: {
	theme : "advanced",
	plugins: "safari,pagebreak,style,layer,table,advhr,advimage,advlink,emotions,iespell,insertdatetime,preview,media,searchreplace,print,contextmenu,paste,directionality,noneditable,visualchars,nonbreaking,xhtmlxtras,template",
	theme_advanced_buttons1 : "bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,|,styleselect,formatselect,fontselect,fontsizeselect",
	theme_advanced_buttons2 : "cut,copy,paste,pastetext,pasteword,|,search,replace,|,bullist,numlist,|,outdent,indent,blockquote,|,undo,redo,|,link,unlink,anchor,image,cleanup,help,code,|,insertdate,inserttime,preview,|,forecolor,backcolor",
	theme_advanced_buttons3 : "tablecontrols,|,hr,removeformat,visualaid,|,sub,sup,|,charmap,emotions,iespell,media,advhr,|,print,|,ltr,rtl,|",
	theme_advanced_buttons4 : "insertlayer,moveforward,movebackward,absolute,|,styleprops,|,cite,abbr,acronym,del,ins,attribs,|,visualchars,nonbreaking,template,pagebreak",
	theme_advanced_toolbar_location : "top",
	theme_advanced_toolbar_align : "left",
	theme_advanced_statusbar_location : "bottom",
	theme_advanced_resizing : false,
	extended_valid_elements : "a[name|href|target|title|onclick],img[class|src|border=0|alt|title|hspace|vspace|width|height|align|onmouseover|onmouseout|name],hr[class|width|size|noshade],font[face|size|color|style],span[class|align|style]",
	template_external_list_url : "example_template_list.js"
   },
   value: "<h1>Demo</h1><p>Ext.ux.TinyMCE works...</p>"
  }, */
  {
   cancelOnEsc: true,
   revertInvalid: true,
   ignoreNoChange: true,
   swallowKeys:false,
   completeOnEnter:true,
   field:this.treeEditorField,
   enableKeyEvents:true,
   //keys:[{key:113,fn:this.handleF2,scope:this},{key:'l',alt:true,fn:this.handleAltL,scope:this}],
   listeners:
   {
    complete:function(editor,newvalue,oldvalue)
    {
     e=editor.editNode;
     e.attributes.loader.baseParams.action='change';
     e.attributes.loader.baseParams.changefrom=oldvalue;
     e.attributes.loader.baseParams.changeto=newvalue;
    },
    startedit:function(el,v)
    {
     var te=this.treeEditor;
     if (te.editNode.attributes.value=='')
     {
      if (te.editNode.attributes.inline=='')
       te.field.setValue(te.editNode.attributes.defvalue);
      else
       te.field.setValue(te.editNode.attributes.inline);
     }
     else
      te.field.setValue(te.editNode.attributes.value);
    },
    scope:this
   },
   value:'fldno',
   maxWidth:3000
  }
 );
 this.treeEditor.renderNode=this.renderNode;
 this.panelTree.on('dblclick',function(node){this.treeEditor.StartEdit(node);},this);
 this.updateNode=function(node,value)
 {
  node.setText('Обновление данных...');
  node.disable();
  var a=node.attributes;
  var pnode=node.parentNode;
  if (a.cat!='subf')
  {
   //a.value=value;
   //node.setText(this.renderNode(node));
  }
  if (a.cat=='subf') //if changed subfield - change field
  {
   var n=node;
   var s=n.parentNode.attributes.value;
   if (value.charAt(0)!='^') s+=('^'+n.attributes.subf);
   s+=value;
   this.updateNode(n.parentNode,s);
   this.updatesf=n.attributes.subf;
   return;
  }
  this.updatingnode=node;
  Ext.Ajax.request
  ({
    url: '../vidget/EditorLoader.php',
    params:{cat:'updaterec',irbDb:this.irbDb,irbRec:this.irbRec,fldno:a.fldno,occ:a.occ,subf:a.subf,value:value},
    success: function(response)
    {
     this.fireEvent('changedrec');
     this.SetSavedState(false);
     if (this.updatingnode.attributes.leaf!=true)
      this.updatingnode.reload(this.renderFieldNodeBySf,this);
     if (this.updatingnode.attributes.cat=='fld')
     {
      this.updatingnode.parentNode.reload();
     }
    },
    failure: function(response)
    {
    	Ext.Msg.alert("Error! (Ext.Ajax.request)",'');
    },
    scope: this
  }); 
 };
 this.renderFieldNodeBySf=function(node)
 {
  var cn=node.firstChild;
  var res='';
  while (cn!=null)
  {
   if (cn.attributes.subf=='*') res=cn.attributes.value+res;
   else
   {
    if (cn.attributes.value!='')
     res=res+'^'+cn.attributes.subf+cn.attributes.value;
   }
   if (this.updatesf==cn.attributes.subf) cn.select();
   cn=cn.nextSibling;
  }
  node.attributes.value=res;
  node.setText(this.renderNode(node));
  node.enable();
  if (this.updatesf=='') node.select();
  this.updatesf='';
  var a=node.parentNode.attributes;
  if (((a.cat=='fset')||(a.cat=='fld')) && (a.repeat==1) && (a.value!='') && node.nextSibling==null)
  {
   node.parentNode.reload();
  }
 };
 this.treeEditor.updateNode=function(ed, value)
 {
  this.tree.getTreeEl().un('scroll', this.cancelEdit, this);
  this.editNode.getOwnerTree().panelEditor.updateNode(this.editNode,value);
 };

 this.panelEditor=new Ext.Panel
 ({
   layout:'fit',
   region:'center'
 });
 this.panelTree.getRootNode().expand();
 this.items=[this.panelTree];

 this.SetSavedState=function(state)
 {
  if (state)
  {
   this.btnSave.disable();
   this.btnSaveAndClose.disable();
   this.btnCancel.disable();
  }
  else
  {
   this.btnSave.enable();
   this.btnSaveAndClose.enable();
   this.btnCancel.enable();
  }
 }

//************************* tool buttons

 this.btnSave=new Ext.Button
 ({
   iconCls:'irb-save',
   tooltip:'Сохранить запись',
//   text:'<b>Сохранить</b>',
   disabled:true,
   handler:function()
   {
    Ext.Ajax.request
    ({
      url: '../vidget/EditorLoader.php',
      params:{cat:'saverec',irbDb:this.irbDb,irbRec:this.irbRec},
      success: function(response)
      {
       if (response.responseText=='')
       {
        this.fireEvent('savedrec');
        this.panelTree.getRootNode().reload();
        this.panelTree.getRootNode().expand();
        this.fireEvent('changedrec');
        Ext.Msg.alert('Запись сохранена');
        this.SetSavedState(true);
       }
       else
       {
        Ext.Msg.show
        ({
          title:'Ошибка',
          msg: response.responseText,
          buttons: Ext.Msg.OK,
          icon: Ext.MessageBox.ERROR
        });
       }
      },
      failure: function(response)
      {
    	Ext.Msg.alert("Error! (Ext.Ajax.request)",'');
      },
      scope: this
    }); 
   },
   scope:this
 });

 this.btnSaveAndClose=new Ext.Button
 ({
   iconCls:'irb-saveandclose',
   tooltip:'Сохранить запись и закрыть редактор',
   text:'<b>Сохранить и закрыть</b>',
   disabled:true,
   handler:function()
   {
    Ext.Ajax.request
    ({
      url: '../vidget/EditorLoader.php',
      params:{cat:'saverec',irbDb:this.irbDb,irbRec:this.irbRec},
      success: function(response)
      {
       this.fireEvent('savedrec');
       this.fireEvent('needtoclose');
      },
      failure: function(response)
      {
    	Ext.Msg.alert("Error! (Ext.Ajax.request)",'');
      },
      scope: this
    }); 
   },
   scope:this
 });

 this.btnUpdate=new Ext.Button
 ({
   iconCls:'irb-refresh',
   tooltip:'Обновить данные в редакторе',
//   text:'Обновить данные',
   handler:function()
   {
    this.treeLoader.load(this.panelTree.getRootNode());
   },
   scope:this
 });

 this.btnCancel=new Ext.Button
 ({
   iconCls:'irb-cancel',
   tooltip:'Отменить изменения и вернуться к исходной записи',
   disabled:true,
   handler:function()
   {
    if (confirm('Вы действительно хотите отменить все изменения и вернуться к исходной записи?'))
    {
     this.panelTree.getRootNode().attributes.cancelchanges=true;
     this.treeLoader.load(this.panelTree.getRootNode());
     this.SetSavedState(true);
    }
   },
   scope:this
 });

 this.btnF2=new Ext.Button
 ({
   iconCls:'irb-f2',
   tooltip:'Ввод данных с помощью инструмента',
   hidden:true,
   handler:function()
   {
    this.handleF2();
   },
   scope:this
 });

 this.wsselector=new Irbis.MnuComboSelector
 ({
   arm:this.irbArm,irbDb:this.irbDb,irbMnuNameByIniSection:'MAIN',irbMnuNameByIniParam:'FmtMnu',mnunamedef:'FMT.MNU',
   listeners:
   {
    'select':function(combo,record,index) { this.treeLoader.baseParams.wsname=record.get('key'); this.treeLoader.load(this.panelTree.getRootNode());},
    scope:this
   }
 });


  this.btnInlineQuickView={
   iconCls:'irb-quickview',
   tooltip:'Просмотр результирующей записи Inline-каталогизации',
   text:'Просмотр результирующей записи Inline-каталогизации',
   handler:function()
   {
    var pftInline=new Irbis.PftView
    ({
      irbDb:this.irbDb,irbRec:this.irbRecInline,irbPft:'@',
      autoScroll:true,
      layout:'fit'
    });
    var wndInlineQuickView=new Ext.Window
     ({
       title:'Просмотр результирующей записи Inline-каталогизации',
       closable:true,
       modal:true,
       autoScroll: true,
       height:250,
       width:600,
       layout:'fit',
       items:pftInline
    });
    wndInlineQuickView.show();
    pftInline.ReLoad();
   },
   scope:this
 };

 this.btnInlineApplyAll=
 {
   iconCls:'irb-inline',
   tooltip:'Применить к текущей записи все найденные данные',
   text:'Применить все',
   handler:function()
   {
    Ext.Ajax.request
    ({
      url: '../vidget/EditorLoader.php',
      params:{cat:'applyallinline',irbDb:this.irbDb,irbRec:this.irbRec,irbRecInline:this.irbRecInline},
      success: function(response)
      {
       this.fireEvent('changedrec');
       this.SetSavedState(false);
       this.treeLoader.load(this.panelTree.getRootNode());
      },
      failure: function(response)
      {
      	Ext.Msg.alert("Error! (Ext.Ajax.request)",'');
      },
      scope: this
    }); 
   },
   scope:this
 };

 this.btnInline = new Ext.Button
 ({
   iconCls:'irb-inline',
   tooltip:'Inline-каталогизация',
   menu:new Ext.menu.Menu
   ({
     id: 'mainMenu',
     items: [this.btnInlineQuickView,this.btnInlineApplyAll]
   }),
   scope:this
 });

 this.btnNew=
 {
  iconCls:'irb-new',
  tooltip:'Новая запись',
  text:'Завершить работу с текущей записью (без сохранения) и создать новую',
  handler:function()
  {
   Ext.Ajax.request
   ({
     url: '../vidget/EditorLoader.php',
     params:{cat:'newrec',irbDb:this.irbDb,irbRec:this.irbRec},
     success: function(response)
     {
      this.fireEvent('changedrec');
      this.SetSavedState(true);
      this.treeLoader.load(this.panelTree.getRootNode());
     },
     failure: function(response)
     {
     	Ext.Msg.alert("Error! (Ext.Ajax.request)",'');
     },
     scope: this
   }); 
  },
  scope:this
 };

 this.btnNewFromCur=
 {
  iconCls:'irb-newfromcur',
  tooltip:'Новая запись из текущей',
  text:'Завершить работу с текущей записью (без сохранения) и создать на ее основе новую',
  handler:function()
  {
   Ext.Ajax.request
   ({
     url: '../vidget/EditorLoader.php',
     params:{cat:'newrecfromcur',irbDb:this.irbDb,irbRec:this.irbRec},
     success: function(response)
     {
      this.fireEvent('changedrec');
      this.SetSavedState(true);
      this.treeLoader.load(this.panelTree.getRootNode());
     },
     failure: function(response)
     {
     	Ext.Msg.alert("Error! (Ext.Ajax.request)",'');
     },
     scope: this
   }); 
  },
  scope:this
 };

 this.btnNewMenu = new Ext.Button
 ({
   iconCls:'irb-new',
   tooltip:'Новая запись',
   menu:new Ext.menu.Menu
   ({
     //id: 'mainMenu',
     items: [this.btnNew,this.btnNewFromCur]
   }),
   scope:this
 });


 this.tbar=[this.btnSaveAndClose,this.btnSave,this.btnNewMenu,this.btnCancel,'-',this.btnUpdate,'-',this.btnF2,'-','Рабочий лист: ',this.wsselector,this.btnInline];
 Ext.Panel.superclass.constructor.call(this);

}


/////////////////////////////////////////////////////////////////////////////

Ext.extend(Irbis.Editor,Ext.Panel,{

  //************************* params

  //irbArm:0,
  irbDb:0,
  irbWsName:'',

  isInlineCatAllowed:true,

  //************************* private

  isChanged:false,
  layout: 'fit',
  //html:'hi!',

  //************************* messages

  saveButtonText:'Сохранить и закрыть',


  //************************* events

  onSave: function(){},
  onNew: function(){},

  //************************* functions

  setChanged:function(isChanged)
  {
   this.isChanged=isChanged;
   //this.buttonSave.setDisabled(!isChanged);
  },

  changeDb:function(irbDb)
  {
   this.irbDb=irbDb;
  },

  //************************* private functions

 selChanged:function(sm,n)
 {
  if ((typeof(n)=='undefined')||(n==null)||(typeof(n.attributes)=='undefined')||(n.attributes==null)) return;
  if (typeof(n.attributes.qtip)=='undefined') this.bbartext.setText('&nbsp;');
  else this.bbartext.setText(n.attributes.qtip); 
  var im=n.attributes.inmode;
  this.btnF2.setVisible( (im==1) || (im=='1') || (im==2) || (im=='2') || (im==4) || (im=='4') || (im==6) || (im=='6') || (im==7) || (im=='7'));
 },

 renderNode:function(node)
 {
  var a=node.attributes;
  var res='';
  switch (a.cat)
  {
   case 'subf': 
                if (a.value!='') res+='<b>';
                res+=(a.caption+': ');
                if (a.value!='') res+='</b>';
                else res+=' <font color="#0000FF"><i>(Добавить значение)</i></font>';
                res+=a.value;
                if (((a.value=='')||(typeof(a.value)=='undefined')) && (a.inline!='')&&(typeof(a.inline)!='undefined'))
                 res+='<font color="#999955"><img src="../img/folder_go.png" border="0"/> <b>'+a.inline+'</b></font>';
                break;
   case 'fld':
   case 'subfs':
                if ((a.repeat==1)||(a.repeat=='1'))
                 res+=('<b>#'+a.occ+':</b> ');
                else
                 res+=('<b>'+a.caption+':</b> ');
                res+=a.value;
                if (((a.value=='')||(typeof(a.value)=='undefined')) && (a.inline!='')&&(typeof(a.inline)!='undefined'))
                {
                 res+='<font color="#999955"><img src="../img/folder_go.png" border="0"/> <b>'+a.inline+'</b></font>';
                } 
                else if (a.value=='')
                {
                 res+='<font color="#0000FF"><i>(Добавить значение)</i></font>';
                }
                break;
   default: res=a.value;
  }
  return res;
 },

 handleAltL:function()
 {
  var t=this.panelTree;
  var n=t.getSelectionModel().getSelectedNode();
  var d=new Date();
  this.updateNode(n,Ext.util.Format.date(d,'Ymd'));
 },

 handleF2:function()
 {
  var t=this.panelTree;
  var n=t.getSelectionModel().getSelectedNode();
  //alert(n.getPath());
  var a=n.attributes;
  var inc;
  var lstnr=
  {
   doSelect:function(c)
   {
    this.w.close();
    this.ed.updateNode(this.n,c.newValue);
   },
   doCancel:function(c)
   {
    this.w.close();
   }
  };
  switch(a.inmode)
  {
   case 0:
   case '0' : triggerEdit(n); return; break;
   case 1:
   case '1': inc=new Irbis.InType1({irbDb:this.irbDb,dopinf:a.dopinf,listeners:lstnr,layout:'fit',initvalue:a.value}); break;
   case 2:
   case '2': inc=new Irbis.InType2({irbDb:this.irbDb,dopinf:a.dopinf,listeners:lstnr,layout:'fit',initvalue:a.value}); break;
   case 4:
   case '4': inc=new Irbis.InType4({irbDb:this.irbDb,dopinf:a.dopinf,listeners:lstnr,layout:'fit',initvalue:a.value}); break;
   case 6:
   case '6': inc=new Irbis.InType6({irbDb:this.irbDb,dopinf:a.dopinf,listeners:lstnr,layout:'fit',initvalue:a.value}); break;
   case 7:
   case '7': inc=new Irbis.InType1({irbDb:this.irbDb,dopinf:a.dopinf,listeners:lstnr,layout:'fit',initvalue:a.value}); break;
   default: return; inc={html:'unknown input type'};
  }
  var wtitle=a.text;
  if (a.repeat==1) wtitle=n.parentNode.attributes.text+' / '+a.text;
  var w=new Ext.Window
  ({
    width:500,
    height:300,
    title:wtitle,
    layout:'fit',
    items:[inc]
  });
  inc.w=w;
  inc.ed=this;
  inc.n=n;
  w.show();
  w.center(); 
 }

});