﻿//--------------------------------------------------------

Ext.onReady(function()
{
//    Ext.state.Manager.setProvider(new Ext.state.CookieProvider());
 Ext.QuickTips.init();
 Ext.BLANK_IMAGE_URL = '../resources/images/default/s.gif';

 var act_Exit = new Ext.Action({text: 'Выход', handler: function(){window.top.location="c.php?action=Close";}, iconCls: 'icon_Exit' });
 var act_Open = new Ext.Action({text: 'Open db', handler: function(){Ext.C_DbSelector.focus();Ext.C_DbSelector.store.load();Ext.C_DbSelector.expand();}, iconCls: 'icon_Open' });

 Ext.C_DbSelector=new Ext.form.ComboBox
 ({
   allowBlank: false,
   blankText:'empty db',
   editable: false,
   width:300,
   resizable:true,
   store: new Ext.data.JsonStore
   ({
     url: Ext.HostUrl+'&action=GetDbList',
     root: 'DbList',
     fields: ['Name','Desc']
   }),
   fieldLabel: 'Name',
   name: 'Name',
   displayField:'Desc',
   valueField:'Name',
   hiddenName:'Name',
   typeAhead: true,
   triggerAction: 'all',
   emptyText:'БД по умолчанию',
   selectOnFocus:true
 });

 C_MainToolBar=new Ext.Toolbar
 (
  [
   {
    text: 'База данных',
    menu: 
    [
     act_Open,
     '-',
     {
      text:'Исходные документы', 
      menu:
      [
       {text:'Новый mfn'},
       {text:'Результат поиска'}
      ]
     },
     '-',
     act_Exit
    ] 
   },
   {
    text: 'Корректировка',
    menu: 
    [
     {text: 'Новый'},
     {text: 'Сохранить'},
     {text: 'Отменить'},
     {
      text: 'Переход',
      menu: 
      [
       {text: 'К первому'},
       {text: 'К предыдущему'},
       {text: 'К следующему'},
       {text: 'К последнему'}
      ]
     },
     {
      text: 'Переход по отмеченым',
      menu:
      [
       {text: 'К первому'},
       {text: 'К предыдущему'},
       {text: 'К следующему'},
       {text: 'К последнему'}
      ]
     },
     {text: 'Отметить все удаленные'},
     {text: 'Снять все отметки'},
     '-',
     {text: 'Рабочий лист ввода'},
     '-',
     {text: 'Новый из текущего'},
     {text: 'Значения по умолчанию'},
     {text: 'Печать КК'},
     {text: 'Добавить элемент в РЛ'},
     {text: 'Очистить'},
     {text: 'Удалить'},
     '-',
     {text: 'Корректировка по словарю'},
     {text: 'Глобальная'}
    ]
   },
   {
    text: 'Поиск',
    menu: 
    [
     {text: 'Поиск по словарю/Рубрикатору'},
     {text: 'Комплексный поиск'},
     {text: 'Для "умников"'},
     {text: 'Последовательный поис'},
     {text: 'Поиск по связи'},
     '-',
     {text: 'Вид основного словаря'},
     {text: 'Отбор по основному словарю'}
    ]
   },
   {
    text: 'Просмотр',
    menu: 
    [
     {text: 'Оперативный просмотр корректируемого'},
     {text: 'Внешний объект'},
     '-',
     {
      text: 'Связанные документы',
      menu:
      [
       {text: 'Вид связи'},
       '-',
       {text: 'Полное описание'},
       {text: 'Корректировка связанных записей'}
      ]
     },
     '-',
     {text: 'Формат просмотра'},
     '-',
     {text: 'Архив'}
    ]
   },
   {
    text: 'Сервис',
    menu: 
    [
     {text: 'Печать'},
     {text: 'Печать текущего'},
     {text: 'Экспорт'},
     {text: 'Копирование'},
     {text: 'Импорт'},
     {text: 'Импорт из ЛИБНЕТ'},
     {text: 'Импорт из Web-ИРБИС'},
     {text: 'Импорт из Z-ресурсов'},
     {text: 'Статистика'},
     {text: 'Стат. формы'},
     '-',
     {text: 'Копировать в буферную запись'},
     {text: 'Буферная запись'},
     {text: 'Вставить из буферной записи'},
     {text: 'Вставить из импорт. записи'},
     '-',
     {text: 'Настройка параметров'},
     {text: 'Настройка интерфейса'},
     {text: 'Виртуальная клавиатура'},
     {text: 'Орфография'},
     {text: 'Автосервис'},
     '-',
     {text: 'Обновить контекст'}
    ]
   },
   {
    text: 'Помощь',
    menu: 
    [
     {text: 'Полная инструкция'},
     {text: 'Текущий элемент ввода'},
     {text: 'Текущий элемент интерфейса'},
     '-',
     {text: 'О программе...'}
    ]
   },
   '-',
   Ext.C_DbSelector   
  ]
 );

 C_MfnField=new Ext.form.NumberField
 ({
   fieldLabel: 'Mfn',
   allowDecimals:false,
   allowNegative:false,
   emptyText: '(новый)',
   height:20,
   name: 'mfn',
   /*<?
    require_once ('../classes/Record.php');
    $rec=new Record($this->db->CurRec);
    if ($rec->mfn>0)
     echo "value:".$rec->mfn.",";
   ?>*/
   listeners:
   {
    change: function (field,val,oldval)
    {
     if (val!=oldval)
     {
      this.oldval=val;
      Ext.Ajax.request
      ({
        url: Ext.HostUrl,
        params: {action: 'ChangeMfn', mfn:val},
        success: function(response){C_ChangeMfn();},
//              failure: Ext.Msg.alert('Wrong Mfn', 'Mfn error'),
        scope: this
      });
     }
    },
    specialkey: function (f,e)
    {
     switch (e.getKey())
     {
      case Ext.EventObject.ENTER: 
       var val=f.getRawValue();
       if (this.oldval!=val)
       {
        this.oldval=val;
        Ext.Ajax.request
        ({
          url: Ext.HostUrl,
          params: {action: 'ChangeMfn', mfn:val},
          success: function(response){C_ChangeMfn();},
//             failure: Ext.Msg.alert('Wrong Mfn', 'Mfn error'),
          scope: this
        });
       }
      }
    }
   }
 })

 C_RecListStore=new Ext.data.JsonStore
 ({
   fields:['mfn','brief'],
   url: Ext.HostUrl+'&action=RecList',
   root: 'RecList',
//   baseParams: {limit:20},
   totalProperty:'totalCount',
   autoLoad:true
 });

 C_RecListStoreSearch=new Ext.data.JsonStore
 ({
   fields:['id','mfn','brief'],
   url: Ext.HostUrl+'&action=RecListSearch',
   root: 'RecList',
   baseParams: {limit:20},
   totalProperty:'totalCount'
//   autoLoad:true
 });

 C_RecList=new Ext.grid.GridPanel
 ({
   store: C_RecListStore,
   autoShow:true,
   viewConfig: 
   {
     forceFit: true, autoFill:true
   },
   sm: new Ext.grid.CheckboxSelectionModel({singleSelect:false,width:20}),
   columns:
   [
    new Ext.grid.CheckboxSelectionModel({singleSelect:false,width:20}),
    {header: 'mfn',width:20,dataIndex:'mfn',align:'right'},
    {header: 'Описание',dataIndex:'brief'}
   ],
   stripeRows: true,
//   autoSizeColumns:
   autoWidth:true,
   autoExpandColumn: 'mfn',
   listeners:
   {
    rowdblclick:function(grid,rowIndex,e)
    {
     val=grid.getStore().getAt(rowIndex).get('mfn');
     C_MfnField.setValue(val);
     Ext.Ajax.request
     ({
       url: Ext.HostUrl,
       params: {action: 'ChangeMfn', mfn:val},
       success: function(response){C_ChangeMfn();},
       scope: this
     });
    }
   }
//   height:200
 });

 C_RecListSearch=new Ext.grid.GridPanel
 ({
   store: C_RecListStoreSearch,
   autoShow:true,
   viewConfig: 
   {
     forceFit: true, autoFill:true
   },
   sm: new Ext.grid.CheckboxSelectionModel({singleSelect:false,width:20}),
   columns:
   [
    new Ext.grid.CheckboxSelectionModel({singleSelect:false,width:20}),
    {header: '#',width:20,dataIndex:'id',align:'right'},
    {header: 'mfn',width:20,dataIndex:'mfn',align:'right'},
    {header: 'Описание',dataIndex:'brief'}
   ],
   stripeRows: true,
//   autoSizeColumns:
   autoWidth:true,
   autoExpandColumn: 'id',
   listeners:
   {
    rowdblclick:function(grid,rowIndex,e)
    {
     val=grid.getStore().getAt(rowIndex).get('mfn');
     Ext.Ajax.request
     ({
       url: Ext.HostUrl,
       params: {action: 'ChangeMfn', mfn:val},
       success: function(response){C_ChangeMfn();},
       scope: this
     });
    }
   }
//   height:200
 });

 C_RecSelectorTab1=new Ext.Panel
 ({
   title:'Список записей',
   waitMsgTarget: true,
   tbar:
   [
    {
     text: '<<',
     tooltip: {title:'Переход', text:'К первому'}
    },
    {
     text: '<',
     tooltip: {title:'Переход', text:'К предыдущему'}
    },
    {
     text: '>',
     tooltip: {title:'Переход', text:'К следующему'}
    },
    {
     text: '>>',
     tooltip: {title:'Переход', text:'К последнему'}
    },
    '-',
    new Ext.Toolbar.TextItem('Mfn: '),
    C_MfnField,
    '-',
    {
     text: '<<=',
     tooltip: {title:'Переход по отмеченым', text:'К первому'}
    },
    {
     text: '<=',
     tooltip: {title:'Переход по отмеченым', text:'К предыдущему'}
    },
    {
     text: '=>',
     tooltip: {title:'Переход по отмеченым', text:'К следующему'}
    },
    {
     text: '=>>',
     tooltip: {title:'Переход по отмеченым', text:'К последнему'}
    }
   ],
   bbar: new Ext.PagingToolbar
   ({
     store: C_RecListStore,
     pageSize: 20,
     displayInfo: true,
     autoWidth:true,
     displayMsg: '{0} - {1} из {2}',
     emptyMsg: "Нет записей для показа"
   }),
   layout:'fit',
   items: [C_RecList] 
 });

 C_RecSelectorTab2=new Ext.Panel
 ({
   title:'Результаты поиска',
   waitMsgTarget: true,
   bbar: new Ext.PagingToolbar
   ({
     store: C_RecListStoreSearch,
     pageSize: 20,
     displayInfo: true,
     autoWidth:true,
     displayMsg: '{0} - {1} из {2}',
     emptyMsg: "Нет записей для показа"
   }),
   layout:'fit',
   items: [C_RecListSearch] 
 });

 C_RecSelector=new Ext.TabPanel
 ({
   split:true,
   region:'west',
   collapsible: true,
   title: 'Выбор текущей записи',
   width:420,
   minSize:420,
   activeTab: 0,
   //layout:'accordion',
   //layoutConfig:{animate:true,activeOnTop: true},
   items: 
   [
    C_RecSelectorTab1,
    C_RecSelectorTab2
   ]
 });

 var C_CurRecPft=new Ext.Panel
 ({
   autoLoad: Ext.HostUrl+'&action=ShowCurRecPft',
   title: 'Полное описание',
   autoScroll:true
 });
      
 function C_ChangeMfn()
 {
  //Ext.Msg.alert('Ok!');
  C_CurRecPft.load({url:Ext.HostUrl+'&action=ShowCurRecPft'});
  Ext.C_WS.load
  ({
    url:Ext.HostUrl+'&action=ShowCurWs',
    scope:this,
    scripts:true
  });
//  C_WS.getUpdater().refresh();
 };

 Ext.C_ChangeSearch=function (pref,term)
 {
//  Ext.Msg.alert(pref,term);
  C_RecSelector.setActiveTab(C_RecSelectorTab2);
  store=C_RecSelectorTab2.items.items[0].getStore();
  store.load({params:{Term:term,Pref:pref,start:0}});
 };


 viewport = new Ext.Viewport
 ({
   layout:'border',
   items: 
   [
    {
     region:'north',
     id:'MainMenuPanel',
     width: 200,
     minSize: 175,
     collapsible: true,
     margins:'0 0 0 5',
     layout:'accordion',
     layoutConfig:
     {
      animate:true
     },
     tbar:C_MainToolBar
    },
    new Irbis.SearchPanel
    ({
      region:'west',
      title:'Поиск записей',
      split:true,
      width: 250,
      minSize: 250,
      collapsible: true,
      margins:'0 0 0 5',
      irbisdb:15
    }),
    {
     region: 'south',
     split:true,
     height: 300,
     minSize: 100,
     collapsible: true,
     margins:'0 0 0 0',
     layout:'border',
     items: 
     [
      C_RecSelector,
      new Ext.TabPanel
      ({
        id: 'PftPanel',
        split: true,
        region: 'center',
        activeTab:0,
        items:
        [
         C_CurRecPft,
         new Ext.grid.PropertyGrid
         ({
           title: 'Связанные документы',
           closable: true,
           source: 
           {
            "(name)": "Properties Grid",
            "grouping": false,
            "autoFitColumns": true,
            "productionQuality": false,
            "created": new Date(Date.parse('10/15/2006')),
            "tested": false,
            "version": .01,
            "borderWidth": 1
           }
         }),
         {
          title:'Окно отладки',
          autoLoad: "c.php?action=Debug",
          text: "Загрузка...",
          autoScroll: true,
          border:false,
          iconCls:'settings'
         }
        ]
      })
     ]
    },
    Ext.C_WS
   ]
 });
});
