Irbis.K={version:Irbis.version};

Irbis.K.ARM=function(cfg)
{
 cfg=cfg||{};
 //cfg.irbDb=20;
 this.irbArm=cfg.arm;
 this.irbDb=cfg.irbDb;
 this.irbDbRdr=cfg.irbDbRdr;
 this.irbDbVuz=cfg.irbDbVuz;
 this.colcfg=cfg.colcfg;

 this.ModalRequest=Irbis.ModalRequest;
 this.LongRequest=Irbis.LongRequest;

 this.vuztreeColumns=[
    {
     header:'&nbsp;',
     width:600,
     dataIndex:'text'
    },
    {
     header:'Студентов',
     width:200,
     dataIndex:'stud'
    }
   ],

 //this.vuztreeLoader=new Ext.tree.TreeLoader
 this.vuztreeLoader=new Ext.ux.tree.TreeGridLoader
 ({
   //preBaseParams:{arm:this.irbArm,irbDb:this.irbDb,irbDbVuz:this.irbDbVuz,irbDbRdr:this.irbDbRdr},
   dataUrl:'../K/vuztreeLoader.php',
   baseParams:{arm:this.irbArm,irbDb:this.irbDb,irbDbVuz:this.irbDbVuz,irbDbRdr:this.irbDbRdr},
   columns:this.vuztreeColumns,
   listeners:
   {
    beforeload:function(tree,node)
    {
     //this.baseParams=this.preBaseParams;
     //Ext.apply(this.baseParams,node.attributes);
     this.baseParams.cat = node.attributes.cat;
     this.baseParams.fo = node.attributes.fo;
     this.baseParams.fak = node.attributes.fak;
     this.baseParams.sem = node.attributes.sem;
     this.baseParams.spec = node.attributes.spec;
     this.baseParams.napr = node.attributes.napr;
     this.baseParams.vo = node.attributes.vo;
     this.baseParams.level = node.attributes.level;
     this.baseParams.disc = node.attributes.disc;
     this.baseParams.tl = node.attributes.tl;
     this.baseParams.headanalog = node.attributes.headanalog;
     this.baseParams.rdrgroup = node.attributes.rdrgroup;
     this.baseParams.uplType=this.uplType;
    }
   }
 });

 this.vuztreeLoader.leaftype='disc';

 this.bChangeCode={text: 'Изменить код',handler:function(){this.fnChangeCode();},scope:this};
 this.bEdit={text: 'Редактировать',iconCls:'irb-edit',handler:function(){this.fnEdit();},scope:this};
 this.bLinkDestroy={text: 'Разорвать связь',iconCls:'irb-delete',handler:function(){this.fnLinkDestroy();},scope:this};

 this.vuztreeMenu=new Ext.menu.Menu
 ({
   items:
   [
    {
     text: 'Скрыть/отобразить уровень',
     menu:
     {
      items:
      [
       {text: 'Форма обучения',iconCls:'irb-kofo'},
       {text: 'Факультет',iconCls:'irb-kofak'},
       {text: 'Семестр',iconCls:'irb-kosem'},
       {text: 'Специальность',iconCls:'irb-kospec'},
       {text: 'Направление',iconCls:'irb-konapr'},
       {text: 'Вид обучения',iconCls:'irb-kovo'}
      ]
     }
    },
    this.bChangeCode,
    this.bEdit,
    '-',
    {text: 'Разорвать связь',iconCls:'irb-delete'}
   ],
   scope:this
 });

 this.vuztreeSelectionModel=new Ext.tree.DefaultSelectionModel({});

 this.VuzTree=new Ext.ux.tree.TreeGrid
// this.VuzTree=new Ext.tree.TreePanel
 ({
   tbar:['tbar'],
   region:'center',
   forceFit:true,
   title:'Контингент',
   layout:'fit',
   useArrows: true,
   autoScroll: true,
   animate: true,
   containerScroll: true,
   border: false,
   rootVisible:false,
   loader:this.vuztreeLoader,
   selModel:this.vuztreeSelectionModel,
   columns:this.vuztreeColumns,
   enableSort:false,
   listeners:
   {
    ndblclick:function(opt)
    {
     var src="";
     var t="";
     t=opt.node.attributes.fak; if ((typeof(t)!="undefined")&&(t!="")) src+=' (F) "FAK='+t+'"';
     t=opt.node.attributes.fo; if ((typeof(t)!="undefined")&&(t!="")) src+=' (F) "FO='+t+'"';
     t=opt.node.attributes.vo; if ((typeof(t)!="undefined")&&(t!="")) src+=' (F) "VO='+t+'"';
     t=opt.node.attributes.sem; if ((typeof(t)!="undefined")&&(t!="")) src+=' (F) "SEM='+t+'"';
     t=opt.node.attributes.napr; if ((typeof(t)!="undefined")&&(t!="")) src+=' (F) "NAPR='+t+'"';
     t=opt.node.attributes.spec; if ((typeof(t)!="undefined")&&(t!="")) src+=' (F) "SPEC='+t+'"';
     t=opt.node.attributes.disc; if ((typeof(t)!="undefined")&&(t!="")) src+=' (F) "DISC='+t+'"';
     src=src.substring(5);
     this.reclist.MakeSearch(src);
    },
    'contextmenu': this.onvuztreeMenuShow,
    scope:this
   },
   split:true
 });

 this.disctreeLoader=new Ext.tree.TreeLoader
 ({
   dataUrl:'../K/disctreeLoader.php',
   baseParams:{arm:this.irbArm,irbDb:this.irbDbVuz},
   listeners:
   {
    beforeload:function(tree,node)
    {
     this.baseParams.cat = node.attributes.cat;
     this.baseParams.wstab = node.attributes.wstab;
     this.baseParams.occstart = node.attributes.occstart;
     this.baseParams.occend = node.attributes.occend;
     this.baseParams.fldno = node.attributes.fldno;
     this.baseParams.occ = node.attributes.occ;
     this.baseParams.dopinf = node.attributes.dopinf;
    }
   }
 });

 this.disctree=new Ext.tree.TreePanel
 ({
   title:'Кафедры-дисциплины',
   uplType:'disc',
   useArrows: true,
   autoScroll: true,
   animate: true,
   containerScroll: true,
   border: false,
   rootVisible:false,
   loader:this.disctreeLoader,
   //keys:{key:113,fn:this.handleF2,scope:this},
   selModel:new Ext.tree.DefaultSelectionModel({}),
   root:
   {
    nodeType: 'async',
    text: 'Ext JS',
    cat:'root',
    id: 'root'
   },
   layout:'fit'
 });

 this.bookpriv=new Irbis.SearchPanel
 ({
   layout:'fit',
   uplType:'books',
   title:'Привязка литературы',
   hideComplex:true,
   irbDb:cfg.irbDb,
   listeners:
   {
    onTermSelected:function(opt)
    {
     if (opt.src=='')
      this.reclist.MakeSearch('("'+opt.pref+opt.term+'")','',this.colcfg);
     else
      this.reclist.MakeSearch(opt.src,'',this.colcfg);
    },
    scope:this
   }
 });

 this.tab=new Ext.TabPanel
 ({
   region:'center',
   activeTab: 0,
   items:[this.disctree,this.bookpriv],
   //title:'Дисциплины',
   tabPosition:'bottom',
   listeners:
   {
    tabchange:this.onTabChange,
    scope:this
   },
   split:true
 });

 this.tabpanel=new Ext.Panel
 ({
   region:'west',
   width:400,
   items:[this.tab],
   title:'Сервисная панель',
   layout:'fit',
   border: false,
   split:true
 });


 this.UPan=new Ext.Panel
 ({
   layout:'border',
   region:'center',
   items:[this.tabpanel,this.VuzTree]
 });

 this.m_DbSelector=new Irbis.DbSelector({arm:this.irbArm,xtype:'combo',
   allowBlank: false,
   editable: false,
   fieldLabel: 'БД',
   anchor: '100%',
   listeners:
   {
    select:function(combo,record,index)
    {
     this.changeRecListDb(record.get('irbDb'),record.get('options'));
    },
    scope:this
   }
 });

 this.m_PftSelector=new Irbis.PftSelector
 ({
   autoLoad:true,
   valueNotFoundText:'Оптимизированный',
   arm:cfg.arm,
   dbid:cfg.irbDb,
   xtype:'combo',
   allowBlank: false,
   editable: false,
   fieldLabel: 'БД',
   anchor: '100%',
   listeners:
   {
    select:function(combo,record,index)
    {
     //alert(record.get('key'));
     var f=record.get('key');
     if (f=='@')
      this.reclist.ChangeFullFmt(f);
     else
      this.reclist.ChangeFullFmt('@'+f);
    },
    scope:this
   }
 });

 this.bLinkIbis=new Ext.Button
 ({
   text:'Привязать отмеченные издания к контингенту',
   hidden:true,
   handler:this.fnLinkIbis,
   scope:this
 })

 this.reclist=new Irbis.RecListPanel128({irbDb:this.irbDb});

 this.reclist.grid.getSelectionModel().on('selectionchange',this.fnReclistSelectionChange,this);

 this.recs=new Ext.Panel({region:'south',tbar:[this.bLinkIbis,'-','Формат просмотра: ',this.m_PftSelector],items:[this.reclist],title:'Связанные записи',height:250,split:true,layout:'fit'});

 this.Pan=new Ext.Panel
 ({
   layout:'border',
   tbar:
   [
    'БД: ',this.m_DbSelector,
    '->',
    {iconCls:'irb-logout',text:'<b>Выход</b>'}
   ],
   items:[this.UPan,this.recs]
 });

 cfg.layout='fit';
 cfg.items=[this.Pan];
 Irbis.K.ARM.superclass.constructor.call(this,cfg);
 var task = 
 {
  run: function()
  {
   Ext.Ajax.request
   ({
     url: '../K/k.php',
     params: { arm: cfg.irbArm, action:'Noop' }
   });
  },
  interval: 60000 //1 min
 };
 runner = new Ext.util.TaskRunner();
 runner.start(task);
}

Ext.extend(Irbis.K.ARM,Ext.Viewport,
{

 fnChangeCode:function()
 {
  var node=this.vuztreeMenu.contextNode;
  var attr=node.attributes;
  var dta='';
  switch (attr.cat)
  {
   case 'fo': dta=attr.fo; break;
   case 'fak': dta=attr.fak; break;
   case 'sem': dta=attr.sem; break;
   case 'spec': dta=attr.spec; break;
   case 'napr': dta=attr.napr; break;
   case 'vo': dta=attr.vo; break;
   default: dta='undef'; break;
  }
  alert("Change code "+dta);
 },

 fnEdit:function()
 {
 },

 fnLinkDestroy:function()
 {
 },

 fnReclistSelectionChange:function(sm)
 {
  this.bLinkIbis.setVisible((this.reclist.grid.getSelectionModel().hasSelection())&&(this.reclist.irbDb==this.irbDb));
 },

 changeRecListDb:function(irbDb,opt)
 {
  this.reclist.ChangeDb(irbDb);
  this.m_PftSelector.ChangeDb(irbDb);
  this.bookpriv.fnChangeDb(irbDb);
 },

 DoRecListRequest:function(rqst,opt)
 {
  var o=opt;
  var mfns=this.GetSelectedMfnsArr();
  Ext.apply(o,
  {
   irbArm:this.irbArm,
   irbDb:this.irbDb,
   irbDbVuz:this.irbDbVuz,
   irbDbRdr:this.irbDbRdr,
   'mfns[]':mfns
  });
  this.LongRequest(o,'../K/'+rqst+'.php');
 },

 GetSelectedMfnsArr:function()
 {
  s=this.reclist.grid.getSelectionModel().getSelections();
  var shl=new Array();
  for(var i = 0, len = s.length; i < len; i++)
  {
   var mfn=s[i].get('mfn');
   if (mfn!='') shl[shl.length]=mfn;
  }
  return shl;
 },

 fnLinkIbis:function()
 {
  var opt={test:'1'};
  this.DoRecListRequest("LinkIbis",opt);
 },

 onTabChange:function(tabpanel,tab)
 {
  //this.vuztreeLoader.uplType=tab.uplType;
  //this.vuztreeLoader.load(this.VuzTree.getRootNode());
 },

 onvuztreeMenuShow:function(node,e)
 {
  node.select();
  this.vuztreeMenu.contextNode = node;
  this.vuztreeMenu.showAt(e.getXY());
 }
});