<?php

require_once (dirname(__FILE__).'/k.php');
require_once (dirname(__FILE__).'/../classes/mnu.php');

$irbDb=$_REQUEST['irbDb'];
$irbDbVuz=$_REQUEST['irbDbVuz'];
$irbDbRdr=$_REQUEST['irbDbRdr'];
$irbRec=$_REQUEST['irbRec'];
$cat=$_REQUEST['cat'];
$armid=$_REQUEST['arm'];

$arm=new k($armid);

$srcdat=
array(
 'fo'=>array('mnu'=>'FO.MNU','subf'=>'O','cls'=>'irb-kofo','pref'=>'VFO=','prefIbis'=>'FO=','subfRdr'=>'O','prefRdr'=>'FO='),
 'fak'=>array('mnu'=>'FAK.MNU','subf'=>'A','cls'=>'irb-kofak','pref'=>'VFAK=','prefIbis'=>'FAK=','subfRdr'=>'A'),
 'sem'=>array('mnu'=>'','subf'=>'F','cls'=>'irb-kosem','pref'=>'VSEM=','prefIbis'=>'SEM=','subfRdr'=>'F'),
 'spec'=>array('mnu'=>'SPEC.MNU','subf'=>'C','cls'=>'irb-kospec','pref'=>'VSPEC=','prefIbis'=>'SPEC=','subfRdr'=>'C'),
 'napr'=>array('mnu'=>'NAPR.MNU','subf'=>'N','cls'=>'irb-konapr','pref'=>'VNAPR=','prefIbis'=>'NAPR=','subfRdr'=>'N'),
 'vo'=>array('mnu'=>'VO.MNU','subf'=>'V','cls'=>'irb-kovo','pref'=>'VVO=','prefIbis'=>'VO=','subfRdr'=>'V')
);

$srcdir=array('fo','fak','sem','spec','napr','vo');
//$srcdir=array('vo','spec');

function CreateRqst()
{
 $pars=array('fo'=>'VFO=','fak'=>'VFAK=','sem'=>'VSEM=','spec'=>'VSPEC=','napr'=>'VNAPR=','vo'=>'VVO=');
 $res='"VD=VUZ"';
 foreach($pars as $par=>$pref)
 {
  if (($_REQUEST[$par]!='')&&($_REQUEST[$par]!='******')) $res.='*"'.$pref.$_REQUEST[$par].'"';
 }
// $res=trim($res,'*');
// if ($res=='') 
// echo $res;
 return $res;
}

function CreateRqstIbis()
{
 $pars=array('fo'=>'FO=','fak'=>'FAK=','sem'=>'SEM=','spec'=>'SPEC=','napr'=>'NAPR=','vo'=>'VO=');
 foreach($pars as $par=>$pref)
 {
  if ($_REQUEST[$par]!='') $res.=' (F) "'.$pref.$_REQUEST[$par].'"';
 }
 return trim($res,' (F) ');
}

function CreateRqstRdr($cat='',$val='')
{
 $pars=array('fo'=>'FO=','fak'=>'FAK=','sem'=>'SEM=','spec'=>'SPEC=','napr'=>'NAPR=','vo'=>'VO=','rdrgroup'=>'GR=','disc'=>'NDUN=');
 foreach($pars as $par=>$pref)
 {
  if (($_REQUEST[$par]!='')&&($_REQUEST[$par]!='******')) $res.='*"'.$pref.$_REQUEST[$par].'"';  
 }
 if (($cat!='')&&($_REQUEST[$cat]=='')) $res.='*"'.$pars[$cat].$val.'"';
 return trim($res,'*');
}


function AppendParam($param)
{
 if (isset($_REQUEST[$param])) return ',"'.addslashes($param).'":"'.addslashes($_REQUEST[$param]).'"';
 return '';
}

function CheckRdrOccPar($r,$occ,$sf,$key)
{
 if ($_REQUEST['key']=='') return true;
 return (mb_strtoupper($r->GetSubField(90,$occ,$sf))==mb_strtoupper($_REQUEST[$key]));
}

function GetRdrOcc(Record $r)
{
 for ($i=1; $i<=$r->GetFieldOcc(90);$i++)
 {
  $res=CheckRdrOccPar($r,$i,'A','fak') && CheckRdrOccPar($r,$i,'V','vo') && CheckRdrOccPar($r,$i,'O','fo') && CheckRdrOccPar($r,$i,'C','spec') && CheckRdrOccPar($r,$i,'V','vo') && CheckRdrOccPar($r,$i,'F','sem');
  if ($res) return $i;
 }
 return 0;
}

function GetNodeParams()
{
 $res='';
 $pars=array('fo','fak','sem','spec','napr','vo','tl','disc');
 foreach($pars as $par) $res.=AppendParam($par);
 return $res;
}

function GetNotInStructArrayRdr($arr,$r)
{
 global $srcdat;
 global $srcdir;
 $cat=$srcdir[$_REQUEST['level']+1];
 //echo 'cat: '.$cat."\n";
 $occs=$r->GetFieldOcc(90);
 for ($i=1;$i<=$occs;$i++)
 {
  $sd=$r->GetSubField(90,$i,$srcdat[$cat]['subfRdr']);
  if ($sd=='') $sd='(Пусто)';
  if (!isset($arr[$sd]))
  {
   $pres=true;
   foreach ($srcdat as $ccat=>$dta)
   {
    if (($_REQUEST[$ccat]!='')&&(mb_strtoupper($r->GetSubField(90,$i,$dta['subfRdr']))!=mb_strtoupper($_REQUEST[$ccat]))) $pres=false;
    else echo mb_strtoupper($r->GetSubField(90,$i,$dta['subfRdr'])).'='.mb_strtoupper($_REQUEST[$ccat]).', ccat='.$ccat."\n";
   }
   if ($pres) $arr[$sd]++;
  }
 }
 return $arr;
}

function LoadNodes68($level)
{
 global $srcdir;
 global $srcdat;
 global $arm;
 global $irbDbVuz;
 global $irbDbRdr;
 $res='';
 $cat=$srcdir[$level];

  switch($_REQUEST['cat'])
  {
   case $srcdir[$level-1]: LoadDiscNodes($level); die(); break;
   case 'rdrs': LoadRdrGroupNodes($level); die(); break;
   case 'rdrgroup': LoadRdrNodes($level); die(); break;
   case 'disc': LoadTlNodes($level); die(); break;
   case 'tl': LoadBooksNodes($level); die(); break;
   case 'book': LoadBooksNodes($level); die(); break;
   case 'rdrns': LoadRdrNsNodes($level); die(); break;
  }
 if (($cat=='')&&($_REQUEST['cat']==$srcdir[$level-1])) LoadDiscNodes($level); 
 $mnu=$srcdat[$cat]['mnu'];
 $subf=$srcdat[$cat]['subf'];
 $cls=$srcdat[$cat]['cls'];
 $db=new DB($irbDbVuz);
 $dbrdr=new DB($irbDbRdr);

 $recs=$db->FindRecords(CreateRqst(),'',0,1);
 if (!is_array($recs)) return '';
 if ($recs[0]<1) return '';
 $sems=array();
 $m=new mnu(0);
 if ($mnu!='') $m->LoadMnu($irbDbVuz,$mnu);
 for ($i=1;$i<=$recs[0];$i++)
 {
  $cd=mb_strtoupper($recs[$i]->GetSubField(68,1,$subf),'utf-8');
  $cdk='';
  if ($cd!='') $cdk=$m->GetDescByKeyNCase($cd).' ('.$cd.')';
  $k='';
  if ($mnu!='') $k=$cdk;
  else $k=$cd;
  if ($k=='') $k='(ВСЕ)';
  $sems[$k]=$cd;
 }
 ksort($sems);
 $wct=0;
 $parsRdr=array('fo'=>'FO=','fak'=>'FAK=','sem'=>'SEM=','spec'=>'SPEC=','napr'=>'NAPR=','vo'=>'VO=','rdrgroup'=>'GR=','disc'=>'NDUN=');
 $src=CreateRqstRdr();
 if ($src=='') $src='("'.$srcdat[$srcdir[0]]['prefRdr'].'$")';
 foreach($sems as $desc=>$sem)
 {
  if ($wct>0) $res.=','; $wct++;
  $rrecs=$dbrdr->FindRecords(CreateRqstRdr($cat,$sem),'',0,0);
  $res.='{listeners:{dblclick:function(n){n.getOwnerTree().fireEvent("ndblclick",{"node":n})},load:function(n){if (n.childNodes.length==1) n.childNodes[0].expand();}},nodetype:"async",level:"'.($level).'",iconCls:"'.$cls.'",editable:false,text:"'.addslashes($desc).'",cat:"'.$cat.'"'.GetNodeParams().','.$cat.':"'.addslashes($sem).'",stud:'.$rrecs[0].'}';
  $src.='^("'.$parsRdr[$cat].$sem.'")';
 }
 $rrecs=$dbrdr->FindRecords($src,'',1,1);
 $cnt=$rrecs[0];
 $dbrdr->FindRecordsClearResult($rrecs);
 $nscaption='ЧИТАТЕЛИ ВНЕ СТРУКТУРЫ';
// $nscaption=$src;
 if ($cnt>0) $res.=',{listeners:{dblclick:function(n){n.getOwnerTree().fireEvent("ndblclick",{"node":n})},load:function(n){if (n.childNodes.length==1) n.childNodes[0].expand();}},nodetype:"async",level:"'.($level-1).'",iconCls:"irb-usrlist",editable:false,text:"<b>'.addslashes($nscaption).'</b>",cat:"rdrns"'.GetNodeParams().',stud:'.$cnt.'}';
 $db->FindRecordsClearResult($recs);
 $m->Dispose($m->GetId());
 return $res; 
}

function LoadDiscNodes($level)
{
 global $vuzdbnam;
 global $arm;
 global $irbDbVuz;
 global $irbDbRdr;
 $dbrdr=new DB($irbDbRdr);
 $db=new DB($irbDbVuz);
 $recs=$db->FindRecords(CreateRqst(),'',1000,1);
 $recs=$db->FindRecords('VD=VUZ','',1000,1);
 
 if (!is_array($recs)) die('[]');
 if ($recs[0]<1) die('[]');
 $m=new mnu(0);
 $m->LoadMnu($irbDbVuz,'DISC.MNU');
 $sems=array();
 $vo=mb_strtoupper($_REQUEST['vo'],'utf-8');
 $spec=mb_strtoupper($_REQUEST['spec'],'utf-8');
 for ($i=1;$i<=$recs[0];$i++)
 {
  if ((($vo=='')||(mb_strtoupper($recs[$i]->GetSubField(68,1,'V'),'utf-8')==$vo)) && 
      (($spec=='')||(mb_strtoupper($recs[$i]->GetSubField(68,1,'C'),'utf-8')==$spec)))
  {
   for ($occ=1;$occ<=$recs[$i]->GetFieldOcc(69);$occ++)
   {
    $sems[$recs[$i]->GetSubField(69,$occ,'W')]=$m->GetDescByKeyNCase($recs[$i]->GetSubField(69,$occ,'D')).' ('.$recs[$i]->GetSubField(69,$occ,'W').')';
   }
  }
  $str='';
  $pars='';
 }
 ksort($sems);
 $wct=0;
 $rrecs=$dbrdr->FindRecords(CreateRqstRdr(),'',0,0);
 $res='[{nodetype:"async",level:"'.$level.'",iconCls:"irb-usrlist",editable:false,listeners:{load:function(n){if (n.childNodes.length==1) n.childNodes[0].expand();}},text:"<b>СТУДЕНТЫ</b>",cat:"rdrs"'.GetNodeParams().',stud:'.$rrecs[0].'}';
 foreach($sems as $key=>$val)
 {
  $res.=',';
  $res.='{nodetype:"async",level:"'.$level.'",iconCls:"irb-kodisc",editable:false,text:"'.addslashes($val).'",cat:"disc"'.GetNodeParams().',disc:"'.addslashes($key).'",stud:'.$rrecs[0].'}';
 }
 $res.=']';
 $db->FindRecordsClearResult($recs);
 $m->Dispose($m->GetId());
 die($res); 
}

function LoadTlNodes($level)
{
 global $irbDb;
 global $arm;
 $db=new DB($irbDb);
 $disc=mb_strtoupper($_REQUEST['disc']);
 $recs=$db->FindRecords('NDUN='.$disc,'',1000,1);
 if (!is_array($recs)) die('[]');
 if ($recs[0]<1) die('[]');
 $sems=array();
 $m=new mnu(0);
 $m->LoadMnu($irbDb,'691G.MNU');
 for ($i=1;$i<=$recs[0];$i++)
 {
  $occ=$recs[$i]->GetFieldOcc(691);
  for ($j=1;$j<=$occ;$j++)
  {
   if (mb_strtoupper($recs[$i]->GetSubField(691,$j,'W'))==$disc)
    $sems[$m->GetDescByKeyNCase($recs[$i]->GetSubField(691,$j,'G'))]=$recs[$i]->GetSubField(691,$j,'G');
  }
 }
 $m->Dispose($m->GetId());
 ksort($sems);
 $wct=0;
 $res='[';
 foreach($sems as $val=>$key)
 {
  if ($wct>0) $res.=','; $wct++;
  $res.='{nodetype:"async",level:"'.$level.'",iconCls:"irb-bookopen",editable:false,text:"'.addslashes($val).'",cat:"tl"'.GetNodeParams().',tl:"'.addslashes($key).'"}';
 }
 $res.=']';
 $db->FindRecordsClearResult($recs);
// $m->Dispose($m->GetId());
 die($res); 
}

function IsKoAnalogBook(Record $r,$id='')
{
 $o=$r->GetFieldOcc(699);
 if ($o==0) return FALSE;
 for ($i=1;$i<=$o;$i++) if ($r->GetSubField(699,$o,'U')=='1') return FALSE;
 if ($id=='') return TRUE;
 for ($i=1;$i<=$o;$i++) if ($r->GetSubField(699,$o,'W')==$id) return TRUE;
 return FALSE;
}

function IsKoGenBook(Record $r)
{
 $o=$r->GetFieldOcc(699);
 if ($o==0) return FALSE;
 for ($i=1;$i<=$o;$i++) if ($r->GetSubField(699,$o,'U')=='1') return TRUE;
 return FALSE;
}

function LoadBooksNodes($level)
{
 global $irbDb;
 global $arm;
 $db=new DB($irbDb);
 $src='"NDUN='.$_REQUEST['disc'].'" (F) "TL='.$_REQUEST['tl'].'"';
 if ($_REQUEST['headanalog']!='') $src.='*"I='.$_REQUEST['headanalog'].'"';
 $recs=$db->FindRecords($src,'',1000,1);
 if (!is_array($recs)) die('[]');
 if ($recs[0]<1) die('[]');
 $sems=array();
 for ($i=1;$i<=$recs[0];$i++)
 {
  $r=$recs[$i];
  $dta=array('mfn'=>$r->GetMfn(),'leaf'=>TRUE);
  if (IsKoGenBook($r))
  {
   $dta['leaf']=FALSE;
   $dta['headanalog']=$r->GetField(903,1);
  }
  if ((!IsKoAnalogBook($r))&&($_REQUEST['headanalog']=='')) $sems[$r->GetBrief($db->GetId())]=$dta;
  else if (IsKoAnalogBook($r,$_REQUEST['headanalog'])) $sems[$r->GetBrief($db->GetId())]=$dta;
 }
 ksort($sems);
 $wct=0;
 $res='[';
 foreach($sems as $val=>$key)
 {
  if ($wct>0) $res.=','; $wct++;
  $res.='{nodetype:"async",level:"'.$level.'",iconCls:"irb-bookopen",leaf:'.($key['leaf']?'true':'false').',editable:false,text:"'.addslashes($val).'",cat:"book"'.GetNodeParams().',headanalog:"'.addslashes($key['headanalog']).'"}';
 }
 $res.=']';
 $db->FindRecordsClearResult($recs);
// $m->Dispose($m->GetId());
 die($res); 
}

function LoadRdrGroupNodes($level)
{
 global $irbDbRdr;
 global $arm;
 $db=new DB($irbDbRdr);
 $recs=$db->FindRecords(CreateRqstRdr(),'',1000,1);
 if (!is_array($recs)) die('[]');
 if ($recs[0]<1) die('[]');
 $sems=array();
 for ($i=1;$i<=$recs[0];$i++)
 {
  $r=$recs[$i];
  $j=GetRdrOcc($r);
  $brief='';
  if($j>0) $brief='Группа  '.$r->GetSubField(90,$j,'E');
  else $brief='(Пусто)';
  $sems[$brief]=$r->GetSubField(90,$j,'E');;
 }
 ksort($sems);
 $wct=0;
 $res='[';
 foreach($sems as $val=>$key)
 {
  if ($wct>0) $res.=','; $wct++;
  $res.='{nodetype:"async",level:"'.$level.'",iconCls:"irb-usrlist",editable:false,text:"'.addslashes($val).'",cat:"rdrgroup"'.GetNodeParams().',rdrgroup:"'.addslashes($key).'"}';
 }
 $res.=']';
 $db->FindRecordsClearResult($recs);
 die($res); 
}

function LoadRdrNodes($level)
{
 global $irbDbRdr;
 global $arm;
 $db=new DB($irbDbRdr);
 $recs=$db->FindRecords(CreateRqstRdr(),'',1000,1);
 if (!is_array($recs)) die('[]');
 if ($recs[0]<1) die('[]');
 $sems=array();
 $cnt=1;
 for ($i=1;$i<=$recs[0];$i++)
 {
  $r=$recs[$i];
  $j=GetRdrOcc($r);
  $brief=$r->GetField(10,1).' '.$r->GetField(11,1).' '.$r->GetField(12,1);
  //if($j>0) $brief.=' (группа '.$r->GetSubField(90,$j,'E').')';
  //str_replace("\r",'',str_replace("\n",'',$db->RecVirtualFormat("&uf('6brief')",$recs[$i])))
  $sems[$brief]=$recs[$i]->GetMfn();
 }
 ksort($sems);
 $wct=0;
 $res='[';
 foreach($sems as $val=>$key)
 {
  if ($wct>0) $res.=','; $wct++;
  $res.='{nodetype:"async",level:"'.$level.'",iconCls:"irb-usrlist",leaf:true,editable:false,text:"'.$cnt.'. '.addslashes($val).'",cat:"rdr"'.GetNodeParams().',rdr:"'.addslashes($key).'"}';
  $cnt++;
 }
 $res.=']';
 $db->FindRecordsClearResult($recs);
// $m->Dispose($m->GetId());
 die($res); 
}

function LoadRdrNsNodes($level)
{
 global $irbDbRdr;
 global $irbDbVuz;
 global $arm;
 global $srcdir;
 global $srcdat;

 $res='';
 $cat=$srcdir[$level];
 $subf=$srcdat[$cat]['subf'];
 $cls=$srcdat[$cat]['cls'];
 $db=new DB($irbDbVuz);
 $dbrdr=new DB($irbDbRdr);

 $recs=$db->FindRecords(CreateRqst(),'',0,1);
 if (!is_array($recs)) return '[]';
 if ($recs[0]<1) return '[]';
 $sems=array();
 $m=new mnu(0);
 if ($mnu!='') $m->LoadMnu($irbDbVuz,$mnu);
 for ($i=1;$i<=$recs[0];$i++)
 {
  $cd=mb_strtoupper($recs[$i]->GetSubField(68,1,$subf),'utf-8');
  $cdk='';
  if ($cd!='') $cdk=$m->GetDescByKeyNCase($cd).' ('.$cd.')';
  $k='';
  if ($mnu!='') $k=$cdk;
  else $k=$cd;
  if ($k=='') $k='(ВСЕ)';
  $sems[$k]=$cd;
 }
 ksort($sems);
 $wct=0;
 $parsRdr=array('fo'=>'FO=','fak'=>'FAK=','sem'=>'SEM=','spec'=>'SPEC=','napr'=>'NAPR=','vo'=>'VO=','rdrgroup'=>'GR=','disc'=>'NDUN=');
 $src=CreateRqstRdr();
 if ($src=='') $src='("'.$srcdat[$srcdir[0]]['prefRdr'].'$")';
 foreach($sems as $desc=>$sem)
 {
  if ($wct>0) $res.=','; $wct++;
  $rrecs=$dbrdr->FindRecords(CreateRqstRdr($cat,$sem),'',0,0);
  $res.='{listeners:{dblclick:function(n){n.getOwnerTree().fireEvent("ndblclick",{"node":n})},load:function(n){if (n.childNodes.length==1) n.childNodes[0].expand();}},nodetype:"async",level:"'.($level).'",iconCls:"'.$cls.'",editable:false,text:"'.addslashes($desc).'",cat:"'.$cat.'"'.GetNodeParams().','.$cat.':"'.addslashes($sem).'",stud:'.$rrecs[0].'}';
  $src.='^("'.$parsRdr[$cat].$sem.'")';
 }
 $db->FindRecordsClearResult($recs);
 $recs=$dbrdr->FindRecords($src,'',1000,1);


 ///////////////////////////////////////
 /*$db=new DB($irbDbRdr);
 $src=CreateRqstRdr();
 foreach($sems as $desc=>$sem)
 {
  $src.=' ^ "'.$parsRdr[$cat].$sem.'"';
 }
 $recs=$db->FindRecords($src,'',1000,1);*/

 if (!is_array($recs)) die('[]');
 if ($recs[0]<1) die('[]');
 $sems=array();
 $cnt=1;
 for ($i=1;$i<=$recs[0];$i++)
 {
  $r=$recs[$i];
  $j=GetRdrOcc($r);
  $brief=$r->GetField(10,1).' '.$r->GetField(11,1).' '.$r->GetField(12,1).' - (значение: '.$r->GetSubField(90,1,$subf).', Кат: '.$r->GetField(50,1).', тип записи: '.$r->GetField(920,1).')';
  $sems[$brief]=$recs[$i]->GetMfn();
 }
 ksort($sems);
 $wct=0;
 $res='[';
 foreach($sems as $val=>$key)
 {
  if ($wct>0) $res.=','; $wct++;
  $res.='{nodetype:"async",level:"'.$level.'",iconCls:"irb-usrlist",leaf:true,editable:false,text:"'.$cnt.'. '.addslashes($val).'",cat:"rdr"'.GetNodeParams().',rdr:"'.addslashes($key).'"}';
  $cnt++;
 }
 $res.=']';
 $db->FindRecordsClearResult($recs);
// $m->Dispose($m->GetId());
 die($res); 
}

$level=$_REQUEST['level'];
if ($level=='') $level=-1;

$res=LoadNodes68($level+1);
if ($res!='') die('['.$res.']');


?>