Ext.BLANK_IMAGE_URL = 'resources/images/default/s.gif';

Ext.onReady(function(){

    Ext.QuickTips.init();

    // turn on validation errors beside the field globally
    Ext.form.Field.prototype.msgTarget = 'side';

    var fs = new Ext.FormPanel({
        frame: true,
        labelAlign: 'right',
        labelWidth: 85,
        width:340,
        waitMsgTarget: true,
        defaults:{width:190},

        defaultType: 'textfield',
        items: [{
                        fieldLabel: 'Логин',
                        name: 'Login',
                        allowBlank:false,
                        blankText:'Логин обязательно должен быть введен'
                    }, {
                        fieldLabel: 'Пароль',
                        name: 'Password',
                        allowBlank:true,
                        inputType: 'password'
                    },new Ext.form.ComboBox({
                        allowBlank: false,
                        blankText:'Не выбран АРМ для входа',
                        editable: false,
                        store: new Ext.data.SimpleStore({
                          fields: ['ARM','ARM_Name'],
                          data : [['C','Каталогизатор'],['B','Книговыдача'],['R','Читатель'],['K','Книгообеспеченность']] // from states.js
                          }),
                        fieldLabel: 'АРМ',
                        name: 'ARM',
                        displayField:'ARM_Name',
                        valueField:'ARM',
                        hiddenName:'ARM',
                        typeAhead: true,
                        mode: 'local',
                        triggerAction: 'all',
                        emptyText:'Выберите АРМ...',
                        selectOnFocus:true
                        })
                ]
    });

    // explicit add
    var submit = fs.addButton({
        text: 'Войти',
        handler: function(){
              fs.form.submit({
                     url:'Login.php', 
                     success: function(form,action)
                      {
                        action.result.retaction();
                      },
                      failure: function(form,action)
                      {
                        action.result.retaction();
                      },
                     waitMsg:'Осуществляется вход...'
                     });
        }
    });

    var w = new Ext.Window({
        resizable: false,
        closable: false,
        x:50,
        y:50,
        title:'<center>'+Ext.lic+'</center><hr size="1px" color=#333399><center>Вход в систему</center>',
        labelAlign: 'right',
        labelWidth: 85,
        width:340,
        waitMsgTarget: true,

        items: [ fs ]
    });

    w.show('form-ct');

    Ext.i128wucb=function(el,success,response,options)
    {
     if ((!success)&&(response.status==0))
     {
      Ext.i128wu.close();
      return;
     }
     if (!success)
     {
      Ext.i128wu.setTitle('<center>Ошибка при проверке наличия новой версии: '+response.statusText+'</center>');
      return;
     }
     if ((success)&&(response.responseText==''))
     {
      Ext.i128wu.close();
     }
     else
     {
      Ext.i128wu.setTitle('<center>Появилась новая версия продукта</center>');
     }
    }

    Ext.i128wu = new Ext.Window({
        resizable: false,
        closable: false,
        x:400,
        y:50,
        title:'<center>Поиск новой версии...</center>',
        labelAlign: 'right',
        labelWidth: 85,
        width:440,
        waitMsgTarget: true
    });

    Ext.i128wu.show();

    Ext.i128wu.load({
        url: 'verinfo.php',
        params: {ver: Ext.i128ver,org:Ext.lic,guid:Ext.i128guid}, // or a URL encoded string
        callback: Ext.i128wucb,
        discardUrl: false,
        nocache: true,
        text: 'Загрузка...',
        timeout: 30,
        scripts: false
    });
 
});
