<?php 

require_once(dirname(__FILE__) . '/OM.php');
require_once(dirname(__FILE__) . '/Record.php');
require_once(dirname(__FILE__) . '/Ini.php');
require_once(dirname(__FILE__) . '/DummyDP.php');

define ('DPjirbDBG',0);



class DP_jirb extends DummyDP
{
//    var $host;
//    var $port;
//    var $login;
//    var $pw;
//    var $IsConnected;
//    var $cfg;
//    var $db;
//    var $odb; //owner db config
//    var $timeout;
//    var $dbcfg;
//    var $remotecp;
//    var $mode;
//    var $z21id;
//    var $termpreg;
//    var $termpregcolrefs;
//    var $termpregcolterms;
//    var $fmt;
//    var $option;
//    var $Itemid;
    
    function DP_jirb($id)
    {
     $this->OM($id,'DP_jirb');
     //       ( )
     if ($id<=0)
     {
      $this->host = 'http://127.0.0.1/index.php';
      $this->port = 80;
      $this->login = '';
      $this->pw = '';
      $this->db='IBIS';
      $this->timeout=120;
      $this->remotecp='utf-8';
      $this->termpreg="|<td valign=\"CENTER\" width=\"10%\" ALIGN=RIGHT>(.*)&nbsp(.*)_S21STR=(.*)\"|U";
      $this->termpregcolrefs=1;
      $this->termpregcolterms=3;
      $this->mode=0;
      $this->fmt='allweb';
      $this->IsConnected = false;
     }
    }
  
    function SetOwnerProvider($id)
    {
     $this->opid=$id;
    }

    private function exception($errcode)
    {
      return $errcode;
    }

    private function ExecRqst($params)
    {
     $ch = curl_init();
     if(!isset($params['Z21ID'])) $params['Z21ID']=$this->z21id;
     $params['Itemid']='320';
     $params['option']=$this->option;
     $pf=http_build_query($params);
     trigger_error('DP_jirb: (pf): '.$pf, E_USER_NOTICE);
     if ($this->mode==1)
      curl_setopt($ch,CURLOPT_URL,$this->host); 
     else
      curl_setopt($ch,CURLOPT_URL,$this->host.'?'.$pf); 
     curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $this->timeout);
     curl_setopt($ch,CURLOPT_PORT,$this->port);
     if ($this->mode==1)
      curl_setopt($ch, CURLOPT_POST, 1);
     curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
     curl_setopt($ch, CURLOPT_FAILONERROR, 1);
     curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
     //curl_setopt($ch, CURLOPT_HEADER, 0);
     if ($this->mode==1)
      curl_setopt($ch,CURLOPT_POSTFIELDS,$pf);
     $res=curl_exec($ch);
//     trigger_error('DP_jirb: (res): '.$res, E_USER_NOTICE);
     $er=curl_errno($ch);
     if ($er != 0)
     {
      trigger_error('DP_jirb: ('.$this->host.'): '.curl_error($ch)."\n".$pf, E_USER_NOTICE);
      curl_close($ch);
      return $this->exception($er); 
     }
     curl_close($ch);
     return $res;
    }

    private function ConvertExpression($Expression,$isencode=true)
    {
     if ($isencode)
      return str_replace('"','<.>',$Expression);
    } 
   
    function Connect($params)
    {
     if ($this->IsConnected) return 0;
     $this->SetOwnerDb($params['dbid']);
     $odp=new DP($this->odpi);
      // read parameters
     $ini=$params['Ini'];
     $this->host = $ini->GetValue('PROVIDER','HOST','http://127.0.0.1/cgi-bin/irbis64r_71/cgiirbis_64.exe');
     $this->port = $ini->GetValue('PROVIDER','PORT',80);
     $this->login = $ini->GetValue('PROVIDER','LOGIN','');
     $this->pw = $ini->GetValue('PROVIDER','PW','');
     $this->db=$ini->GetValue('PROVIDER','DB','IBIS');
     $this->timeout=$ini->GetValue('PROVIDER','TIMEOUT',120);
     $this->remotecp=$ini->GetValue('PROVIDER','REMOTECP','utf-8');
     $this->termpreg=$ini->GetValue('PROVIDER','TERMPREG',"|<td valign=\"CENTER\" width=\"10%\" ALIGN=RIGHT>(.*)&nbsp(.*)_S21STR=(.*)\"|U");
     $this->termpregcolrefs=$ini->GetValue('PROVIDER','TERMPREGCOLREFS',1);
     $this->termpregcolterms=$ini->GetValue('PROVIDER','TERMPREGCOLTERMS',3);
     $this->mode=$ini->GetValue('PROVIDER','MODE',0);
     $this->fmt=$ini->GetValue('PROVIDER','FMT','allweb');
     $this->Itemid=$ini->GetValue('PROVIDER','ITEMID','320');
     $this->option=$ini->GetValue('PROVIDER','OPTION','com_irbis');
     $this->IsConnected = false;
     
     if (($this->pw=='')||($this->z21id!=''))
     {
      $this->IsConnected=1;
      return 0;
     }
     //   
     //    
     if ($this->login=='')
     {
      $this->z21id=$this->pw;
      return 0;
     }
     //      -      id -   
     $p['C21COM']='F';
     $p['Z21FLAGID']='1';
     $p['Z21FAMILY']=iconv('utf-8',$this->remotecp,$this->login);
     $p['Z21ID']=iconv('utf-8',$this->remotecp,$this->pw);
     $r=$this->ExecRqst($p);
     if ($r<0) return $r;
     $r1=strstr('&Z21ID=',$r);
     $r1+=7;
     $id='';
     while (($r1<$l)&&($r{$r1}>'0')&&($r{$r1}<'9'))
     {
      $id.=$r{$r1};
      $r1++;
     }
     $this->z21id=$id;
     $this->IsConnected=1;
     return 0;
    }

    function Disconnect($sysconn)
    {
        $this->IsConnected = false;
    }

    function GetFile($nApath,$Adbn,$FileName)
    {
     $odp=new DP($this->odpi);
     return $odp->GetFile($nApath,$Adbn,$FileName);
    }

    function GetFormattedRecordsAfterSearch($DbName, $Expression, $Format, $NumRecords =
        0, $FirstRecord = 0, $Min = 0, $Max = 0, $Sequence = '')
    {
        return -9999; // NA
    }

    function GetMaxMfn($DbName)
    {
        return -9999; // NA
    }

    function NoOperation()
    {
        return 0;
    }

    function RecIfUpdate($DbName, $mfn)
    {
        return -9999; // 
    }

    function RecRead($DbName, $mfn, $bLock,Record $rec)
    {
      $r = $this->Search($DbName,'("I='.$mfn.'")', '', "&uf('+0')", 1, 1);

      if (!is_array($r)) return $r;
      if ($r[0] < 1) return $r[0];
      if ($r[1] != '')
      {
	$rec->ParseIrbisRec($r[1]);
      }
      return $rec->GetId();
    }

    function RecReadAndFormat($DbName, $mfn, $bLock, $Format)
    {
        if ($Format=='@') $Format="&uf('6kn_h')";
        $r1=$this->Search($DbName,"(\"I=".$mfn."\")",'',$Format,1,1);
        return $r1[1];
    }

    function RecVirtualFormat($DbName, $Format, Record $VirtualRecord)
    {
     $odp=new DP($this->odpi);
     return $odp->RecVirtualFormat($DbName, $Format, $VirtualRecord);
     //   64
    }

    function RecWrite($DbName, $bLock, $bIfUpdate, Record $VirtualRecord)
    {
//        if (($er=$this->Connect($sysconn))<0) return $er;
        return -9999;
    }

    function Search($DbName, $Expression, $Sequence, $Format, $NumMfn = 0, $FirstMfn =
        0, $Min = 0, $Max = 0,$IsExt=false)
    {
     $p=array();
     trigger_error('DP_jirb: ', E_USER_NOTICE);
     $p['C21COM']='S';
     $p['I21DBN']=$this->db;
     $p['P21DBN']=$this->db;
     $p['S21All']=$this->ConvertExpression(iconv('utf-8','windows-1251',$Expression));
     $p['S21FMT']=$this->fmt;
     $p['Z21ID']=$this->z21id;
     //$p['S21REF']=2;
     if ($NumMfn>0)
       $p['S21CNR']=$NumMfn;
     else
       $p['S21CNR']=1;
     if ($FirstMfn>0)
       $p['S21STN']=$FirstMfn;
     $r=$this->ExecRqst($p);
     //echo $this->fmt;
     $recs=array();
     if ($this->fmt=='all_z') $recs=$this->parse_all_z($r,$Format,$DbName);
     else if ($this->fmt=='all') $recs=$this->parse_all($r,$Format,$DbName);
     else if ($this->fmt=='allweb') $recs=$this->parse_allweb($r,$Format,$DbName);
     //echo $r;
     //trigger_error('DP_jirb: '.var_export($recs,true), E_USER_NOTICE);
      //print_r ($recs);
      return $recs;
    }

    function parse_all_z($r,$Format,$DbName)
    {
     $Format=str_replace('mfn','\'~~~~~mfn~~~~~\'',$Format);
     $odp=new DP($this->opid);
     $recs=array();
     $recs[0]=0;
     $ar=array();
     $preg="|<br>1014(.*)<br>1001|Us";
     preg_match_all($preg,$r,$ar,PREG_PATTERN_ORDER);
     if (is_array($ar[1])) foreach ($ar[1] as $k=>$zr)
     {
      if (trim($zr)!='')
      {       
       $zr=str_replace('<br>','',$zr);
       $zr=str_replace('<b>','',$zr);
       $zr=str_replace('</b>','',$zr);
       $zr=str_replace('<font color=red>','',$zr);
       $zr=str_replace('</font>','',$zr);
       $zr=str_replace('&nbsp;','',$zr);
       $rec=new Record(0);
       $fa=explode("\n",$zr);
       if (is_array($fa)) foreach ($fa as $k=>$fs)
       {
        if (($k>0)&&(trim($fs)!=''))
        {
         $fs1=explode(":",$fs);
//         if (is_array($fs1)) foreach ($fs1 as $fs2)
//         {
          $fnum=$fs1[0];
          $fdat=trim(ltrim(ltrim($fs,"0123456789"),":"));
          
          $rec->FieldAdd($fnum,$fdat);
//         }
        }
       }
       $recs[0]++;
       
       $nr=array();
       $nr['mfn']=addslashes($rec->GetField(903,1));
       if ($nr['mfn']=='""') $nr['mfn']="\"".addslashes($rec->GetField(1,1))."\"";
       if ($nr['mfn']=='""') $nr['mfn']="\"".$rec->mfn."\"";
//       trigger_error('DP_jirb: '.($nr['mfn']), E_USER_NOTICE);
//       $irbrec="0\r".str_replace("\r\n","\r",$rec->GetAsIrbRec());
       
       $nr['format']=$odp->RecVirtualFormat($DbName,$Format,$rec);
       $nr['format']=str_replace('~~~~~mfn~~~~~',$nr['mfn'],$nr['format']);
       trigger_error('DP_jirb: nr: '.var_export($nr,true), E_USER_NOTICE);
       if ($IsExt)
       {
        if (($NumMfn>count($recs)-1)||($NumMfn==0))
        $recs[]=$nr;
       } 
       else
        $recs[]=$nr['format'];
       $rec->Dispose($rec->GetId());
       //907:^C^A20110105^B
      }
     }
//     trigger_error('DP_jirb: '.var_export($recs,true), E_USER_NOTICE);
     return $recs;
    }


       function RecSearch($DbName, $Expression, $Sequence, $NumMfn = 0, $FirstMfn = 0)
       {
    	$r = $this->Search($DbName,$Expression, $Sequence, "&uf('+0')", $NumMfn, $FirstMfn);
	if (!is_array($r)) return array(0=>$r);
	if ($r[0] < 1) return array(0=>$r[0]);
	$res = array(0=>0);
	foreach ($r as $key => $m)
	{
	 if ($key == 0) $res[0] = $m;
	 else
	 {
	  if ($m != '')
	  {
	   $rr = new Record(0);
	   $rr->ParseIrbisRec($m);
	   $res[] = $rr;
	  }
	 }
	}
	return $res;
       }


    function parse_all($r,$Format,$DbName)
    {
     $recs=array();
     $recs[0]=0;
     $t=explode('{',$r);
     $odp=new DP($this->opid);
     $Format=str_replace('mfn','\'~~~~~mfn~~~~~\'',$Format);
     foreach($t as $string)
     {
      $rec=new Record(0);
      $string=explode('}',$string);
      $rec_string=explode('\par \b ',$string[0]);
      if (is_numeric($rec_string[0]))
      {
       $rec->SetMfn((int)$rec_string[0]);
       //trigger_error('DP_jirb: '.$rec->GetMfn(), E_USER_NOTICE);
       for($i=0;$i<count($rec_string);$i++)
       {                           
        if (preg_match('{#(\d+).+? (.+)}',$rec_string[$i],$fields))
        {           
         $field_value=trim(preg_replace('{<[^>]+>}','',$fields[2]));
         if ($fields[1]==1001)
          $recs[0]=trim($field_value,'\par ');
         if ($fields[1]<1000)
           $rec->FieldAdd($fields[1],$field_value);
         }                                               
        }
        $nr=array();
        $nr['mfn']=addslashes($rec->GetField(903,1));
        if ($nr['mfn']=='""') $nr['mfn']="\"".addslashes($rec->GetField(1,1))."\"";
        if ($nr['mfn']=='""') $nr['mfn']="\"".$rec->mfn."\"";
//        trigger_error('DP_jirb: '.($nr['mfn']), E_USER_NOTICE);
//        $irbrec="0\r".str_replace("\r\n","\r",$rec->GetAsIrbRec());
        
        $nr['format']=$odp->RecVirtualFormat($DbName,$Format,$rec);
        $nr['format']=str_replace('~~~~~mfn~~~~~',$nr['mfn'],$nr['format']);
        if ($IsExt)
        {
         if (($NumMfn>count($recs)-1)||($NumMfn==0))
         $recs[]=$nr;
        } 
        else
         $recs[]=$nr['format'];
       }
       $rec->Dispose($rec->GetId());
      }
      return $recs;
    }

    function parse_allweb($r,$Format,$DbName)
    {
     $recs=array();
     trigger_error('DP_jirb: (res): '.var_export($r,true), E_USER_NOTICE);
     
     $p=strpos($r,'<i>   </i> : <B>'); $r=substr($r,$p+50);
     $p=strpos($r,'</B>'); $totn=substr($r,0,$p);
     $recs[0]=$totn+0;
     $p=strpos($r,'<!--#############/SEARCH_RESULT##########################-->'); $r=substr($r,$p);
     $p=strpos($r,'<tbody>'); $r=substr($r,$p+7);
     $p=strpos($r,'<!--#######################FOOTER#####################################-->'); $r=substr($r,0,$p);

     $t=explode('<tr>',$r);
     $odp=new DP($this->opid);
     $Format=str_replace('mfn','\'~~~~~mfn~~~~~\'',$Format);
     foreach($t as $string)
     {
      $rec=new Record(0);
      $p=strpos($string,'<td width=90% colspan="3">'); $string=substr($string,$p+26);
      $p=strpos($string,'<hr noshade size="1">'); $string=substr($string,0,$p);
      $string=str_replace("\n",'',$string);
      $string=str_replace("\r",'',$string);
      $string=str_replace('<b><font color=red>','',$string);
      $string=str_replace('</font></b>','',$string);
      $string=str_replace('<br>','',$string);
      
      $fldsa=explode('',$string);
      $fc=count($fldsa);
      $tosave=false;
      for ($i=1;$i<$fc;$i++)
      {
       $f1=substr($fldsa[$i],4);
       $f1=str_replace('</b>','',$f1);
       $f1=explode('',$f1);
       //trigger_error('DP_jirb: (res): ['.$i.']'.var_export($f1,true), E_USER_NOTICE);
       $fldn=$f1[0]+0;
       $f1=substr($f1[1],2);
       
       $flds=trim($f1," \n\r");
       //trigger_error('DP_jirb: (res): '.$fldn.'['.$i.']'.var_export($flds,true), E_USER_NOTICE);
       if (($fldn>0)&&($flds!=''))
       {
        $rec->FieldAdd($fldn,iconv('windows-1251','utf-8',$flds));
        $tosave=true;
       }
      }
      if ($tosave)
      {
       $nr=array();
       $nr['mfn']=addslashes($rec->GetFieldA(903,1,'*'));
       if ($nr['mfn']=='""') $nr['mfn']="\"".addslashes($rec->GetField(1,1))."\"";
       if ($nr['mfn']=='""') $nr['mfn']="\"".$rec->mfn."\"";
        
       $nr['format']=$odp->RecVirtualFormat($DbName,$Format,$rec);
       $nr['format']=str_replace('~~~~~mfn~~~~~',$nr['mfn'],$nr['format']);
       if ($IsExt)
       {
        if (($NumMfn>count($recs)-1)||($NumMfn==0))
        $recs[]=$nr;
       } 
       else
        $recs[]=$nr['format'];
      }
      $rec->Dispose($rec->GetId());
     }
     return $recs;
    }

    function WriteToIni($IniText)
    {
     $odp=new DP($this->odpi);
     return $odp->WriteToIni($IniText);
     //   64
    }

    function GetTermList($DbName, $Pref, $StartTerm, $NumTerms, $isback=0,$format = '')
    {
     if ($isback!=0) return -9999; // NA
     $preg=$this->termpreg;
     $refscol=$this->termpregcolrefs;
     $termcol=$this->termpregcolterms;
     $p['C21COM']='T';
     $p['I21DBN']=$this->db.'_EX';
     $p['T21PRF']=$Pref;
     $p['T21TRM']=$StartTerm;
     $p['T21CNR']=$NumTerms;
     $p['Z21ID']=$this->z21id;
     $r=$this->ExecRqst($p);
     //trigger_error(var_export($r,true),E_USER_NOTICE);
     //print_r($r);
     if ($r<0) return $r;
     preg_match_all($preg,$r,$ar,PREG_PATTERN_ORDER);
     //trigger_error(var_export($ar,true),E_USER_NOTICE);
     $res=array();
     $i=0;
     while ((isset($ar[$refscol][$i]))&&(isset($ar[$termcol][$i])))
     {
      $res[]=array('key'=>urldecode($ar[$termcol][$i]),'refs'=>$ar[$refscol][$i]);
      $i++;
     }
     return $res;
    }

    function SetOwnerDb($id)
    {
     $this->odbi=$id;
    }
}
;
?>