<?php

require_once(dirname(__FILE__) . "/mnu.php");

class Fst128
{

 function _construct()
 {
 }

 function Fst(DB $db,Record $rIn,Record $rOut,$name,$params=array())
 {
  $fn=dirname(__FILE__).'/fst/';
  $fn.=($name.'.fst128');

  $cn='i128Fst_'.$fn;

  global $I128FST;
  if (isset($I128FST[$cn])) 
  {
   $c=$I128FST[$cn]; 
   $resf=$c->Fst($db,$rIn,$rOut,$params);
   return $resf;
  }
  
  if (file_exists($fn.'.user'))
  {
   require_once($fn.'.user');
  }
  else
  {
   if(file_exists($fn))
   {
    require_once($fn);
   }
   else
   {
    return NULL;
   }
  }
  $fc=new $cn;
  $I128FST[$cn]=$fc;
  $resf=$fc->Fst($db,$rIn,$rOut,$params);
  return $resf;
 }
};


?>