<?php 

require_once(dirname(__FILE__) . '/OM.php');
require_once(dirname(__FILE__) . '/DB.php');
require_once(dirname(__FILE__) . '/Record.php');

define('INLINECATALLOW',true);

class InlineCat extends OM
{

/*
  irbRec - record id for inline cat
  srcfmt - format wich build search expression from record
  maxdeep - max deep of records to compose result
  dbs - array of database info for inline cat

  each dbs elements consists from:
   id - database id
   autofst - fst which automatically applied to record from this db
   autogbl - gbl wich automatically apllied to record from this db

*/

///////////////////////////////////////

 function InlineCat($id=0)
 {
  $this->OM($id,'InlineCat');
 }

 function Update($r,$dbid=0)
 {
  require_once(dirname(__FILE__) . '/DB.php');

  //trigger_error('inline dbid: '.$dbid,E_USER_NOTICE);
  $irbDb=0;
  if ($irbDb<=0) $irbDb=$dbid;
  if ($irbDb<=0) return; //no db = no inlincat
 // $irbDb=6;
  //trigger_error('inline dbid: '.$irbDb,E_USER_NOTICE);
  $ri=new Record($this->inlineRec);
  $this->inlineRec=$ri->GetId();
  if ($irbDb>0)
  {
   $db=new DB($irbDb);
   $Expression='';
   $v920=$r->GetField(920,1);
   if ($r->GetSubField(10,1,'A')!='') $Expression.='("B='.$r->GetSubField(10,1,'A').'")';
//    if ($r->GetSubField(700,1,'A')!='') $Expression.='*("A='.$r->GetSubField(700,1,'A').'")';
//    if ($r->GetSubField(200,1,'A')!='') $Expression.='*("T='.$r->GetSubField(200,1,'A').'")';
   $Expression=trim($Expression,'*');
   if (($Expression!='')&&($this->LastExpr!=$Expression))
   {
    $ri->Clear();
    $this->LastExpr=$Expression;
    $sres=$db->FindRecords($Expression,'',10,1);
    //trigger_error('sres: '.var_export($sres,true),E_USER_NOTICE);
//    if ($sres[0]>0) trigger_error('sres[1]: '.var_export($sres[1]->rDump(),true),E_USER_NOTICE);
    //print_r($sres[1]->Content);
    //$db->RecRead(1, false, $ri);
    $c=$ri->Content;
    for ($i=1;$i<count($sres);$i++)
    {
     $c1=$sres[$i]->Content;
     foreach ($c1 as $fn=>$f)
     {
      if(!isset($c[$fn]))
       $c[$fn]=$c1[$fn];
      else
      {
       foreach($f as $occ=>$fv)
        if(!isset($c[$fn][$occ])) $c[$fn][$occ]=$c1[$fn][$occ];
      }
     }
    }
    $ri->Content=$c;
   }
  }

 }

};

?>