<?php

require_once 'dirname(__FILE__).././classes/DB.php';
require_once 'dirname(__FILE__).././classes/Record.php';

function fmt_v($res, DB $db, Record $r, $field='',$occ='',$subfield='')
{
 if ($subfield!='')
 {
  if ($occ>0) 
  {
   $res.=$r->GetSubField($field, $occ, $subfield);
  }
  else 
  {
   $res.=$r->GetSubField($field, 1, $subfield);
  }
 }
 else 
 {
  if ($occ>0)
  {
   $res.=$r->GetField($field,$occ);
  }
  else $res.=$r->GetField($field,1);
 }
 return $res;
}

function fmt_rdrfio($res, DB $db, Record $r, $field='',$occ='',$subfield='')
{
 $family=$r->GetField(10,1);
 $fname=$r->GetField(11,1);
 $sname=$r->GetField(12,1);
 $res1=$family;
 if (($res1!='') && ($fname!='')) $res1.=' ';
 $res1.=$fname;
 if (($res1!='') && ($sname!='')) $res1.=' ';
 $res1.=$sname;
 $res.=$res1;
 return $res;
}

?>