<?php 

ini_set('session.gc_maxlifetime', 120960);
ini_set('session.cookie_lifetime', 120960);
@mkdir($_SERVER['DOCUMENT_ROOT'] .'/../sessions/');
ini_set('session.save_path', $_SERVER['DOCUMENT_ROOT'] .'/../sessions/');


require_once(dirname(__FILE__).'/../classes/ARM.php');
require_once(dirname(__FILE__).'/../classes/Ini.php');
require_once(dirname(__FILE__).'/../classes/DB.php');


//trigger_error('gateway: '.var_export($_REQUEST,true), E_USER_NOTICE);

global $OPTIONS;
$act=REQUEST('act');
$sesid=session_id();
$armid=REQUEST('armid');
$dbname=REQUEST('DbName');
$dbid=REQUEST('dbid');

function gateway_err($err)
{
 //die ('{"sesid":"'.$sesid.'","armid":"'.$armid.'","dbid":"'.$dbid.'","res":"'.$err.'"}');
 die(var_export(array('sesid'=>$sesid,'armid'=>$armid,'dbid'=>$dbid,'res'=>$err),true));
}

//trigger_error(var_export($_REQUEST,true),E_USER_NOTICE);

switch ($act)
{
 case 'Connect':
  //trigger_error(var_export($_REQUEST,true),E_USER_NOTICE);
  //if ($armid<=0) gateway_err(-2222);
  $arm=new ARM($armid);
  $res=$arm->Login('C',$OPTIONS['i64MasterHost'],$OPTIONS['i64MasterPort'],REQUEST('login'),REQUEST('pw'),true);
  if ($res!=0) gateway_err($res);
  if ($arm->IsLogged)
  {
   $ini = new Ini($arm->Ini);
   //$dbid = $arm->GetDbIdByName($ini->GetValue('MAIN', 'DEFAULTDB','IBIS'));
   $dbid = $arm->GetDbIdByName(REQUEST('DbName'));
   $db = new DB($dbid);
   $db->Open($arm->Ini);
   echo var_export(array('sesid'=>$sesid,'armid'=>$arm->GetId(),'dbid'=>$dbid,'res'=>0,'i128ver'=>$OPTIONS['ver']),true);
   //echo '{"sesid":"'.$sesid.'","armid":'.$arm->GetId().',"dbid":'.$dbid.',"res":0}';
   //trigger_error('{"sesid":"'.$sesid.'","armid":'.$arm->GetId().',"dbid":'.$dbid.',"res":0}',E_USER_NOTICE);
  }
  else
  {
   echo var_export(array('sesid'=>'','armid'=>0,'dbid'=>0,'res'=>-400),true);
   //echo '{"sesid":"","armid":0,"dbid":0,"res":-400}';
   //trigger_error('{"sesid":"","armid":0,"dbid":0,"res":-400}',E_USER_NOTICE);
  }
  break;

 case 'Disconnect':
  if ($armid<=0) gateway_err(-2222);
  $arm=new ARM($armid);
  $arm->Logout();
  echo var_export(array('res'=>0),true);
  //echo '{"res":0}';
  break;

 case 'GetFile':
  if ($dbid<=0) gateway_err(-2222);
  $db=new DB($dbid);
  //$dpid=$db->GetProvider();
  //$dp=new DP($dpid);
  //$r=$dp->GetFile(REQUEST('nApath'),stripslashes(REQUEST('Adbn')),stripslashes(REQUEST('FileName')));
  $r=$db->GetFile(REQUEST('nApath'),stripslashes(REQUEST('FileName')));
  //echo '{"res":'.json_encode(iconv('windows-1251','utf-8',$r)).'}';
  var_export(array('res'=>iconv('windows-1251','utf-8',$r)));
  //echo '{"res":"'.addslashes($r).'"}';
  break;

 case 'GetFormattedRecordsAfterSearch':
  if ($dbid<=0) gateway_err(-2222);
  $db=new DB($dbid);
  $dpid=$db->GetProvider();
  $dp=new DP($dpid);
  $r=$dp->GetFormattedRecordsAfterSearch(REQUEST('DbName'),stripslashes(REQUEST('Expression')),stripslashes(REQUEST('Format')),REQUEST('NumRecords'),REQUEST('FirstRecord'),REQUEST('Min'),REQUEST('Max'),stripslashes(REQUEST('Sequence')));
  var_export(array('res'=>$r));
  //echo '{"res":'.json_encode($r).'}';
  break;

 case 'GetMaxMfn':
  if ($dbid<=0) gateway_err(-2222);
  $db=new DB($dbid);
  var_export(array('res'=>$db->GetMaxMfn()));
  //echo '{"res":".addslashes($db->GetMaxMfn())."}';
  break;

 case 'NoOperation':
  if ($armid<=0) gateway_err(-2222);
  $arm=new ARM($armid);
  $arm->Noop();
  var_export(array('res'=>0));
  //echo '{"res":0}';
  break;

 case 'RecIfUpdate':
  if ($dbid<=0) gateway_err(-2222);
  $db=new DB($dbid);
  $r=$db->RecIfUpdate(REQUEST('mfn'));
  var_export(array('res'=>$r));
  echo '{"res":"'.addslashes($r).'"}';
  break;

 case 'RecSearch':
  if ($dbid<=0) gateway_err(-2222);
  $db=new DB($dbid);
  $dpid=$db->GetProvider();
  $dp=new DP($dpid);
  $r=$dp->RecSearch(REQUEST('DbName'),stripslashes(REQUEST('Expression')),stripslashes(REQUEST('Sequence')),REQUEST('NumMfn'),REQUEST('FirstMfn'));
  $r1[0]=$r[0];
  for($i=1;$i<count($r);$i++)
  {
   $r1[$i]=$r[$i]->GetAsArray();
  }
  var_export(array('res'=>$r1));
  break;

 case 'RecRead':
  if ($dbid<=0) gateway_err(-2222);
  $db=new DB($dbid);
  $dpid=$db->GetProvider();
  $dp=new DP($dpid);
  $r=new Record(0);
  $r1=$dp->RecRead(REQUEST('DbName'),stripslashes(REQUEST('mfn')),stripslashes(REQUEST('bLock')),$r);
  //trigger_error('gateway RecRead: '.var_export($r->rDump(),true),E_USER_NOTICE);
  if ($r1!=0) var_export(array('res'=>$r1));
  else var_export(array('res'=>$r->GetAsArray()));
  //if ($r1!=0) echo '{"res":'.json_encode($r1).'}';
  //else echo '{"res":'.json_encode($r->Content).'}';
  $r->Dispose($r->GetId());
  break;

 case 'RecReadAndFormat':
  if ($dbid<=0) gateway_err(-2222);
  $db=new DB($dbid);
  $dpid=$db->GetProvider();
  $dp=new DP($dpid);
  $r=$dp->RecReadAndFormat(REQUEST('DbName'),stripslashes(REQUEST('mfn')),stripslashes(REQUEST('block')),stripslashes(REQUEST('Format')));
  var_export(array('res'=>$r));
  //echo '{"res":'.json_encode($r).'}';
  break;

 case 'RecVirtualFormat':
  if ($dbid<=0) gateway_err(-2222);
  $db=new DB($dbid);
  $dpid=$db->GetProvider();
  $dp=new DP($dpid);
  $vr=new Record(0);
  //$vr->ParseIrbisRec(stripslashes(REQUEST('VirtualRecord')));
  $ar='';
  if (REQUEST('VirtualRecord')!='') eval('$ar='.stripslashes(REQUEST('VirtualRecord')).';');
  if (is_array($ar))
  {
   $vr->SetFromArray($ar);
   $r=$dp->RecVirtualFormat(REQUEST('DbName'),stripslashes(REQUEST('Format')),$vr);
   var_export(array('res'=>array('res'=>$r,'VirtualRecord'=>$vr->GetAsArray())));
   //echo '{"res":'.json_encode($r).'}';
   $vr->Dispose($vr->GetId());
   //echo '{"res":"'.addslashes($r).'"}';
  }

  break;

 case 'RecWrite': // NA for sequrity reasons
  if ($dbid<=0) gateway_err(-2222);
  $db=new DB($dbid);
  $dpid=$db->GetProvider();
  $dp=new DP($dpid);
  $vr=new Record(0);
  $ar='';
  if (REQUEST('VirtualRecord')!='') eval('$ar='.stripslashes(REQUEST('VirtualRecord')).';');
  if (is_array($ar))
  {
   $vr->SetFromArray($ar);
   //$rcode=$db->SaveAndUpdateRecord($vr);
   $rcode=$dp->RecWrite(REQUEST('DbName'), REQUEST('bLock'), REQUEST('bIfUpdate'), $vr);
   var_export(array('res'=>array('res'=>$rcode,'VirtualRecord'=>$vr->GetAsArray())));
   $vr->Dispose($vr->GetId());
   //var_export(array('sesid'=>$sesid,'res'=>$rcode));
   //echo '{"sesid":"'.$sesid.'","res":"'.$rcode.'"}';
  }
  break;

 case 'Search':
  if ($dbid<=0) gateway_err(-2222);
  $db=new DB($dbid);
  $dpid=$db->GetProvider();
  $dp=new DP($dpid);
  $r=$dp->Search(REQUEST('DbName'),stripslashes(REQUEST('Expression')),stripslashes(REQUEST('Sequence')),stripslashes(REQUEST('Format')),REQUEST('NumMfn'),REQUEST('FirstMfn'),REQUEST('Min'),REQUEST('Max'),REQUEST('IsExt'));
  var_export(array('res'=>$r));
  //echo '{"res":'.json_encode($r).'}';
  break;

 case 'GetTermList':
  if ($dbid<=0) gateway_err(-2222);
  $db=new DB($dbid);
  $dpid=$db->GetProvider();
  $dp=new DP($dpid);
  $r=$dp->GetTermList(REQUEST('DbName'),REQUEST('Pref'),REQUEST('StartTerm'),REQUEST('NumTerms'),REQUEST('isback'),REQUEST('format'));
  var_export(array('res'=>$r));
  //echo '{"res":'.json_encode($r).'}';
  break;

 default:
  gateway_err(-2222);
}


?>