<?php 

require_once(dirname(__FILE__).'/../classes/ARM.php');
require_once(dirname(__FILE__).'/../classes/DB.php');
require_once(dirname(__FILE__).'/../classes/Record.php');

class stat
{
 
 var $fresc;

 function stat()
 {
  $this->fresc=array();
 }

 function ApplyVal(&$fres,&$colinfo,$row,$col,$val)
 {
  $operation=$colinfo['operation'];
  $elm=&$fres[$row][$col];
  if ($colinfo['type']=='multy')
  {
   $colinfo['subcols'][$col]='1';
   $elm=&$fres[$row][$colinfo['name']][$col];
  }
  switch($operation)
  {
   case 'sum': $elm['data']+=$val; break;
   case 'count': $elm['data']++; break;
   case 'avg': $elm['sum']+=$val; $elm['cnt']++; $elm['data']=$elm['sum']/$elm['cnt']; break;
   case 'min': if ($elm['data']=='') $elm['data']=$val; else $elm['data']=min($elm['data'],$val);
   case 'max': if ($elm['data']=='') $elm['data']=$val; else $elm['data']=max($elm['data'],$val);
   case 'concatenate': $elm['data'].=$val; break;
   default: $elm['data']=$val;
  }
 }

 function GetAsHtmlTable($arr,$cols)
 {
//  print_r($cols);
  $res='<table border="1"><tr>';
  foreach ($cols as $colinfo)
  {
   if ($colinfo['type']=='multy')
   {
    if (is_array($colinfo['subcols'])) foreach($colinfo['subcols'] as $colname=>$coldata)
    {
     $res.='<td>'.$colname.'</td>';
    }
   }
   else
   {
    $res.='<td>'.$colinfo['name'].'</td>';
   }
  }
  $res.='</td>';
  foreach($arr as $row)
  {
   $res.='<tr>';
   foreach ($cols as $colinfo)
   {
    if ($colinfo['type']=='multy')
    {
     if (is_array($colinfo['subcols'])) foreach($colinfo['subcols'] as $colname=>$coldata)
     {
      $res.='<td>'.$row[$colinfo['name']][$colname]['data'].'</td>';
     }
    }
    else
     $res.='<td>'.$row[$colinfo['name']]['data'].'</td>';
   }
   $res.='</tr>';
  }
  $res.='</table>';
  return $res;
 }

 function CreateStat($db,$rowtype,array &$cols,$Src,$Posl,array $params=array())
 {
/*
cols:array(
'type' => internal column type. may be: 'record', 'const', 'counter'
'func' => stat function name
'value' => const value of column. May be changed for each row
'name'=> column name (if const)
)
*/
  require_once (dirname(__FILE__) . "/Record.stt");
  require_once (dirname(__FILE__) . "/".$rowtype.".stt");
  $portion=100;
  $classname='stt_'.$rowtype;
  $scls=new $classname();
  $rcls=new stt_Record;
  set_time_limit(36000);
  $recs=$db->FindRecords($Src,$Posl,1,1);
  $res=array();
  if (!is_array($recs)) {return $recs;}
  if ($recs[0]<0) {return $recs[0];}
  $tcount=$recs[0];
  $fres=array();
  $fresc=array();
  for ($i=0;$i*$portion<$tcount;$i++)
  {
   $recs=array();
   $recs=$db->FindRecords($Src,$Posl,$portion,$i*$portion+1);
   if (!is_array($recs)) {return $recs;}
   if ($recs[0]<0) {return $recs[0];}
   for ($j=1;$j<count($recs);$j++)
   {
    foreach ($cols as $key=>&$colinfo)
    {
     $tres=array();
     if ($colinfo['type']!='record') 
     {
      if ($scls->$colinfo['func']($db,$recs[$j],$tres,$this,$colinfo,$params))
      {
       foreach($tres as $row=>$resi)
       {
        foreach($resi as $col=>$vals)
        {
         if (is_array($vals)) foreach ($vals as $val) 
         {
          $this->ApplyVal($fres,$colinfo,$row,$col,$val);
         }
        }
       }
      }
     }
    }
    // const in record
    foreach ($cols as $key=>&$colinfo)
    {
     if ($colinfo['type']=='record') 
     {
      $colinfo['value']=$rcls->$colinfo['func']($db,$recs[$j],$fres,$this,$colinfo,$params);
      foreach($tres as $row=>$resi)
      {
       foreach($colinfo['value'] as $val)
        $this->ApplyVal($fres,$colinfo,$row,$colinfo['name'],$val);
      }
     }
    }
   }
   $db->FindRecordsClearResult($recs);
  }
//  print_r($scls);
  return $fres;
 }
};

//$MODULES['OmSTU']=new OmSTU();
?>