<?php

require_once(dirname(__FILE__).'/../classes/OM.php');
require_once(dirname(__FILE__).'/../classes/LongTask.php');
require_once(dirname(__FILE__).'/../classes/ARM.php');
require_once(dirname(__FILE__).'/../classes/DB.php');
require_once(dirname(__FILE__).'/../classes/Record.php');

class ButtonManagerPreselected
{
 var $action;
 var $armid;
 var $container;
 var $codepage;
 var $curcount;
 var $dbid;
 var $dbtoname;
 var $filename;
 var $fstname;
 var $guid;
 var $mfn;
 var $pft;
 var $recid;
 var $sequence;
 var $src;
 var $task;
 var $totcount;

 function __construct()
 {
  $this->ActionSetEmpty();
  $this->armid=$_REQUEST['irbArm'];
  $this->codepage=$_REQUEST['codepage'];
  $this->container=$_REQUEST['container'];
  $this->curcount=0;
  $this->dbid=$_REQUEST['irbDb'];
  $this->dbtoname=$_REQUEST['Name'];
  $this->filename=$_REQUEST['fpath'];
  $this->fstname=$_REQUEST['key'];
  $this->guid=$_REQUEST['guid'];
  $this->mfn=$_REQUEST['mfn'];
  if (!is_array($this->mfn))
  {
   if ($this->mfn!='') $this->mfn=array(0=>$this->mfn);
   else $this->mfn=array();
  }
  $this->oper=$_REQUEST['oper'];
  $this->pft=$_REQUEST['pft'];
  $this->recid=$_REQUEST['irbRec'];
  $this->sequence=stripslashes($_REQUEST['sequence']);
  $this->src=stripslashes($_REQUEST['src']);
  $this->totcount=0;
 }

  function ActionSetEmpty() { $this->action="Ext.Msg.alert('Готово','Операция выполнена');"; }
  function ActionSetNewWindow($scripturl,$windowtitle) { $this->action="window.open('".$scripturl."?action=printres&guid=".$this->GetGuid()."','".$windowtitle."','width=600,height=400,top=10,left=10,toolbar=1,location=0,menubar=1,scrollbars=1,resizable=1');";}
  function ActionSetReload($title='',$msg='') { $this->action="a.RecListPanel.Reload();"; if ($msg!='') $this->action.="Ext.Msg.alert('$title','$msg');";}
  function ActionSetLoadFile($scripturl) { $this->action="ifr=document.getElementById('irbisWorkIFrame'); ifr.src='".$scripturl."?action=printres&guid=".$this->GetGuid()."';";}
  function GetAction() {return $this->action;}
  function GetArm() { if ($this->armid<1) return NULL; $arm=new ARM($this->armid); return $arm; }
  function GetContainer() { return $this->container; }
  function GetCodepage() {return $this->codepage; }
  function GetCurCount() { return $this->curcountcnt; }
  function SetCurCount($cnt) { $this->curcountcnt=$cnt; }
  function StepCount() { $this->curcountcnt++; }
  function GetTotCount() { return $this->totcount; }
  function SetTotCount($val) { $this->totcount=$val; }
  function GetDb() { if ($this->dbid<1) return NULL; $db=new DB($this->dbid); return $db; }
  function GetDbTo() { if ($this->dbtoname=='') return NULL; $arm=$this->GetArm(); if ($arm===NULL) return NULL; $dbid=$arm->GetDbIdByName($this->dbtoname); if ($dbid<1) return NULL; $db=new DB($dbid); return $db; }
  function GetFileName() {if ($this->filename=='') return ''; global $OPTIONS; $dir=$OPTIONS['DataPath'].'/Temp'; @mkdir($dir,0777,true); return $dir.'/'.$this->filename;}
  function GetFstName() {return $this->fstname;}
  function GetGuid() { return $this->guid; }
  function GetMfn() { return $this->mfn; }
  function GetOper() { return $this->oper; }
  function GetPft() { return $this->pft; }
  function GetResScript() { return $this->resscript; }
  function GetResTitle() { return $this->restitle; }
  function GetSrc() { return $this->src; }
  function GetSequence() { return $this->sequence; }
  function GetRec() { if ($this->recid<1) return NULL; $rec=new Record($this->recid); return $rec; }
  function UpdateTask() { $this->task->Update($this->GetCurCount()/$this->GetTotCount(),$this->GetProgressMessage());}
  //----------------- user functions
  function GetProgressMessage() {return $this->GetCurCount().' из '.$this->GetTotCount().' ('.sprintf('%d',100*$this->GetCurCount()/$this->GetTotCount()).'%) записей обработано';}

  function Start(&$res) { return TRUE; }
  function End(&$res) { return TRUE; }
  function DoWork($db,$r,&$res) { }
  function GetResult($res){}

  function Run()
  {

   if (isset($_FILES['filpath']))
   {
    global $OPTIONS;
    @mkdir($OPTIONS['DataPath'].'/Temp');
    $fname=pathinfo($_FILES['filpath']['tmp_name']);
    $fname=$fname['basename'];
    if (!move_uploaded_file($_FILES['filpath']['tmp_name'], $OPTIONS['DataPath'].'/Temp/'.$fname)) 
    {
     echo '{success:true, file:"",errormsg:""}'; //$_FILES['filepath']['name']
     return;
    }
    echo '{success:true, file:"'.addslashes($fname).'"}';
    return;
   }

   $recportion=500;
   $this->task=new LongTask($this->GetGuid());

   if ($_REQUEST['action']=='printres')
   {
    $this->GetResult($this->task->GetData('result'));
    $this->task->Destroy();
    return;
   }

   $res='';

   $this->task->Start();
   set_time_limit(36000);
   
   if (!$this->Start($res))
   {
    if ($this->GetFileName()!='') @unlink($this->GetFileName());
    $this->task->SetData('result',$res);
    $this->task->Done($this->GetAction());
    return FALSE;
   }

   // create recordset

   $rs=array(0=>0);
   $this->SetTotCount(0);
   $db=$this->GetDb();

   $this->task->Update(0,'Запуск обработки');

   if ($this->GetOper()=='selected')
   {
    $mfns=$this->GetMfn();
    $this->task->Update(0,'Чтение отмеченных записей');
    foreach ($mfns as $idx=>$mfn)
    {
     $r=new Record(0);
     $db->RecRead($mfn,false,$r);
     $rs[]=$r;
     $rs[0]++;
     $this->task->Update($idx/count($mfns),'Чтение отмеченных записей');
    }
    $this->SetTotCount($rs[0]);
   }
   else
   {
    if (($this->GetSrc()!='')||($this->GetSequence()!=''))
    {
     $this->task->Update(0,'Расчет количества записей');
     $rs=$db->FindRecords($this->GetSrc(),$this->GetSequence());
     $this->SetTotCount($rs[0]);
     $this->task->Update(0,'Загрузка первой порции записей');
     $rs=$db->FindRecords($this->GetSrc(),$this->GetSequence(),$recportion,1);
    }
   }

   $this->task->Update(0,'Запуск обработки');

   $this->SetCurCount(1);

   $rsp=0;
   //cycle by records
   while ($this->GetCurCount()<=$this->GetTotCount())
   {
    $rsc=1;
    while($rsc<count($rs))
    {
     if (!(($this->GetOper()=='unselected') && (in_array($rs[$rsc]->GetMfn(),$this->GetMfn()) ) ))
     {
      $this->DoWork($db,$rs[$rsc],$res);
      $this->task->Update($this->GetCurCount()/$this->GetTotCount(),$this->GetProgressMessage());
     }
     $rsc++;
     $this->StepCount();
    }
    if ( ($this->GetCurCount()<=$this->GetTotCount()) && ($this->GetOper()!='selected') )
    {
     $rsp++;
     $db->FindRecordsClearResult($rs);
     trigger_error('ButtonManagers: rsp='.$rsp.'; recportion='.$recportion.'; start='.($rsp*$recportion+1), E_USER_NOTICE);
     $rs=$db->FindRecords($this->GetSrc(),$this->GetSequence(),$recportion,$rsp*$recportion+1);
    }
   }
   $db->FindRecordsClearResult($rs);

   $this->End($res);

   //$action="Ext.Msg.alert('Готово','$this->totcount записей обработано');";

   if ($this->GetFileName()!='') @unlink($this->GetFileName());
   $this->task->SetData('result',$res);
   $this->task->Done($this->GetAction());

   return TRUE;
  }
}

?>