<?php
require_once(dirname(__FILE__).'/../classes/OM.php');
require_once(dirname(__FILE__).'/../classes/DB.php');
require_once(dirname(__FILE__).'/../classes/Ini.php');
require_once(dirname(__FILE__).'/../classes/DoMultyThreadedCommands.php');


function RecListPanel128_join(array &$rc1,array &$rc2)
{
 $rc=array(0=>$rc1[0]+$rc2[0]);
 $c=count($rc1); for ($i=1;$i<$c;$i++) $rc[]=$rc1[$i];
 $c=count($rc2); for ($i=1;$i<$c;$i++) $rc[]=$rc2[$i];
 return $rc;
}

if (REQUEST('op')=='GetSessionFull')
{
 $fmt=stripslashes(REQUEST('fmt'));
 if ($fmt=='') $fmt='@';
 $t=explode('/',REQUEST('mfn'));
 $bShowDbInfo=($t[0]{0}=='i');
 $DbInfo='';
 if ($bShowDbInfo)
 {
  $t[0]=substr($t[0],2);
 }
 $bShowDbInfo=true;
 //trigger_error('dbid: '.($t[0]+0),E_USER_NOTICE);
 $db=new DB($t[0]+0);
 $dbini=new Ini($db->Ini);
 $lib=$dbini->GetValue('MAIN','LIBNAME','');

 if ($bShowDbInfo)
 {
  $dbini=new Ini($db->Ini);
  $lib=iconv('windows-1251','utf-8',$dbini->GetValue('MAIN','LIBNAME',''));
  if ($lib=='') $lib=$OPTIONS['ORGNAME'];
  if ( ($db->Description!='') || ($lib!='') )
   $DbInfo.='База данных: ';
  if ($lib!='') $DbInfo.='<b>'.$lib.'</b>';
  if ( ($db->Description!='') && ($lib!='') )
   $DbInfo.=' / ';
  if ($db->Description!='')
   $DbInfo.=''.$db->Description;
  if ($DbInfo!='') $DbInfo.='<br>';
 }

 $mfn=$t[1];
 for ($i=2;$i<count($t);$i++)
  $mfn.='/'.$t[$i];
 $mfn=trim(stripslashes($mfn),'"');
 $res=$db->RecReadAndFormat($mfn, false, $fmt);
 if ($res=='') $res=' ';
 if ($res{0}=='{')
 {
  $res=substr($res,1,-1);
  $res=str_replace("\\b0",'</b>',$res);
  $res=str_replace("\\b",'<b>',$res);
  $res=str_replace("\\par",'<br/>',$res);
  $res=str_replace("\\tab",'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;',$res);
  $res='</>'.$res;
 }
 $res=$DbInfo.$res;
 die($res);
}

$dbid=json_decode(stripslashes($_REQUEST['db']))+0;
$src=stripslashes(REQUEST('src'));
$sequence=REQUEST('sequence');

$limit=REQUEST('limit');
if ($limit<=0) $limit=20;

$start=REQUEST('start');
if ($start<=0) $start=0;
$start++;

$cols=array();

if (REQUEST('cols')=='')
{
        $cols=json_decode("[{\"fmt\":\"brief\",\"dataIndex\":\"brief\",\"header\":\"Desc\"}]",true);
}
else
{
        $cols=json_decode(stripslashes(REQUEST('cols')),true);
}

$rc=array(0=>0);
$hitses=0;
$rc=array(0=>0);

$db='';
$dbs=array();


if (!is_array($dbid)) $dbid=array(0=>$dbid);

foreach ($dbid as $cdbid)
{
 if ($cdbid>0)
 {
  $db=new DB($cdbid);
  $dbs[$cdbid]=$db;
  if ((REQUEST('basketName')!='undefined') && ($src=='') && ($sequence==''))
  {
   require_once(dirname(__FILE__).'/../classes/ARM.php');
   $dbname=$db->GetName();
   $basket=$_SESSION['basket'][REQUEST('basketName')];
   if (!is_array($basket)) $basket=array();
   $th+=count($basket[$dbname]);
   $hitses+=$th;
   $rc[0]+=$th;
   for ($lf=$start;($lf<=$th)&&($lf<($start+$limit));$lf++)
   {
    $nr=new Record(0);
    $db->RecRead($basket[$dbname][$lf-1],false,$nr);
    $nr->dbid=$cdbid;
    $rc[]=$nr;
   }
  }
  else
  {
   if (!(($src=='') && ($sequence=='')))
   {
    $rc1=$db->FindRecords($src,$sequence,$limit,$start);
    $c=count($rc1); for ($i=1;$i<$c;$i++) $rc1[$i]->dbid=$cdbid;
    $rc=RecListPanel128_join($rc,$rc1);
   }
   $hitses=$rc[0];
   //echo $cdbid.'~'; print_r($rc);
  }
 }
}


// $rc contain records for output
// $hitses contain hitses number


if ((!is_array($rc)) || ($rc[0]<0)) die('{}');


$res='{totalCount:'.$hitses.', RecList:[';
for ($i=1;$i<count($rc);$i++)
{
 $r=$rc[$i];
 if ($i>1) $res.=',';
 $res.='{id:'.($i+$start-1).', mfn:"'.addslashes($r->GetMfn()).'", dbid:"'.$r->dbid.'", npp:'.($i+$start-1);
 foreach($cols as $col)
 {
  $res.=','.$col['dataIndex'].':"'.addslashes($dbs[$r->dbid]->Format128($r,$col['fmt'],$col['fmttype'])).'"';
 }
 $res.='}';
 $r->Dispose($r->GetId());
}

$flds="'id','mfn','dbid','npp'";
foreach($cols as $col) $flds.=",'".$col['dataIndex']."'";
$res.='],metaData:{root:"RecList",fields:['.$flds.'],totalProperty:"totalCount"}}';
echo $res;
?>