<?php

require_once(dirname(__FILE__).'/../classes/DB.php');
require_once(dirname(__FILE__).'/../classes/Record.php');

$dbid=REQUEST('irbDb');
$pft=REQUEST('pft'); // if emty - then default used
$recid=REQUEST('irbRec'); 


$db=new DB($dbid);


$rec=new Record($recid);

$c=$rec->Content;
unset($c['fldcount']);
$rec->Content=$c;

// check for default(@) fmt
if (($pft=='@')||($pft==''))
{
 require_once(dirname(__FILE__).'/../classes/opt.php');
 $pftoptid=$db->PftOpt;
 $pftopt=new opt($pftoptid);
 $pft='@'.$pftopt->GetOptValue($rec->GetSubField(920,1,'*'));
}



$res=$db->RecVirtualFormat($pft,$rec);

if ((is_numeric($res)) && ($res<0))
{
 require_once(dirname(__FILE__).'/../classes/ARM.php');
 $arm=new ARM($db->GetArmId());
 echo $arm->ParseError($res);
 return;
}

if ($res{0}=='{')
 {
  $res=substr($res,1,-1);
  $res=str_replace("\\b0",'</b>',$res);
  $res=str_replace("\\b",'<b>',$res);
  $res=str_replace("\\par",'<br/>',$res);
  $res=str_replace("\\tab",'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;',$res);
  $res='</>'.$res;
 }
/*echo '<pre>';
print_r($res);
echo '</pre>';*/
echo $res;

?>