<?php 

require_once(dirname(__FILE__).'/ButtonManagers.inc');

class rlbPrintRecs extends ButtonManagerPreselected
{

 function Start(&$res)
 {
  $this->ActionSetNewWindow('../vidget/rlbPrintRecs.php','');
  $this->rtfh="{\\rtf1\\ansi\\ansicpg1251\\deff0\\deflang1049{\\fonttbl{\\f0\\fnil\\fcharset204{\\*\\fname Arial;}Arial CYR;}} \\viewkind4\\uc1\\pard\\f0\\fs16 \\paperw11907 \\paperh16839 \\margl1701 \\margr850 \\margt1134 \\margb1134 \n";
  $this->isrtf=FALSE;
  return TRUE;
 }

 function DoWork($db,$r,&$res)
 {
  $res0=$db->RecReadAndFormat($r->GetMfn(),false,$this->GetPft());
  $r0=trim($res0);
  if ($r0{0}=='{')
  {
   $this->isrtf=true;
   if ($cnt==0) $res.=$rtfh;
   $res1=iconv('utf-8','windows-1251',$res0);
   $len=strlen($res1);
   $res2='';
   for ($i=0;$i<$len;$i++) if (ord($res1{$i})>127) $res2.="\\'".sprintf('%2x',ord($res1{$i})); else $res2.=$res1{$i};
   $res.=$res2;
   if ($r0{strlen($r0)-1}!='}') $res.=' } ';
   $res.=" { \\pard \\par \\par }\\par \n";
  }
  else $res.=$res0;
 }

 function End(&$res)
 {
  if ($this->isrtf)
  {
   $res=$this->rtfh.$res.' }';
   $this->ActionSetLoadFile('../vidget/rlbPrintRecs.php');
  }
 }

 function GetResult($res)
 {
  if ($res{0}=='{')
  {
   header ("Cache-Control: private");
   header ("Cache-Control: must-revalidate, post-check=0, pre-check=0");
   header ("Content-Type: application/rtf");
   header ("Content-Length: " . strlen($res));
   header ("Content-Disposition: attachment; filename=print.rtf");
  }
  else
  {
   header("Content-Type: text/html; charset=utf-8");
  }
  echo $res;
 }
}

$m=new rlbPrintRecs;
$m->Run();

?>