<?php 

require_once(dirname(__FILE__).'/ButtonManagers.inc');

class rlbManageRecs extends ButtonManagerPreselected
{
 var $params;
 var $ssname;
 var $basket;

 function Start(&$res)
 {
  if ($this->GetArm()===NULL) return FALSE;
  $this->params=$_REQUEST['params'];
  $this->ssname=$_REQUEST['key'];
  $fname=dirname(__FILE__).'/../classes/serialsearch/'.$this->ssname;
  if (file_exists($fname.'.user.serialsearch128')) $fname=$fname.'.user.serialsearch128';
  else if (file_exists($fname.'.serialsearch128')) $fname=$fname.'.serialsearch128';
  else return FALSE;
  require_once($fname);
  $classname='SerialSearch128_'.$this->ssname;
  $this->scls=new $classname();

  //$this->ActionSetNewWindow('../vidget/rlbSerialSearch.php','Последовательный поиск');

  return TRUE;
 }

 function DoWork($db,$r,&$res)
 {
  if ($this->scls->DoWork($db,$r,$res))
  {
   $res[]=$r->GetMfn();
   $this->basket[]=$r->GetMfn();
  }
 }

 function End(&$res)
 {
  $arm=$this->GetArm();
  //$arm->RecBasket=$this->basket;
  $basketName=$this->GenGuid();
  $_SESSION['basket'][$basketName][$this->GetDb()->GetName()]=$this->basket;
  $this->action="

  var p=a.RecListPanel;

  var RecListBasket=new Irbis.RecListPanelTab128({irbDb:p.irbDb,irbArm:p.irbArm,layout:'fit',basketName:'$basketName',GetLastSrc:function(){return '';},GetLastSeqence:function(){return '';}});

  if (typeof(p.userBaskets)=='undefined') p.userBaskets=[];
  p.userBaskets['$basketName']=RecListBasket;

  var basketbtncfg=
  {
   irbArm:p.irbArm,
   irbDb:p.irbDb,
   irbRec:p.irbRec,
   RecListPanel:RecListBasket
  };

  var rltbar=
  [
   {iconCls:'irb-clear',tooltip:p.basketClear,handler:function(){this.ModalRequest({irbDb:this.irbDb,irbArm:this.irbArm,action:'clear','mfn[]':this.userBaskets['$basketName'].GetSelectedMfns(),basketName:'$basketName'},'../vidget/basket128.php');},scope:p},
   {iconCls:'irb-basket-remove',tooltip:p.basketRemove,handler:function(){this.ModalRequest({irbDb:this.irbDb,irbArm:this.irbArm,action:'del','mfn[]':this.userBaskets['$basketName'].GetSelectedMfns(),basketName:'$basketName'},'../vidget/basket128.php');},scope:p},
   '-'
  ];
   
  if (p.showEditRec) rltbar.push(new Irbis.RecListPanel128.ModalButton(Ext.apply({iconCls:'irb-edit', tooltip:p.recEdit, url:'../vidget/rlbEditRec.php'},basketbtncfg)));
  if (p.showPrintRecs) rltbar.push(new Irbis.RecListPanel128.PreselectionButton(Ext.apply({iconCls:'irb-print', tooltip:p.recPrint, title:p.recPrint, url:'../vidget/rlbPrintRecs.php', showSrcDocSelector:true},basketbtncfg)));
  if (p.showCopyRecs) rltbar.push(new Irbis.RecListPanel128.PreselectionButton(Ext.apply({iconCls:'irb-copy', tooltip:p.recCopy, title:p.recCopy, url:'../vidget/rlbCopyRecToDb.php', showSrcDocSelector:true, showTVP:true, irbMnuNameByIniSection:'MAIN', irbMnuNameByIniParam:'COPYMNU',showExpDbSelector:true},basketbtncfg)));
  if (p.showDeleteRecs) rltbar.push(new Irbis.RecListPanel128.PreselectionButton(Ext.apply({iconCls:'irb-delete', tooltip:p.recRemove, title:p.recRemove, url:'../vidget/rlbDeleteRecs.php', showSrcDocSelector:true, confirmText:'Действительно удалить отмеченные записи?'},basketbtncfg)));
  if (p.showPft)
  {
   var basketPftSelector=new Irbis.PftSelector
   ({
     autoLoad:true,
     valueNotFoundText:'Оптимизированый',
     arm:p.irbArm,
     dbid:p.irbDb,
     xtype:'combo',
     allowBlank: false,
     editable: false,
     fieldLabel: 'БД',
     anchor: '100%',
     listeners:
     {
      select:function(combo,record,index)
      {
       var f=record.get('key');
       if (f=='@') this.RecListBasket.ChangeFullFmt(f); else this.RecListBasket.ChangeFullFmt('@'+f);
      },
      scope:p
     }
   });

   rltbar.push('-');
   rltbar.push(p.viewFormat+': ');
   rltbar.push(basketPftSelector);
   rltbar.push('->');
   rltbar.push({iconCls:'irb-basket',tooltip:p.basketAdd,handler:function(){Irbis.ModalRequest({irbDb:this.irbDb,irbArm:this.irbArm,action:'add','mfn[]':this.userBaskets['$basketName'].GetSelectedMfns(),basketName:this.basketName},'../vidget/basket128.php');},scope:p});

  }

  var tab=p.add
  ({
    title:p.titleSerialSearch,
    iconCls:'irb-serialsearch',
    layout:'fit',
    closable:true,
    active:true,

    m_recList:RecListBasket,
    tbar:rltbar,
    items:[RecListBasket],
    listeners:
    {
     activate:function(tab){tab.m_recList.Reload();}
    }
  });
  p.activate(tab);
  ";
  return TRUE;
 }

 function GetResult($res)
 {
  header("Content-Type: text/html; charset=utf-8");
  echo '<hr><pre>';
  print_r($res);
  echo '</pre>';
 }

 function GenGUID()
 {
  $rawid = strtoupper(md5(uniqid(rand(), true)));
  $workid = $rawid;

  $byte = hexdec( substr($workid,12,2) );
  $byte = $byte & hexdec('0f');
  $byte = $byte | hexdec('40');
  $workid = substr_replace($workid, strtoupper(dechex($byte)), 12, 2);

  $byte = hexdec( substr($workid,16,2) );
  $byte = $byte & hexdec('3f');
  $byte = $byte | hexdec('80');
  $workid = substr_replace($workid, strtoupper(dechex($byte)), 16, 2);


  $guid = substr($rawid, 0, 8).'-'
     .substr($rawid, 8, 4).'-'
     .substr($rawid,12, 4).'-'
     .substr($rawid,16, 4).'-'
     .substr($rawid,20,12);
  return $guid;
 }
}

$m=new rlbManageRecs;
$m->Run();

?>